/* -*-	Mode:C++; c-basic-offset:8; tab-width:8; indent-tabs-mode:t -*- */
/**************************************************************************************************
*IBM Public License Version 1.0 
*
*THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS IBM PUBLIC LICENSE ("AGREEMENT"). ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS AGREEMENT. 
*
*1. DEFINITIONS 
*
*"Contribution" means: 
*
*       a) in the case of International Business Machines Corporation ("IBM"), the Original Program, and 
*
*       b) in the case of each Contributor, 
*
*       i) changes to the Program, and
*
*       ii) additions to the Program;
*
*       where such changes and/or additions to the Program originate from and are distributed by that particular Contributor. A Contribution 'originates' from a Contributor if it
*       was added to the Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions do not include additions to the Program which: (i) are
*       separate modules of software distributed in conjunction with the Program under their own license agreement, and (ii) are not derivative works of the Program.
*
*  "Contributor" means IBM and any other entity that distributes the Program. 
*
*  "Licensed Patents " mean patent claims licensable by a Contributor which are necessarily infringed by the use or sale of its Contribution alone or when combined with the
*  Program. 
*
*  "Original Program" means the original version of the software accompanying this Agreement as released by IBM, including source code, object code and documentation, if
*  any. 
*
*  "Program" means the Original Program and Contributions. 
*
*  "Recipient" means anyone who receives the Program under this Agreement, including all Contributors. 
*
*  2. GRANT OF RIGHTS 
*
*       a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive, worldwide, royalty-free copyright license to reproduce, prepare
*       derivative works of, publicly display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, and such derivative works, in source code
*       and object code form.
*
*       b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive, worldwide, royalty-free patent license under Licensed Patents to
*       make, use, sell, offer to sell, import and otherwise transfer the Contribution of such Contributor, if any, in source code and object code form. This patent license shall
*       apply to the combination of the Contribution and the Program if, at the time the Contribution is added by the Contributor, such addition of the Contribution causes
*       such combination to be covered by the Licensed Patents. The patent license shall not apply to any other combinations which include the Contribution. No hardware per
*       se is licensed hereunder. 
*
*       c) Recipient understands that although each Contributor grants the licenses to its Contributions set forth herein, no assurances are provided by any Contributor that
*       the Program does not infringe the patent or other intellectual property rights of any other entity. Each Contributor disclaims any liability to Recipient for claims brought
*       by any other entity based on infringement of intellectual property rights or otherwise. As a condition to exercising the rights and licenses granted hereunder, each
*       Recipient hereby assumes sole responsibility to secure any other intellectual property rights needed, if any. For example, if a third party patent license is required to
*       allow Recipient to distribute the Program, it is Recipient's responsibility to acquire that license before distributing the Program.
*
*       d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its Contribution, if any, to grant the copyright license set forth in this
*       Agreement. 
*
*  3. REQUIREMENTS 
*
*  A Contributor may choose to distribute the Program in object code form under its own license agreement, provided that: 
*
*       a) it complies with the terms and conditions of this Agreement; and
*
*       b) its license agreement:
*
*       i) effectively disclaims on behalf of all Contributors all warranties and conditions, express and implied, including warranties or conditions of title and non-infringement,
*       and implied warranties or conditions of merchantability and fitness for a particular purpose; 
*
*       ii) effectively excludes on behalf of all Contributors all liability for damages, including direct, indirect, special, incidental and consequential damages, such as lost
*       profits; 
*
*       iii) states that any provisions which differ from this Agreement are offered by that Contributor alone and not by any other party; and
*
*       iv) states that source code for the Program is available from such Contributor, and informs licensees how to obtain it in a reasonable manner on or through a medium
*       customarily used for software exchange. 
*
*  When the Program is made available in source code form: 
*
*       a) it must be made available under this Agreement; and 
*
*       b) a copy of this Agreement must be included with each copy of the Program. 
*
*  Each Contributor must include the following in a conspicuous location in the Program: 
*
*       Copyright  2002 International Business Machines Corporation, 
*       Massachusetts Institute of Technology, and others. All Rights Reserved. 
*
*  In addition, each Contributor must identify itself as the originator of its Contribution, if any, in a manner that reasonably allows subsequent Recipients to identify the originator
*  of the Contribution. 
*
*  4. COMMERCIAL DISTRIBUTION 
*
*  Commercial distributors of software may accept certain responsibilities with respect to end users, business partners and the like. While this license is intended to facilitate the
*  commercial use of the Program, the Contributor who includes the Program in a commercial product offering should do so in a manner which does not create potential liability
*  for other Contributors. Therefore, if a Contributor includes the Program in a commercial product offering, such Contributor ("Commercial Contributor") hereby agrees to defend
*  and indemnify every other Contributor ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising from claims, lawsuits and other legal
*  actions brought by a third party against the Indemnified Contributor to the extent caused by the acts or omissions of such Commercial Contributor in connection with its
*  distribution of the Program in a commercial product offering. The obligations in this section do not apply to any claims or Losses relating to any actual or alleged intellectual
*  property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the Commercial Contributor in writing of such claim, and b) allow the Commercial
*  Contributor to control, and cooperate with the Commercial Contributor in, the defense and any related settlement negotiations. The Indemnified Contributor may participate in
*  any such claim at its own expense. 
*
*  For example, a Contributor might include the Program in a commercial product offering, Product X. That Contributor is then a Commercial Contributor. If that Commercial
*  Contributor then makes performance claims, or offers warranties related to Product X, those performance claims and warranties are such Commercial Contributor's
*  responsibility alone. Under this section, the Commercial Contributor would have to defend claims against the other Contributors related to those performance claims and
*  warranties, and if a court requires any other Contributor to pay any damages as a result, the Commercial Contributor must pay those damages. 
*
*  5. NO WARRANTY 
*
*  EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
*  KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT,
*  MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness of using and distributing the
*  Program and assumes all risks associated with its exercise of rights under this Agreement, including but not limited to the risks and costs of program errors, compliance with
*  applicable laws, damage to or loss of data, programs or equipment, and unavailability or interruption of operations. 
*
*  6. DISCLAIMER OF LIABILITY 
*
*  EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE ANY LIABILITY FOR ANY DIRECT,
*  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND
*  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
*  OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF ADVISED OF THE POSSIBILITY OF
*  SUCH DAMAGES. 
*
*  7. GENERAL 
*
*  If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not affect the validity or enforceability of the remainder of the terms of this
*  Agreement, and without further action by the parties hereto, such provision shall be reformed to the minimum extent necessary to make such provision valid and enforceable. 
*
*  If Recipient institutes patent litigation against a Contributor with respect to a patent applicable to software (including a cross-claim or counterclaim in a lawsuit), then any
*  patent licenses granted by that Contributor to such Recipient under this Agreement shall terminate as of the date such litigation is filed. In addition, If Recipient institutes
*  patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding combinations of the Program with other
*  software or hardware) infringes such Recipient's patent(s), then such Recipient's rights granted under Section 2(b) shall terminate as of the date such litigation is filed. 
*
*  All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the material terms or conditions of this Agreement and does not cure such failure in a
*  reasonable period of time after becoming aware of such noncompliance. If all Recipient's rights under this Agreement terminate, Recipient agrees to cease use and
*  distribution of the Program as soon as reasonably practicable. However, Recipient's obligations under this Agreement and any licenses granted by Recipient relating to the
*  Program shall continue and survive. 
*
*  IBM may publish new versions (including revisions) of this Agreement from time to time. Each new version of the Agreement will be given a distinguishing version number. The
*  Program (including Contributions) may always be distributed subject to the version of the Agreement under which it was received. In addition, after a new version of the
*  Agreement is published, Contributor may elect to distribute the Program (including its Contributions) under the new version. No one other than IBM has the right to modify this
*  Agreement. Except as expressly stated in Sections 2(a) and 2(b) above, Recipient receives no rights or licenses to the intellectual property of any Contributor under this
*  Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not expressly granted under this Agreement are reserved. 
*
*  This Agreement is governed by the laws of the State of New York and the intellectual property laws of the United States of America. No party to this Agreement will bring a
*  legal action under this Agreement more than one year after the cause of action arose. Each party waives its rights to a jury trial in any resulting litigation. 
**********************************************************************************************************************/


/*==============================================================================
 Baseband module (Bluetooth MAC): 
 Simulates the following from the Bluetooth baseband specifications
 (1) Frequency Hopping Kernel (79 hop)
 (2) Error Model
 (3) Inquiry and Paging procedures
 (4) Transmission and reception of baseband packets
 (5) Interference model: currently does not exist yet! (see isErrorFree(Packet*)
 (6) Some HCI commands   
               
 linkq_: Array of LMP objects each of which manages a logical channel.
 lc_: Array of LinkController objects each of which are responsible for managing 
      a link (ARQN) and is managed by a LMP object.

 Limitations: 

 A node can participate in a maximum of MaxNumPnets other piconets as
 slave and manage MaxNumSlaves slaves simultaneously.

 ============================================================================*/


#include <bt-core.h>
#include <fh-channel.h>
#include <bt-wirelessphy.h>
#include <bt-distfer.h>

// INQ, PAGE follows 1.1 Spec
#define VER_11

//Define this if you are only interested in scatternet formation.
//#define HOLD_LINK_FOREVER // Hold the link forever, so no communication on the link. 


unsigned trace_category = TRACECAT_BT | TRACECAT_DEFAULT;
unsigned trace_level = (LEVEL_ACCT);// | LEVEL_L2CAP | LEVEL_PACKET | LEVEL_TSS);// | LEVEL_TSF | LEVEL_INQPG | LEVEL_HIGH

int hdr_bt::offset_;
char hdr_bt::hdr_buf_[BUF_LEN];

char gBasebandBuf[BUF_LEN];
int  gMaxBDAddr = 0;

static class BTHeaderClass : public PacketHeaderClass {
public:
	BTHeaderClass() : PacketHeaderClass("PacketHeader/BT", sizeof(hdr_bt)) {
		bind_offset(&hdr_bt::offset_);
	}
} class_bthdr;

static class BasebandClass : public TclClass 
{
public:
	BasebandClass() : TclClass("Baseband"){}
	TclObject* create( int, const char*const*) {
	 	return ( new Baseband );
	}
} class_baseband;


// Test and debugging
static int dropCnt = 0;
int gTmp = -1;
int gTmpAddr = -1, gTmpClk = -1;

// Scatternet statistics
int gScatCount = 0;
int gNodeCount = 0;
ScatHandler* gScatHandler = NULL;
Event* gScatEv = NULL;
bool gNbhPrinted = false;


Baseband** Baseband::lms = NULL;
hash_map<unsigned, addr_inputs> Baseband::addr_cache_;


Baseband::Baseband() : clkn_handler_(this), clk_handler_(this), recv_handler_(this), 
	tx_handler_(this), tdd_handler_(this), resp_id_handler_(this), switch_handler_(this),
	rswitch_handler_(this), sess_handler_(this)
{
	if (lms == NULL) {
		staticInitialize();
	}
	giac_ = GIAC;

	bind("bd_addr_", &bd_addr_);	
	bind("giac_", &giac_);	
	bind("diac_", &diac_);	
	bind("xpos_", &xpos_);
	bind("ypos_", &ypos_);
	bind("nam_trace_", &nam_trace_);
	bind("clkn_", &clkn_);
	
	diac_ = 0;
	clkn_ = clkf_ = clke_ = 0;
	new_am_addr_ = 0;
	trace_ = NULL;

	num_piconets_ = 0; 
	curr_piconet_ = InvalidPiconetNo;
	next_piconet_ = InvalidPiconetNo;
	last_piconet_ = InvalidPiconetNo;

	reply_slot_ = 0;

	// create queues for simulating collisions 
	request_q_ = new queue<ConnectionRequest*>;

	// initialize timers 
	tx_timer_ = 0;
	inq_timer_ = inqscan_timer_ = inqbackoff_timer_ = inqresp_timer_ = 0;	
	page_timer_ = pagescan_timer_ = pageresp_timer_ = new_connection_timer_ = 0;
	wait_timer_ = PageWaitTime; 

	// initialize counters 
	nmr_ = nsr_ = nfhs_ = 0;
	nsr_incr_offset_ = 0;
	num_id_ = num_trains_sent_ = 0;
	last_paged_ = 0;
	freeze_ = 0;
	polled_ = 0;
	am_addr_ = 0;

	train_type_ = A;
	state_ = STANDBY;
	prev_state_ = NUM_STATE;
	next_state_ = CONNECTION;
	tdd_state_ = IDLE;
	tx_clock_ = CLKN;

	num_acl_links_ = 0;
	linkq_ = new (LMP*)[MaxNumLinks];
	lc_ = new (LinkController*)[MaxNumLinks];

	memset(lc_, 0, (sizeof(LinkController*) * MaxNumLinks));
	memset(linkq_, 0, (sizeof(LMP*) * MaxNumLinks));

	for (int i=0; i< (MaxNumSlaves + 1); i++)
		active_list_[i] = -1; // 0 is a valid address!!!!

	state_prog_ = NONE_IN_PROG; 
	prev_clk_ = -1;
	other_addr_ = 0;
	other_offset_ = 0;

	for(int i = 0; i < MaxNumLinks; i++) {
		link_pids_[i] = InvalidPiconetNo;
		time_spent_in_conn_[i] = 0;
	}

	last_recv_ = NULL;

	vip_pkt_ = NULL;
	vip_piconet_ = InvalidPiconetNo;
	last_even_tick_ = 0.0;
	role_ = AS_MASTER;
	max_scan_period_ = RAND_MAX;

	memset(&my_piconet_attr_, 0, sizeof(my_piconet_attr_));
	my_piconet_attr_.mode = Disconnected;

	memset(piconet_attr_, 0, sizeof(con_attr*)*MaxNumLinks);

	tm_windows_ = new int[NUM_TM];
	memset(tm_windows_, 0, (sizeof(int) * NUM_TM));
	tm_windows_[INQ_SCAN_TM] = TwInqScan;
	tm_windows_[PAGE_SCAN_TM] = TwPageScan;

	tm_periods_ = new int[NUM_TM];
	memset(tm_periods_, 0, (sizeof(int) * NUM_TM));
	tm_periods_[INQ_SCAN_TM] = TinqScan;
	tm_periods_[PAGE_SCAN_TM] = TpageScan;

	tm_valid_ = new int[NUM_TM];
	memset(tm_valid_, 0, (sizeof(int) * NUM_TM));

	host_timer_ = 0;
	n_inq_train_ = Ninq;
	n_page_train_ = Npage;
	piconet_hold_time_ = MaxHoldTime * 100; 
	b_stop_ = false;
	iac_filter_accept_ = false;
	b_connect_as_master_ = true;

	cache_ = new cache_entry[num_sequence];
	memset(cache_, 0, sizeof(cache_entry)*num_sequence);
	n_hits_ = 0;

	recv_freq_ = -1;
	b_switch_ = 0;
	clkn_ = 0;   
	newconn_addr_ = -1; 	
	curr_lid_ = -1;
	tx_lid_ = -1;

	for(int i = 0; i < NUM_STATE; i++) 
		time_spent_[i] = 0;
}

void 
Baseband::stop(bool bStop = true) 
{
	double clock = Scheduler::instance().clock();
	int addr = (curr_lid_ == -1) ? curr_piconet_ : lid2addr(curr_lid_);
	TRACE_BT(LEVEL_MED, "%s %s _%d_ (%d) STATE %s LASTED %10.4f \n", "STOP", 
		  TraceAcctStr, bd_addr_, addr, StateTypeStr[state_], (clock - prev_clk_));
	b_stop_ = bStop;
	
	updateTimeSpent(state_, clock - prev_clk_, addr);
	for(int i = 0; i < NUM_STATE; i++) {
		if(i == CONNECTION) {
			double total = 0;
			for(int j = 0; j < MaxNumLinks; j++) {
				if(time_spent_in_conn_[j] > 0) {
					TRACE_BT(LEVEL_ACCT, "%s %s %s _%d_ (%d) STATE %s LASTED %10.4f \n", "STOP", 
						  (b_stop_) ? "TRUE " : "FALSE", TraceAcctStr, bd_addr_, lid2addr(j), 
						  StateTypeStr[i], time_spent_in_conn_[j]);
					total += time_spent_in_conn_[j]; 
				}
			}
			if(time_spent_[i] > total) { 
				// This time is spent on other links which no longer exist
				TRACE_BT(LEVEL_ACCT, "%s %s %s _%d_ (%d) STATE %s LASTED %10.4f \n", "STOP", 
					  (b_stop_) ? "TRUE " : "FALSE", TraceAcctStr, bd_addr_, bd_addr_,
					  StateTypeStr[i], time_spent_[i] - total);
			}
		}
		else {
			TRACE_BT(LEVEL_ACCT, "%s %s %s _%d_ (%d) STATE %s LASTED %10.4f \n", "STOP", 
				  (b_stop_) ? "TRUE " : "FALSE", TraceAcctStr, bd_addr_, addr, 
				  StateTypeStr[i], time_spent_[i]);
		}
	}

	if(dropCnt) {
		TRACE_BT(LEVEL_ACCT, "drops due to dist: %d\n", dropCnt);
		dropCnt = 0;
	}
	TRACE_BT(LEVEL_ACCT, "_%d_ nHits %d\n", bd_addr_, n_hits_);
}

// Instproc-likes for Baseband class
int 
Baseband::command(int argc, const char*const* argv)
{
	if (argc == 3) {
		if (strcmp(argv[1], "set-seed") == 0) {
			ASSERT(bd_addr() == 0);
			int seed = atoi(argv[2]);
			srand(seed);
			TRACE_BT(LEVEL_MED, "BB FIRST RAND %d SEED %d\n", randRange(0, 100000), seed);
			return TCL_OK;
		}
		else {
			// setting objects
			TclObject *obj = NULL;
			if (strcmp(argv[1], "bthost") == 0) {
				LOOKUP_TCLOBJ(obj, argv[2]);
				host_ = (BTHost*)obj;
				return (TCL_OK);
			}
			else if (strcmp(argv[1], "channel") == 0) {				
				LOOKUP_TCLOBJ(obj, argv[2]);
				channel_ = (FHChannel*)obj;
				channel_->init();
				return (TCL_OK);
			}
			else if (strcmp(argv[1], "trace-target") == 0) {
				LOOKUP_TCLOBJ(obj, argv[2]);
				trace_ = (Trace*)obj;
				return (TCL_OK);
			}
		}
	}
	if (argc == 4) {
		if (strcmp(argv[1], "install-linkq") == 0) {
			int slot = atoi(argv[2]);
			linkq_[slot] = (LMP*)TclObject::lookup(argv[3]);
			linkq_[slot]->init(slot);
			return (TCL_OK);
		}

		if (strcmp(argv[1], "install") == 0) {
			int slot = atoi(argv[2]);
			lc_[slot] = (LinkController*)TclObject::lookup(argv[3]);
			//ASSERT(slot >= MaxNumSlaves); //GT extension
			return (TCL_OK);
		}
	}
	return (BiConnector::command(argc, argv));
}

// Called by bthost when '$ns at time "$bthost start"' is executed in Tcl script
void
Baseband::start()
{
	Scheduler& s = Scheduler::instance();
	uap_lap_ = randRange(0U, UINT_MAX); // assign a random addr

	updateRole(AS_SLAVE);
	updateRole(AS_MASTER);

	for(int i = 0; i < MaxNumSlaves; i++) 
		link_pids_[i] = pid();
	
	// backward compatibility! //@GT
	if(diac_ != 0) {
		int n = 0;
		vector<int> filter;
		while(n < 32) {
			if(!((diac_ >> n) & 0x01)) // Do not accept those not on the list
				filter.push_back(n + IACLow);
			n++; 
		}
		setIacFilter(filter, false);
	}

	//setIAC(IACLow + pid());
	setIAC(GIAC);

	s.schedule (&clkn_handler_, &clkn_ev_, ClockTick);

	Baseband::lm(bd_addr(), this);
	if(bd_addr() > gMaxBDAddr)
		gMaxBDAddr = bd_addr();

	scat_id_ = prev_scat_id_ = bd_addr();
	gScatCount++;
	gNodeCount++;

	ASSERT(clkn_ >= 0);
	start_clkn_ = clkn_;

	TRACE_BT(LEVEL_ACCT, "BB START %d\t clock: %10e, xpos %.4f, ypos %.4f, clkn %d\n", 
		  bd_addr_, s.clock(), xpos_, ypos_,  clkn_);
}

// Print out statistics related to scatternet formation.
void
ScatHandler::handle(Event* e) 
{
	int scatCnt = Baseband::lm(0)->host()->topoConstructor()->numScatternets();
	if(scatCnt < 0) {
		scatCnt = gScatCount;
	}

	TRACE_BT(LEVEL_ACCT, "%s SCAT COUNT v.s. Nodes: %d / %d.\n",
		  TraceAcctStr, scatCnt, gNodeCount);

	Scheduler& s = Scheduler::instance();
	s.schedule(gScatHandler, gScatEv, 1);

	if (!gNbhPrinted) {
		int nnodes = 0, nbhs = 0;
		for (int i = 0; i < MaxNumNodes; i++) {
			if (!Baseband::lm(i))
				continue;
			nnodes++;
			TRACE_BT(LEVEL_ACCT, "_%d_ (%4.2f, %4.2f) neighbors: ", 
				 Baseband::lm(i)->bd_addr(), Baseband::lm(i)->xpos_, Baseband::lm(i)->ypos_); 
			for (int j = 0; j < MaxNumNodes; j++) {
				if (Baseband::lm(j) && i != j && 
				    Baseband::lm(i)->isWithinRange(Baseband::lm(j)->xpos_, 
								      Baseband::lm(j)->ypos_)) {
					TRACE(LEVEL_ACCT, "%d ", Baseband::lm(j)->bd_addr());
					nbhs++; 
				}
			}
			TRACE(LEVEL_ACCT, "\n");
		}
		TRACE_BT(LEVEL_ACCT, "nnodes %d, density %4.2f\n", nnodes, (double)nbhs/nnodes);
		gNbhPrinted = true;
	}
}


// Handles all the events synchronized with a CLKN tick (tick = 312.5usec). This is the native clock handler and
// there is only one instance for each device. 
void 
CLKNHandler::handle (Event* e)
{
	Scheduler& s = Scheduler::instance();
	ConnectionRequest* cr; 
	hdr_bt* bt = NULL;

	if(lm_->b_stop_) return; 

	lm_->clkn_++;
	if (lm_->clke_)
		lm_->clke_++;

	lm_->checkWrapAround(&lm_->clkn_);
	lm_->checkWrapAround(&lm_->clke_);

	int clkmod4 = lm_->clkn_%4;
	if(clkmod4 == 0)
		lm_->last_even_tick_ = s.clock();

	s.schedule (this, e, ClockTick);

	int lid = 0;
	if(lm_->my_piconet_attr_.mode == Hold) {
		if (--(lm_->my_piconet_attr_.hold_time) == 0) {
			int hold = lm_->scheduler()->tillNextActiveLink(lm_->clkn_, &lid);
			if(hold <= 0) {
				if(!lm_->holdExpires(lm_->pid(), lid)) {
					if(lm_->my_piconet_attr_.hold_time <= 0)
						lm_->my_piconet_attr_.hold_time = Tretry;
				}
			}
			else {
				lm_->my_piconet_attr_.hold_time = hold;
			}
		}
		ASSERT(lm_->my_piconet_attr_.hold_time >= 0);
	}

	// Handle timer events 
	if (lm_->tm_valid_[HOST_TM] && ((--lm_->host_timer_) == 0)) {
		lm_->host()->hci2HostTimerExpiredEvent();
	}

	// Timers common to master and slaves
	if (lm_->pageresp_timer_) {  
		if (lm_->state_ == MASTER_RESP && clkmod4 == 0) 
			lm_->nmr_++;
		else if (lm_->state_ == SLAVE_RESP) {
			if (lm_->nsr_ == 0) {
				lm_->nsr_ = 1;
				lm_->nsr_incr_offset_ = clkmod4;
			}
			else if (clkmod4 == lm_->nsr_incr_offset_) 
				lm_->nsr_++;
		}
	}

	if (lm_->isActiveAsMaster()) {
		// Timers used by the master
		if (lm_->state_ == INQUIRY && (--lm_->inq_timer_ == 0)) { 
			// Send results to host and restore previous state.
			lm_->inquiryComplete(lm_->prev_state_);
			ASSERT(lm_->getSessionInProg() == NONE_IN_PROG);
		}

		if (lm_->tm_valid_[INQ_TM] && lm_->state_ == STANDBY && lm_->inq_timer_ > 0) {
			lm_->saveAndChangeState(INQUIRY);
			lm_->host()->hciCommandStatusEvent(HCI_INQ, true);
		}

		if (lm_->state_ == PAGE && --(lm_->page_timer_) == 0) {
			// Page timeout happens. Let host know about the unsuccessful connection establishment.
			lm_->initInqPageParam();
			lm_->changeState(lm_->prev_state_);

			lm_->changeProg(NONE_IN_PROG);
			lm_->host()->hciConnectionCompleteEvent(-1, true); 
		}
	} 

	if(lm_->isActiveAsSlave()) {
		// Timers used by slaves
	
		// Timeouts related to inquiry scan and page scan

		if (lm_->tm_valid_[INQ_SCAN_TM] && ++(lm_->inqscan_timer_) == lm_->tm_windows_[INQ_SCAN_TM]) {
			// A short inquiry scan has been done so schedule the inquiry scan event
			// to happen in next TinqScan ticks.
			lm_->inqscan_timer_ = -lm_->tm_periods_[INQ_SCAN_TM]; //-TinqScan;
			lm_->endScan(INQ_SCAN);
			lm_->host()->hciScanCompleteEvent(INQ_SCAN_TM);
		}
		
		if (lm_->tm_valid_[PAGE_SCAN_TM] && ++(lm_->pagescan_timer_) == lm_->tm_windows_[PAGE_SCAN_TM]) {
			// A short page scan has been done so schedule the page scan event
			// to happen in next TpageScan ticks.
			if (lm_->getState() == PAGE_SCAN) { 
				// If a PAGE_RESP session has begun, we let it proceed. If no successful connection
				// happens, handleNewConnectionTO will be called. OTH, we do, however, stop the scanning
				// even if the node is in INQ_RESP state. This because SCANNING is part of the 
				// INQ_RESP session that lasts until inqresp_timer_ expires. @GT 10/17/02
				lm_->pagescan_timer_ = -lm_->tm_periods_[PAGE_SCAN_TM];//-TpageScan;
				lm_->endScan(PAGE_SCAN);
				lm_->host()->hciScanCompleteEvent(PAGE_SCAN_TM); //GT new HCI event?
			}
		}
		
		if (lm_->clkn_ == lm_->max_scan_period_) {
			TRACE_BT(LEVEL_HIGH, "_%d_ CLKN is max_scan_period_. STOP all scans.\n", lm_->bd_addr());
			lm_->resetState();
		}

		// Time to perform another inquiry scan. 
		if (lm_->tm_valid_[INQ_SCAN_TM] && lm_->inqscan_timer_ == 0 && 
		    (lm_->clkn_ < lm_->max_scan_period_) && !(lm_->inqbackoff_timer_)) {
			if(!lm_->scan(INQ_SCAN))
				lm_->inqscan_timer_ = -Tretry;
		}

		// Time to perform another page scan.
		if (lm_->tm_valid_[PAGE_SCAN_TM] && lm_->pagescan_timer_ == 0 && (lm_->clkn_ < lm_->max_scan_period_)) {
			if(!lm_->scan(PAGE_SCAN))
				lm_->pagescan_timer_ = -Tretry;
		}

		// Random backoff timeout in inquiry response procedure
		if (lm_->inqbackoff_timer_) { 
			if (--(lm_->inqbackoff_timer_) == 0) {
				TRACE_BT(LEVEL_TIMER, "_%d_ Inqbackofftimer expired. state %s, prog %s.\n", 
					  lm_->bd_addr(), StateTypeStr[lm_->state_], ProgTypeStr[lm_->getSessionInProg()]);
				if(lm_->getSessionInProg() != INQ_IN_PROG)
					ASSERT(0);
				lm_->prev_state_ = lm_->state_;
				lm_->changeState(INQ_RESP);
			}
		}		
	}

	// Transmit timer
	lm_->updateTxTimer(CLKN);

	if (lm_->pageresp_timer_ ) {
		if (--(lm_->pageresp_timer_) == 0) {
			lm_->handlePageRespTO();
		}
	}

	if (lm_->inqresp_timer_) {
		if (--(lm_->inqresp_timer_) == 0) {
			TRACE_BT(LEVEL_TIMER, "_%d_ Inquiry response timeout\n", lm_->bd_addr());
			lm_->handleInqRespTO();
			lm_->host()->hciScanCompleteEvent(INQ_SCAN_TM, true); 
		}
	}

	if (lm_->new_connection_timer_) {
		if (--(lm_->new_connection_timer_) == 0) {
			TRACE_BT(LEVEL_TIMER, "_%d_ New connection timer expired.\n", lm_->bd_addr());
			lm_->handleNewConnectionTO();
		}
	}

	// If no packet is being transmitted or received try to transmit one
	// For master transmissions only since tx_clock_ = CLKN 
        if (lm_->tdd_state_ == IDLE && lm_->tx_clock_ == CLKN && lm_->isActiveAsMaster()) {
		if (lm_->state_ == PAGE) {
			// send two ID packets per even slot 
			if (clkmod4 < 2) 
				lm_->sendIDPacket(lm_->page_addr_);
		}
		else if (!lm_->request_q_->empty()) {
			// Find if a Page request is pending 
			if (lm_->state_ == CONNECTION && lm_->wait_timer_-- && clkmod4 == 0
				&& lm_->currentRole() == AS_MASTER) {
				lm_->scheduleNext();
			}

			if (lm_->wait_timer_ == 0 || lm_->state_ == STANDBY) { 
				if (lm_->num_acl_links_ < MaxNumLinks) { 
					cr = lm_->request_q_->front();
					lm_->request_q_->pop();
					lm_->saveAndChangeState(PAGE);
					lm_->host()->hciCommandStatusEvent(HCI_PAGE, true);
					lm_->initInqPageParam(); 
					lm_->page_timer_ = lm_->tm_periods_[PAGE_TM]; 
					lm_->clke_ =  lm_->clkn_ - cr->clock_offset;
					TRACE_BT(LEVEL_ACCT, "_%d_ CLKN %d PAGING %d DEVICE CLKE %d ACTUAL CLKN %d MOD4 %d\n",
						  lm_->bd_addr(), lm_->clkn(), cr->bd_addr, lm_->clke_, 
						  Baseband::lm(cr->bd_addr)->clkn(), clkmod4);
						
					lm_->page_addr_ = cr->bd_addr;
					if (clkmod4 <2) 
						lm_->sendIDPacket(lm_->page_addr_);
					lm_->wait_timer_ = PageWaitTime;
				}
			}
		}
		else if (lm_->state_ == INQUIRY) {
			// Send two ID packets per even slot
			if (clkmod4 < 2) 
				lm_->sendIDPacket(lm_->getIAC());
		}
		else if (lm_->state_ == MASTER_RESP && clkmod4 == 0) {
			// Follow master response page procedure 
			if (!(lm_->pageresp_timer_)) {
				lm_->nmr_ = 1;
				lm_->pageresp_timer_ = PageRespTO;

			}
			lm_->sendFHSPacket();
		}
		else if (lm_->new_connection_timer_ && clkmod4 == 0) {
			// Send POLL packet to the new connection with a new am_addr
			if (lm_->new_am_addr_==0) lm_->newAmAddr();
			if (lm_->new_am_addr_ < (MaxNumSlaves + 1)) {
				Packet* p = lm_->sendPOLLPacket(lm_->new_am_addr_);
				bt = HDR_BT(p);
				if(!(lm_->newconn_addr_ != -1))
					ASSERT(0);
				TRACE_BT(LEVEL_MED, "_%d_ SENDING POLL PKT TO %d FOR NEWCONN. SENDFQ %d RECVFQ %d %s\n",
					 lm_->bd_addr(), lm_->newconn_addr_, bt->fs_,
					 Baseband::lm(lm_->newconn_addr_)->recv_freq_, bt->toString());
			}
			else {
				ASSERT(0);
				// Host should not have done paging since this node has already
				// reached maximum connection limit
			}
		}
	        else if (lm_->state_ == CONNECTION && clkmod4 == 0 && lm_->currentRole() == AS_MASTER) {
			lm_->scheduleNext();
		}
	}

	if(lm_->state_ != CONNECTION || lm_->currentRole() == AS_MASTER) {
		lm_->updateRecvFreq(); 
	}
}

void
Baseband::beginPageRespSession() 
{
	if(getSessionInProg() != NONE_IN_PROG)
		ASSERT(0);
	beginSession(PAGE_IN_PROG, PageRespTO + 6);

	Scheduler& s = Scheduler::instance();
	freeze_ = 1; // freeze the clock

	if(state_ == PAGE_SCAN) {
		// Initiate slave response procedure
		// Page message received, sync to master clock  by setting the next transmission event at 
		// exactly 625 usec after we started receiving the page ID packet
	
		clkf_ = clkn_;
		changeState(SLAVE_RESP);
		
		tx_clock_ = CLK;
		newconn_addr_ = -1;
		Event* e = new Event(); 
		s.schedule(&(resp_id_handler_), e, SlotTime - (s.clock() - recv_start_));
	}
	else {
		ASSERT(state_ == PAGE);
	        //Received a valid page response, freeze the estimated clock  for rest of the paging procedure.
		// Initiat master response procedure.
		
		clkf_ = clke_;
		changeState(MASTER_RESP);
	}
	TRACE_BT(LEVEL_ACCT, "_%d_ BEGIN PAGE RESPONSE SESSION CLKN %d CLKF %d CLKE %d %s\n",
		  bd_addr(), clkn(), clkf_, clke_, StateTypeStr[state_]);
}

void
Baseband::endPageRespSession() 
{
	endSession(PAGE_IN_PROG);

	if(state_ == MASTER_RESP) {
		
		clke_ = 0;
		nmr_ = 0;
		prepareMasLink();
		newconn_addr_ = page_addr_;
		pageresp_timer_ = 0;
		freeze_ = 0; 
	}
	else {
		ASSERT(state_ == SLAVE_RESP && new_connection_timer_);
		TRACE_BT(LEVEL_HIGH, "_%d_ SENDING ID-PKT TO MAS %d IN RESPONSE TO FHS\n", 
			  bd_addr(), scanned_addr_);

		if(!resp_id_handler_.is_scheduled_) {
			// wait until the next slot boundary (see SPEC)
			Scheduler& s = Scheduler::instance(); 
			s.schedule(&(resp_id_handler_), new Event(), SlotTime - (s.clock() - recv_start_));
		}
		pageresp_timer_ = 0;
		// we reset freeze_ in RespIdHandler::handle since the ID packet still needs to use the frozen clock
		newconn_addr_ = scanned_addr_;
	}
}

void
Baseband::prepareMasLink()
{
	ASSERT(pid() != InvalidPiconetNo);
	//master_index_ = pid() + 1;
	curr_piconet_ = pid(); 
	
	changeState(CONNECTION);
	new_connection_timer_ = NewConnectionTimeout;
	b_connect_as_master_ = true;
	updateRole(AS_MASTER);
}

void
Baseband::prepareSlvLink() 
{
	changeState(CONNECTION);
	updateRole(AS_SLAVE);
}

void
Baseband::handlePageRespTO() 
{
	endSession(PAGE_IN_PROG);

	if(isActiveAsMaster() && page_timer_) {
		if(state_ == MASTER_RESP) 
			changeState(PAGE); 
		freeze_ = 0;
		nmr_ = 0;
	}

	if(isActiveAsSlave()) {
		if(state_ == PAGE_SCAN || state_ == SLAVE_RESP) 
			changeState(prev_state_);
		freeze_ = 0;
		nsr_ = 0;
	}
	pageresp_timer_ = 0;
}

void
Baseband::handleNewConnectionTO() 
{
	// We need to cater for the case when it really timeouts.
	if(state_ == CONNECTION) {// real connection timeouts since master or slave does not respond!
		if(roleChangeInProg()) {
			TRACE_BT(LEVEL_ERROR, "_%d_ DBG ROLESWITCH NEWCONN TIMEOUT\n", bd_addr());
			ASSERT(0);
		}
		else {
			if(b_connect_as_master_)
				inquiryComplete(prev_state_);
			else {
				// we need to delete the slave link 
				TRACE_BT(LEVEL_TSF, "_%d_ DBG NEWCONNECTION TIMEOUT DURING PAGE SCAN\n",
					  bd_addr());
				delSlaveLink(curr_piconet_);
				host()->hciScanCompleteEvent(PAGE_SCAN_TM, true); // inform host of the failure
			}
		}
	}
	else if (isActiveAsMaster() && state_ == MASTER_RESP) {
		if (page_timer_) 
			changeState(PAGE);
		else 
			changeState(prev_state_);
	}
	else if(isActiveAsSlave() && state_ == SLAVE_RESP) {
		// This happens when slave does not receive the POLL pkt following the paging procedure.
		changeState(prev_state_);
	}
	newconn_addr_ = -1;
}

// Perform inquiry or page scan.
bool
Baseband::scan(state_type scan_state) 
{
	TRACE_BT(LEVEL_TIMER, "_%d_ %s TIMER EXPIRED. state %s, prog %s\n", 
		 bd_addr(), StateTypeStr[scan_state], StateTypeStr[state_], ProgTypeStr[state_prog_]);

	if(state_prog_ != NONE_IN_PROG || (state_ != CONNECTION && state_ != STANDBY)) 
		return false;

	ASSERT(scan_state == INQ_SCAN || scan_state == PAGE_SCAN);
	ASSERT(state_ != scan_state);

	timer_type tm = (scan_state == INQ_SCAN) ? INQ_SCAN_TM : PAGE_SCAN_TM;

	if (state_ == CONNECTION) {
		//TRACE_BT(LEVEL_LOW, "BD_ADDR %d PUTTING PICONET %d ON HOLD FOR %s FOR %d ticks.\n",
		//	  bd_addr_, curr_piconet_, StateTypeStr[scan_state], MinHoldTime);
		next_state_ = scan_state;
		holdPiconet(curr_piconet_, tm_windows_[tm] + 2);
	}
	else {
		saveAndChangeState(scan_state);
	}
	host()->hciCommandStatusEvent(tm2hci(tm), true);
	return true;
}

void
Baseband::endScan(state_type state) 
{
	ASSERT(state == INQ_SCAN || state == PAGE_SCAN);
	if ((state == state_) && ((state_ == INQ_SCAN) && !freeze_) || (state_ == PAGE_SCAN)) {
		changeState(STANDBY); 
		if(state_ == PAGE_SCAN)
			changeProg(NONE_IN_PROG);
	}
}

// Slave link handler per piconet. Invoked every one-half time-slot. 
void
CLKHandler::handle(Event * e) 
{
	if(lm_->b_stop_) return; 

	Scheduler& s = Scheduler::instance();
	int clkmod4;
	CLKEvent* clkev = (CLKEvent*)e;
	int piconet_no = clkev->piconet_no;
	con_attr* attr = lm_->piconet_attr_[lm_->pid2lid(piconet_no)];

	clkmod4 = (++(attr->clk))%4;
	lm_->checkWrapAround(&attr->clk);

	s.schedule (this, e, ClockTick);

	if (attr->mode == Hold) {
		if (--(attr->hold_time) == 0) {
#ifdef HOLD_LINK_FOREVER
			TRACE_BT(LEVEL_MED, "_%d_ TEST: HOLDING PNET %d FOREVER\n", lm_->bd_addr(), piconet_no);
			return; 
#endif
                        if(!lm_->holdExpires(clkev->piconet_no, lm_->pid2lid(clkev->piconet_no))) {
				if(attr->hold_time <= 0)
					attr->hold_time = Tretry;
			}
		}
		if(attr->mode == Hold)
			return;
	}

	if (piconet_no == lm_->curr_piconet_) {
		lm_->master_clk_ = attr->clk;
		lm_->updateRecvFreq();
	}
	else {
		return;
	}

	lm_->updateTxTimer(CLK);
	
	// If no packet is being transmitted or received try to transmit one
	if (lm_->tdd_state_ == IDLE && lm_->tx_clock_ == CLK) {
		// Slave transmissions
		if (lm_->state_ == SLAVE_RESP && lm_->new_connection_timer_) { 
			if(piconet_no != lm_->scanned_addr_)
				ASSERT(0);

			// Send ID packet as an ack for the FHS packet recv from master */
			lm_->endPageRespSession();
			TRACE_BT(LEVEL_LOW, "_%d_ DBG MASTERCLK mas %d  masclk %d, real masclkn %d\n",
				 lm_->bd_addr(), piconet_no, lm_->master_clk_, Baseband::lm(piconet_no)->clkn());
		}

		// if the slave has been polled and clkmod4 corresponds
		// to the start of an odd slot send a response
		else if (lm_->polled_ && clkmod4 == 2) {	
			if (lm_->new_connection_timer_) {
				// send ack to the 'first' poll packet by the master
				lm_->new_connection_timer_ = 0;
				lm_->sendNULLPacket(attr->am_addr);
				lm_->linkEstablished(lm_->pid2lid(piconet_no));
			}	

			else if (lm_->state_ == CONNECTION) {
				Packet* pkt = NULL;
				if(lm_->vip_piconet_ == piconet_no) {
					// handle the special baseband packet first
					pkt = lm_->vip_pkt_;
					lm_->vip_piconet_ = InvalidPiconetNo;
					lm_->vip_pkt_ = NULL;
				}

				if(!pkt) {
					int lid = lm_->pid2lid(piconet_no);
					// if hold_in_prog, it must be a one-slot packet
					pkt = lm_->lc_[lid]->send(lm_->getSessionInProg() == HOLD_IN_PROG ? 1 : -1);
				}

				if (pkt) 
					lm_->sendPacket(pkt);
				else 
					lm_->sendNULLPacket(attr->am_addr);
			}
			// replied to poll from master hence reset polled
			lm_->resetPolledStates();
		}
		else if (!lm_->polled_ && clkmod4 == 2) {	
			// The link is active. Let the host know that a poll has been missed. 
			lm_->host()->pollMissed(lm_->pid2lid(piconet_no));
		}
	}	
}

void
Baseband::resetPolledStates()
{
	polled_ = 0;
	reply_slot_ = 0;
}

void
Baseband::resetState() 
{
	// a new link has been created or deleted
	if(num_acl_links_ <= 0 && num_piconets_ <= 0) {
		prev_state_ = STANDBY;
		changeState(STANDBY);
	}
	else {
		changeState(CONNECTION);
	}
}

void
Baseband::saveAndChangeState(state_type state)
{
	// We need to cancel the current state by not setting prev_state, otherwise we would override prev_state_.
	// The rule is to make a special case for CONNECTION which does not happen periodically and is the default state.
	if(prev_state_ == STANDBY && (state_ != STANDBY && state_ != CONNECTION))
		ASSERT(0);
	if(prev_state_ != CONNECTION)
		prev_state_ = state_; // BUG-4 fix: cancel the current state
	changeState(state);
}

// Change STATE_ to STATE. If ADDR != -1, ADDR is used to print out stats.
void
Baseband::changeState(state_type state, int addr = -1)
{
	if(state == state_ && addr == -1) {
		return;
	}

	state_type old_state = state_;
	state_ = state;
	if (nam_trace_) {
		BTNodeTrace* ns = (BTNodeTrace*)downtarget_;
		// inform the nam trace object about state change 
		// old state required for back-trace in nam
		ns->changeNodeColor(state, old_state);
	}

	switch(state) {
	case INQUIRY:
		tx_clock_ = CLKN;
		break;
	case SLAVE_RESP:
		tx_clock_ = CLK;
		break;
	case CONNECTION:
		if(currentRole() == AS_SLAVE)
			tx_clock_ = CLK;
		else 
			tx_clock_ = CLKN; 
		break;
	default:
		break;
	}

	tdd_state_ = IDLE;

	double clock = Scheduler::instance().clock();
        addr = (addr == -1) ? curr_piconet_ : addr;
	if(prev_clk_ >= 0) {
		TRACE_BT(LEVEL_MED, "%s  _%d_ (%d) STATE %s LASTED %10.4f NEXT %s\n", TraceAcctStr, bd_addr_, addr, 
		      StateTypeStr[old_state], (clock - prev_clk_), StateTypeStr[state_]);
		updateTimeSpent(old_state, clock - prev_clk_, addr);
	}

	prev_clk_ = clock;
	if(state != old_state) {
		TRACE_BT(LEVEL_STATE, "_%d_ (%d) CHANGING STATE %s -> %s, prev %s next %s prog %s\n", 
			 bd_addr_, addr, StateTypeStr[old_state], StateTypeStr[state_], 
			 StateTypeStr[prev_state_], StateTypeStr[next_state_], ProgTypeStr[state_prog_]);
	}

	if(state_ != CONNECTION)
		curr_lid_ = -1;
}

void
Baseband::updateTimeSpent(state_type state, double dur, int addr = -1)
{
	time_spent_[state] += dur;
	if(state == CONNECTION) {
		if(addr != -1)
			time_spent_in_conn_[addr2lid(addr)] += dur;
	}
}

void
Baseband::scheduleNext()
{	
	if(my_piconet_attr_.mode != Active)
		return;
	Packet* pkt = NULL;
	pkt = scheduler()->schedulePkt(clkn_, (getSessionInProg() == HOLD_IN_PROG) ? 1 : -1);
	if (pkt) 
		sendPacket(pkt);
}

inline BTScheduler*
Baseband::scheduler() const 
{
	return dynamic_cast<BTScheduler*>(uptarget_); 
}

Packet*
Baseband::allocPkt(bt_packet_type pktType, int addr) 
{
	Packet* p = NULL;
	hdr_cmn* ch = NULL;
	hdr_bt* bt = NULL;
	
	switch(pktType) {
	case BT_FHS:
	{
		p = Baseband::allocBBPkt(BT_POLL, addr);
		ch = HDR_CMN(p);
		bt = HDR_BT(p);
		
		bt->type = BT_FHS;
		ch->size() = FHSSize;
		bt->ph.data = new uchar[sizeof(FHS_payload)];
		FHS_payload* fhs = (FHS_payload*)(bt->ph.data);
		fhs->addr = bd_addr_;
		
		ASSERT(pid() != InvalidPiconetNo);
		fhs->piconet_no = pid(); 
		break;
	}
	case BT_ID:
		p = Baseband::allocBBPkt(BT_POLL, addr);
		ch = HDR_CMN(p);
		bt = HDR_BT(p);

		bt->type = BT_ID;
		ch->uid() = addr;
		ch->size() = IDSize;
		break;

	default:
		p = Baseband::allocBBPkt(pktType, addr);
		break;
	}
	return p;
}

Packet*
Baseband::allocBBPkt(bt_packet_type pktType, int addr) 
{
	Packet* p = ALLOCP();
	hdr_cmn* ch = HDR_CMN(p);
	hdr_bt* bt = HDR_BT(p);
	bt->type = pktType;
	bt->am_addr = (uchar)addr;
	
	switch(pktType) {
	case BT_POLL:
		ch->size() = PollSize;
		break;	
	case BT_NULL:
		bt->arqn = 0;
		ch->size() = NullSize;
		break;
	case BT_DM1:
	case BT_DM3:
	case BT_DM5:
	case BT_DH1:
	case BT_DH3:
	case BT_DH5:
		ch->size() = Payload[bt->type];
		break;
	default:
		ASSERT(0);
	}
	return p;
}

Packet*
Baseband::sendIDPacket(int addr)
{
	if (state_ == PAGE || state_ == INQUIRY) 
		updateInqPageParam();

	Packet* p = allocPkt(BT_ID, addr);
	sendPacket(p);
	return p;
}

void
Baseband::sendFHSPacket()
{
	Packet* p = allocPkt(BT_FHS, 0);
	sendPacket(p);
}	

Packet*
Baseband::sendPOLLPacket(uchar am_addr)
{
	Packet* p = allocPkt(BT_POLL, am_addr);
	sendPacket(p);
	return p;
}

void
Baseband::sendNULLPacket(uchar am_addr)
{
	Packet* p =  allocPkt(BT_NULL, am_addr);
	sendPacket(p);
}

// Schedules the packet to be sent on the appropriate hopping sequence.
void
Baseband::sendPacket(Packet* p)
{
	Scheduler& s = Scheduler::instance();
	FH_sequence_type 	hop_type;

	int 	address;
	int 	clock, clockf;

	tdd_state_ = TRANSMIT;
	hdr_cmn* ch = HDR_CMN(p); 
	hdr_bt* bt = HDR_BT(p); 

	tx_timer_ = (int)(2*SlotSize[bt->type]);
	bt->piconet_no = pid(); 

	switch (state_) {

	case INQUIRY:
		clock = clkn_;
		address = giac_;
		hop_type = inquiry_hopping;
		bt->am_addr = 0;  	// used for broadcast in animation
		break;
		
	case PAGE: 
		clock = clke_;
		address = page_addr_;
		hop_type = page_hopping;
		bt->am_addr = 0;  	// used for broadcast in animation
		bt->recv_id_ = page_addr_; 
		break;

	case INQ_RESP: 
		clock = clkn_;
		address = giac_;
		hop_type = inquiry_response;
		bt->recv_id_ = 0;  	
		break;

	case SLAVE_RESP:
		clock = clkn_;
		address = bd_addr_;
		hop_type = slave_response;
		bt->recv_id_ = 0;  
		break;

	case MASTER_RESP:
		clock = clke_;
		address = page_addr_;

		if(clke_ != lm(address)->lastEvenTick()) {
			TRACE_BT(LEVEL_LOW, "_%d_ DBG LAST EVEN TICK DIFFERENT clkf_ %d clke_ %d, realeventick %d\n", 
				  bd_addr(), clkf_, clke_, lm(address)->lastEvenTick());
		}
		hop_type = master_response;
		bt->recv_id_ = page_addr_;
		break;

	case CONNECTION: 
		if(currentRole() == AS_MASTER) {
			address = bd_addr_;
			clock = clkn_;
			am_addr_ = bt->am_addr;
			bt->recv_id_ = active_list_[bt->am_addr];
		}
		else {
			ASSERT(currentRole() == AS_SLAVE);
			address = master_addr_;						
			clock = master_clk_;
			bt->recv_id_ = address;
		}
		bt->piconet_no = curr_piconet_;
		hop_type = channel_hopping;
		break;
	}

	bt->send_id_ = bd_addr_;
	if (ch->size() == 0)
		ch->size() = Payload[bt->type];

	clockf = (freeze_) ? clkf_ : clock;	
	bt->fs_ = FH_kernel(clock, clockf, hop_type, address);	
	//TRACE_BT(LEVEL_TMP, "_%d_ SEND FREQ %d STATE %s CLOCK 0x%x CLOCKF 0x%x HOP %d ADDR %d\n", 
	//		 bd_addr(), bt->fs_, StateTypeStr[getState()], clock, clockf, hop_type, address);

#ifdef DEBUG_BB
	Baseband* bb = lm(scanned_addr_);
	int ce = bb->clke_;
	int cf = bb->clkf_;
	tdd_state_type prevState = bb->tdd_state_;
	bb->tdd_state_ = IDLE;
	for(int i = ce - 10; i < ce + 11;  i++) {
		for(int j = cf - 10; j < cf + 11;  j++) {
			bb->clke_ = i;
			bb->clkf_ = j;
			bb->updateRecvFreq();
			TRACE_BT(LEVEL_TMP, "_%d_ DBG MAS %d clke_ %d clkf_ %d recv_freq %d\n",
				 bd_addr(), scanned_addr_, bb->clke_, bb->clkf_, bb->recv_freq_);
		}
	}
	bb->clke_ = ce;
	bb->clkf_ = cf;
	bb->tdd_state_ = prevState;
	bb->updateRecvFreq();
	TRACE_BT(LEVEL_TMP, "_%d_ DBG MAS %d clke_ %d clkf_ %d recv_freq %d\n",
		 bd_addr(), scanned_addr_, bb->clke_, bb->clkf_, bb->recv_freq_);
#endif

	bt->send_id_ = bd_addr_;
	bt->xpos_ = xpos_;
	bt->ypos_ = ypos_;
	if(state_ == CONNECTION) {
		tx_lid_ = bt->lid_ = (currentRole() == AS_MASTER) ? AM2LID(bt->am_addr) : pid2lid(curr_piconet_);
		bt->dir = isMasLink(bt->lid_);
	}
	else {
		bt->lid_ = (uchar)-1;
		bt->dir = (uchar)-1;
		tx_lid_ = -1;
	}
	//tx_lid_ = (bt->lid_ == (uchar)-1) ? -1 : bt->lid_;

	if(bt->type == BT_FHS) {
		// Set the clock information right before the packet is transmitted
		FHS_payload* fhs = (FHS_payload*)(bt->ph.data);
		fhs->clock = clkn_ & 0xfffffffc; // even tick
		fhs->real_time = last_even_tick_;
	}

	s.schedule(&tx_handler_, p, PropDelay); 
	// debugging purposes and to solve occassional acceptance of wrong packets (see RecvHandler::handle)
	bt->state_ = state_; 

	if(bt->ph.l_ch == LMP_CHAN) {
		// Check LMP commands to make sure whether BB needs to do anything.
		uchar* data = p->accessdata();
		uchar opcode = data[0];

		if(opcode == LMP_DETACH) {
			detach(linkq_[bt->lid_]);
		}
	}

}

// Hand the packet down to the lower layer. 
void
TxHandler::handle (Event* e)
{
	//TRACE_BT(LEVEL_TMP, "_%d_ GT handle: %s \n", lm_->bd_addr(), HDR_BT((Packet*)e)->toString());

	if(lm_->b_stop_) 
		return; 

	Packet* p = (Packet*)e; 
	hdr_bt* bt = HDR_BT(p);
	TRACE_BT(LEVEL_PACKET, "_%d_ SEND %s %s %s %d\n", 
		 lm_->bd_addr_, bt->toString(), HDR_L2CAP(p)->toString(), 
		 packet_info.name(HDR_CMN(p)->ptype()), HDR_CMN(p)->uid());
	if(lm_->trace_)
		lm_->trace_->recv(COPYP(p), lm_);

	lm_->downtarget_->recv(p, lm_);
}

void
TDDHandler::handle (Event* p)
{
	lm_->tdd_state_ = IDLE;
}

// First bit of a packet received. All packets reach all nodes
// because of broadcast. This is required for collision detection. 
void 
Baseband::sendUp (Packet* p, Handler* h)
{
	if(b_stop_ || state_ == STANDBY) {
		FREEP(p);
		return; 
	}

	static bool check = true;
	check = true;

	Scheduler& s = Scheduler::instance();
	hdr_cmn* ch = HDR_CMN(p);
	hdr_bt*  bt = HDR_BT(p);

	// If no useful reception is taking place change the receiving frequency if required
	if (tdd_state_ == IDLE) {
		if (!isWithinRange(bt->xpos_, bt->ypos_)) {
			dropCnt++; 
			FREEP(p);
			return;
		}
		
		if(state_ == CONNECTION) {
			if(currentRole() == AS_MASTER) {
				bt->lid_ = AM2LID(bt->am_addr);
			}
			else {
				if(num_piconets_ && curr_piconet_ != InvalidPiconetNo)
					bt->lid_ = pid2lid(curr_piconet_);
				else {
					bt->lid_ = (uchar)-1;
					check = false;
				}
			}
		}
	}
	
	/*  find if the packet is to be received  */
	if((tdd_state_ == IDLE) && (bt->fs_ == recv_freq_) && isErrorFree(p) && isValidPacket(p)) {
		ASSERT(check);
		recv_start_ = s.clock();
		tdd_state_ = RECEIVE;
		s.schedule(&recv_handler_, p, ch->size()*8.0/BandWidth);
		tx_timer_ = (int)(2*SlotSize[bt->type]);
	}
	else {
		//if(bt->send_id_ == 0 && bt->type == BT_ID && bt->state_ == PAGE && bd_addr_ == 29 && state_==PAGE_SCAN)
		//	TRACE_BT(LEVEL_TMP, "_%d_ DISCARDING PAGED PKT %s\n", bd_addr(), bt->toString());
		FREEP(p);
		return;
	}
}

bool
Baseband::isErrorFree(Packet* p)
{
	// We need to have a reasonable error model implemented here!
	// Lacking the error model will not significantly affect the Bluetooth Inquiry operations. 
	// This is because ID packets are very short and thus, collissions are highly unlikely. 
	// The assumption here is also that there are no noise in the channel!
	return true;
}

// Determine whether the received packet is valid. 
int
Baseband::isValidPacket(Packet* p)
{
	hdr_cmn* ch = HDR_CMN(p);
	hdr_bt*  bt = HDR_BT(p);
	int access_code = 0;
	int respond = 0;
	int flag = 0;
	
	flag = (bt->fs_ == recv_freq_);	
	if (!flag)
		return flag;

	uchar 	curr_am_addr = 0;
	if (currentRole() == AS_MASTER)  
		curr_am_addr = am_addr_;
	else if(curr_piconet_ != InvalidPiconetNo)
		curr_am_addr = piconet_attr_[pid2lid(curr_piconet_)]->am_addr;
	
	switch(bt->type) {
	    case BT_ID:
		access_code = ch->uid();
		if(access_code  >= IACLow) {
			respond = !iac_filter_accept_;
			for(unsigned i = 0; i < iac_filter_.size(); i++) 
				if(iac_filter_[i] == access_code) {
					respond = iac_filter_accept_;
					break;
				}
		}

	   	flag &= ((state_ == INQ_SCAN &&  respond) || (state_ == INQ_RESP && respond) ||
			 (state_ == PAGE_SCAN && (int)access_code == bd_addr_) || 
			 (state_ == PAGE && (int)access_code == page_addr_) ||
			 (state_ == MASTER_RESP && (int)access_code == page_addr_));
		TRACE_BT(LEVEL_LOW, "BD_ADDR %d, access_code %d, respond %d, flag %d, %s %s\n", 
			  bd_addr_, access_code, respond, flag, StateTypeStr[state_], bt->toString());
		break;
	    
	    case BT_FHS:
		    flag &= ((state_ == INQUIRY) || (state_ == SLAVE_RESP) || (state_ == CONNECTION));
		break;
	
	    case BT_POLL:
	    	flag &= (state_ == CONNECTION && isActiveAsSlave());
		flag &= (curr_am_addr == 0 || curr_am_addr == bt->am_addr);
		break;

     	    default:
		flag &= (tdd_state_ == IDLE);
		flag &= ((curr_am_addr == bt->am_addr) || bt->am_addr == 0);
		flag &= (bd_addr_ == bt->recv_id_);
		flag &= (state_ == CONNECTION); //All other packets should only be received in CONNECTION state! 
		break;
	}

	// We need to check for channel access code to validate that packets are intended for this piconet.
	// We treat piconet_no as the channel access code.
	if(state_ ==  CONNECTION) {
		flag &= (curr_piconet_ == bt->piconet_no);
	}

	return flag;
}	

void
Baseband::updateRecvFreq()
{
	if(state_ == STANDBY)
		return;

	int clock; 
	int clockf;
	int address;
	FH_sequence_type hop_type;

	switch (state_) {
		
	case PAGE_SCAN:
		clock = clkn_;
		clockf = clkf_;//@GT 12/08
		//clockf = (freeze_) ? clkf_ : clock;	
		address = bd_addr_;
		hop_type = page_scan;
		break;
		
	case PAGE:
		clock = clke_;
		clockf = clkf_;//@GT 12/08
		//clockf = (freeze_) ? clkf_ : clock;	
		address = page_addr_;
		hop_type = page_hopping;
		break;
		
	case SLAVE_RESP:
		clock = clkn_;
		clockf = clkf_;
		address = bd_addr_;
		hop_type = slave_response;
		break;
		
	case MASTER_RESP:
		clock = clke_;
		clockf = clkf_;
		address = page_addr_;
		hop_type = master_response;
		break;
		
	case INQUIRY:
		clock = clkn_;
		clockf = clkf_;
		address = giac_;
		hop_type = inquiry_hopping;
		break;
		
	case INQ_SCAN:
		clock = clkn_;
		clockf = clkf_;
		address = giac_;
#ifndef VER_11
		hop_type = (freeze_) ? inquiry_response : inquiry_scan;
#else
		hop_type = inquiry_scan; //@GT 10/07
#endif
		break;
		
	case INQ_RESP:
		clock = clkn_;
		clockf = clkf_;
		address = giac_;
		hop_type = inquiry_response;
		break;		
		
	case CONNECTION:
		if(currentRole() == AS_MASTER) {
			clock = clkn_;
			address = bd_addr_;
		}
		else {
			clock = master_clk_;
			address = master_addr_;
		}
		clockf = clock;
		hop_type = channel_hopping;
		break;		
	}


	WirelessPhyBt* intf = dynamic_cast<WirelessPhyBt*>(downtarget_);
	ASSERT(intf);
	if(recv_freq_ != -1) {
		channel_->remove(recv_freq_, intf);
	}

	recv_freq_ = FH_kernel (clock, clockf, hop_type, address);
	channel_->insert(recv_freq_, intf);
	//TRACE_BT(LEVEL_TMP, "_%d_ LISTEN FREQ %d STATE %s CLOCK 0x%x CLOCKF 0x%x HOP %d ADDR %d\n", 
	//		 bd_addr(), recv_freq_, StateTypeStr[getState()], clock, clockf, hop_type, address);
}

// valid packet completely received
void
RecvHandler::handle(Event* e) 
{
	Scheduler& s = Scheduler::instance();
	Packet* p = (Packet*)e;
	hdr_cmn* ch = HDR_CMN(p);
	hdr_bt*  bt = HDR_BT(p);

	int clock, addr;
	FHS_payload* fhs;

	// calulate distance between Rx and Tx
	// double dist = distance(lm_->xpos_, lm_->ypos_, bt->xpos_, bt->ypos_);
	// evaluate loss probability for the packet 
	// double fer = lm_->calcLossProb(bt->type, dist); 
	// fer = (bt->type == BT_ID) ? 0.0 : fer;

	NsObject* uptarget = NULL;
	if(lm_->currentRole() == AS_MASTER) 
		uptarget = lm_->uptarget_;
	else if(lm_->curr_piconet_ != InvalidPiconetNo)
		uptarget = lm_->lc_[lm_->pid2lid(lm_->curr_piconet_)];

	//	if (Random::uniform() > fer) {   
	if(true) { // Packet collision should be handled in isErrorFree

		TRACE_BT(LEVEL_PACKET, "_%d_ RECV %s %s %s %d\n", lm_->bd_addr_, bt->toString(), 
			  HDR_L2CAP(p)->toString(), packet_info.name(HDR_CMN(p)->ptype()), HDR_CMN(p)->uid());

		if(lm_->last_recv_) 
			FREEP(lm_->last_recv_);
		lm_->last_recv_ = COPYP(p);
		

		// We should also remove the interface from channel_ when the entire node is on hold to speed up. 
		if((lm_->state_ == CONNECTION && lm_->curr_piconet_ !=  InvalidPiconetNo && 
		    lm_->getPnetAttr(lm_->curr_piconet_).mode == Hold && bt->recv_id_ != lm_->bd_addr())
		   || (lm_->state_ == STANDBY)) {
			//TRACE_BT(LEVEL_TMP, "_%d_ NEW FIX %s\n", lm_->bd_addr(), bt->toString());
			FREEP(p); 
			return;
		}
		
		if (bt->ph.l_ch == LMP_CHAN) {
			lm_->polled_ = 1;
			ASSERT(uptarget);
			uptarget->recv(p,lm_);
			return;
		}
		
		switch (bt->type) {
		case BT_ID:
			if (lm_->state_ == INQ_SCAN) {
				int rand = randRange(1, MaximumBackoff); // the seed is set by the TCL scripts
				// start backoff timer for upto 1024 slots and go to previous state
				if (lm_->freeze_ == 0) {
					// start a new inquiry response session 
					// freeze clock to be used for the rest of the
					// session as the current value of the native clock
					lm_->inqresp_timer_ = InqRespTO + rand; 
					lm_->freeze_ = 1;
					lm_->clkf_ = lm_->clkn_;
					lm_->nfhs_ = 0;
					lm_->beginSession(INQ_IN_PROG, InqRespTO + rand + 2); 
				}

				TRACE_BT(LEVEL_INQPG, "INQ_MSG %d***-->%d\t CLKN: %-10d code: %d backoff: %d\n", 
					 bt->send_id_, lm_->bd_addr_, lm_->clkn_, ch->uid(), rand);
				lm_->changeState(lm_->prev_state_);
				lm_->inqbackoff_timer_ = rand;
			}
			else if(lm_->state_ == INQ_RESP) {
				// First inquiry message received after backoff. 
				// sync to master clock by setting the next transmission  
				// event at exactly 625usec after we started receiving the inquiry ID packet
				TRACE_BT(LEVEL_INQPG, "INQ_MSG AFTER BO *-->%d\t CLKN: %-10d clock: %10e, code %d \n", 
					 lm_->bd_addr_, lm_->clkn_,s.clock(), ch->uid());
				// Should only schedule to respond if the session is available
				if(!lm_->resp_id_handler_.is_scheduled_) {
					lm_->resp_id_handler_.is_scheduled_ = true;
					Event* e = new Event(); 
					s.schedule(&(lm_->resp_id_handler_), e, SlotTime - (s.clock() - lm_->recv_start_));
					lm_->tx_clock_ = CLK;
				}
			}
	    	        else if(lm_->state_ == PAGE_SCAN) {

				lm_->scanned_addr_ = bt->send_id_; // debug
				lm_->beginPageRespSession();
				
				TRACE_BT(LEVEL_INQPG, "PAGE_MSG ****-->%d\t CLKN: %-10d clock: %10e CLKF: %-10d %s\n", 
					  lm_->bd_addr_, lm_->clkn_, s.clock(), lm_->clkf_, bt->toString());	
			}
	    	        else if (lm_->state_ == PAGE) {

				lm_->beginPageRespSession();
				TRACE_BT(LEVEL_INQPG, "PAGE_ACK %d-->%d\t\t CLKN: %-10d clock: %10e CLKF: %-10d %s\n", 
					  ch->uid(), lm_->bd_addr_, lm_->clkn_, s.clock(), lm_->clkf_, bt->toString());
			}
         	   	else if (lm_->state_ == MASTER_RESP) {
				// Received ack of the FHS packet
				lm_->endPageRespSession();
				TRACE_BT(LEVEL_INQPG, "FHS_ACK %d-->%d\t\t CLKN: %-10d clock: %10e\n", 
					  ch->uid(), lm_->bd_addr_, lm_->clkn_, s.clock());
			}

		        FREEP(p);
			break;

		case BT_FHS:
			fhs = (FHS_payload*)(bt->ph.data);
			addr = fhs->addr;
			clock = fhs->clock;
			
			TRACE_BT(LEVEL_INQPG, "FHS_PKT %d-->%d\t\t CLKN: %-10d CLKE: %-10d offset %-10d clock: %10e\n", 
				 addr, lm_->bd_addr_, lm_->clkn_, clock, ((lm_->clkn_ & 0xfffffffc) - clock), s.clock());
			
			if (lm_->state_ == INQUIRY) {
				// this packet may be as a result of page response FHS packet
				if(bt->state_ != INQ_RESP) { 
				// TODO: occassionally, we may be accepting the wrong FHS pkt (from page response state). 
				// Not sure whether/how the BT Spec distinguishes between the two. 
				// For now, state_ is set at the packet header and we check against that field.
					TRACE_BT(LEVEL_ERROR, "_%d_ GT_HACK DISCARDING WRONG FHS PKT %s\n", 
						 lm_->bd_addr(), bt->toString());
				}
				else {
				        // FHS packet received at the master with clock and address information
					uchar new_response = 1;
					
				        // Find if the packet corresponds to a new device discovery 
					for (unsigned i=0; i < lm_->addr_vec_.size(); i++) {
						if (lm_->addr_vec_[i]->addr == addr)
							new_response = 0;
					}
					
					if (new_response) {
						// store the info received to be sent to BThost
						FHS_payload*  info = new FHS_payload;
						info->addr = addr;
						info->clock = lm_->clockDiff(clock); 
						lm_->addr_vec_.push_back(info);
						if (lm_->addr_vec_.size() == (unsigned)lm_->num_responses_) { 
							// If the specified number of responses in the 
							// hciInquiry command have been received, 
							// send hciInquiry_Result with the info collected
							// so far and stop further inquiry 
							lm_->inquiryComplete(lm_->prev_state_); 
						}
				}
				}
			}
			else if (lm_->state_ == SLAVE_RESP) {
				if(bt->state_ != MASTER_RESP) {
					TRACE_BT(LEVEL_ERROR, "_%d_ DBG RECEIVING POTENTIALLY BAD FHS PACKET %s %s. DROPPED\n", 
						 lm_->bd_addr(), bt->toString(), StateTypeStr[bt->state_]);
				        // Bluetooth needs a better way of dealing with this stuff! 
				        // A bluetooth node in page response session might receive 
				        // an inquiry response packet accidentally.
				}
				else {
				        // if the timer has started we are already attempting to create a conn
					if(!lm_->new_connection_timer_)
						lm_->initSlaveLink(p, true);
				}
			}
			else if(lm_->state_ == CONNECTION) {
				if(addr == lm_->other_addr_ && lm_->roleChangeInProg()) {
					lm_->switchRoles(0, p);
					lm_->recvSlotOffset(-1, -1); //reset the variables
				}
			}
			FREEP(p); 
			break;
			
		case BT_POLL:
			if (lm_->new_connection_timer_) {
				// First poll pkt received by a slave 
				lm_->piconet_attr_[lm_->pid2lid(lm_->curr_piconet_)]->am_addr = bt->am_addr;
				lm_->lc_[lm_->pid2lid(lm_->curr_piconet_)]->setAmAddr(bt->am_addr);
			}
			
			// remember to reply at the next odd slot boundary 
			lm_->polled_ = 1;
			ASSERT(uptarget);
			uptarget->recv(p, lm_);
			break;
			
		case BT_NULL:
			if (lm_->new_connection_timer_) {
				// Ack for the first poll packet sent to a slave received 
				// at the master. It is safe to bring it in the piconet now
				if(lm_->page_addr_ == bt->send_id_) {
				// check whether this packet is from the node we are expecting from
					lm_->initMasterLink(bt->am_addr);
				}
				FREEP(p); 
			}
			else {
				// null packets don't contain data but might contain
				// ack hence link controller needs to know about it
				if(lm_->isActiveAsSlave())
					lm_->polled_ = 1;
				uptarget->recv(p,lm_);
			}
			break;
			
		default:
			if(lm_->currentRole() == AS_SLAVE) {
				// Remember to respond in the next odd slot
				lm_->polled_ = 1;
			}
			
			if(uptarget) 
				uptarget->recv(p,lm_);
			else {
				lm_->dropped(p);
				FREEP(p);
			}
			return; 
		}
	}
	else if (lm_->drop_)
		lm_->drop_->recv(p, lm_);
	else 
		FREEP(p);
}

void
Baseband::initMasterLink(uchar am_addr) 
{
	Scheduler& s = Scheduler::instance();
	new_connection_timer_ = 0;
	active_list_[am_addr] = page_addr_;
	num_acl_links_++;
	new_am_addr_ = 0;
	TRACE_BT(LEVEL_HIGH, "POLL_ACK %d-->%d\t\t CLK:  %-10d clock: %10e PICONET: %d AM_ADDR: %d\n", 
		  page_addr_, bd_addr_, clkn_, s.clock(), pid(), am_addr);

	// create first LMP message to be sent to the new 
	// slave. This is also the first packet that is sent
	// using stop and wait ARQ at the link controller
	scheduler()->connect(AM2LID(am_addr));
	my_piconet_attr_.mode = Active;
	updateScatCount(this, lm(page_addr_));

	// THIS MUST COME AFTER SCHED->CONNECT!!!!
	linkEstablished(AM2LID(am_addr));
}

// Delete the master link associated with AM_ADDR since the slave node is no longer active. 
void 
Baseband::delMasterLink(uchar am_addr) 
{
	if (!(am_addr > 0  && am_addr < (MaxNumSlaves + 1)))
		ASSERT(0);

	int linkId = AM2LID(am_addr);
	int addr = lid2addr(linkId, false);
	TRACE_BT(LEVEL_ACCT, "%s _%d_ DISCONNECTED: MAS %d-%d SLV\n", TraceAcctStr,
		  bd_addr(), lid2addr(linkId, true), addr); //lid2addr(linkId, false));

	new_am_addr_ = 0;
	active_list_[am_addr] = -1;

	scheduler()->disconnect(AM2LID(am_addr));

	num_acl_links_--;
	if(num_acl_links_ <= 0) {
		my_piconet_attr_.mode = Disconnected;
	}
	else {
		int hold = scheduler()->tillNextActiveLink(clkn(), NULL);
		//if(hold <= 0 && gUsingTSS)
		if (hold <= 0)
			ASSERT(0);
		my_piconet_attr_.hold_time = hold;
		my_piconet_attr_.mode = Hold;
	}
	curr_piconet_ = InvalidPiconetNo;

	if(num_acl_links_ <= 0 && num_piconets_ <= 0) 
		prev_state_ = STANDBY;

	ASSERT(getSessionInProg() == NONE_IN_PROG || getSessionInProg() == HOST_IN_PROG || 
	       getSessionInProg() == SCHED_IN_PROG || getSessionInProg() == SWITCH_IN_PROG);

	changeState(STANDBY); // don't use addr since this link has been destroyed
	reduceScatCount(this);
	linkq_[AM2LID(am_addr)]->linkDestroyed(true);
}

// Initialize a slave link based on the FHS packet P received from the master.
void
Baseband::initSlaveLink(Packet* p, bool new_conn) 
{
	hdr_bt*  bt = HDR_BT(p);

	ASSERT(bt->type == BT_FHS);
	FHS_payload* fhs = (FHS_payload*)(bt->ph.data);
	int addr = fhs->addr;
	int clock = fhs->clock;
	int piconet_no = fhs->piconet_no;

	if(scanned_addr_ != addr && !roleChangeInProg()) {
		TRACE_BT(LEVEL_MED, "_%d_ DBG ACCIDENTALLY WE HAVE RECEIVED A DIFFERENT FHS_PKT _
                         THAN EXPECTED (during pagescan)addr %d, now %d. DROPPED\n",
			 bd_addr(), scanned_addr_, addr);
		return; 
		// if we accept this packet there is a small window where we might recieve 
		// this wrong fhs_pkt before we even finish sending the page_ack back to 
		// the correct one. we should fix this or propose a modification to the standard 
		// if necessary to prevent these situations
		scanned_addr_ = addr; 
	}

	for(int i = 0; i < MaxNumLinks; i++) {
		if(link_pids_[i] == piconet_no && link_pids_[i] != InvalidPiconetNo) {
			// This rarely happens. It means that two nodes paging are on the same
			// frequency. we should fix this by dropping packets nicely.
			// this unexpected fhs packet from a node (which we already have connection to)
			// so just return;
			return;
		}
	}

	// FHS packet received from the master, send a packet 
	// 625usec after we started receiving the packet
	if(new_conn) {
		new_connection_timer_ = NewConnectionTimeout;
		b_connect_as_master_ = false;
	}

	tx_clock_ = CLK;
	num_piconets_++;

	Scheduler& s = Scheduler::instance();
	int linkId = newLid();
	double delay = SlotTime - (s.clock() - fhs->real_time);
	if(delay < 0) {
		clock += 4; // next even slot
		delay += (2*SlotTime);
	}

	if(linkId >= MaxNumLinks) {
		TRACE_BT(LEVEL_HIGH, "_%d_ MAX NUMBER OF SLAVE LINKS HAVE REACHED!\n", bd_addr());
		max_scan_period_ = clkn_ + 2;
		return;
	}

	link_pids_[linkId] = piconet_no; 

	piconet_attr_[linkId] = new con_attr;
	master_addr_ = piconet_attr_[linkId]->master_addr = addr;
	master_clk_ = piconet_attr_[linkId]->clk = clock + 1; //GT plus 1 here and another 1 in CLKHandler for odd slot
	
	piconet_attr_[linkId]->mode = Active;

	lc_[linkId]->initialize();	// Initialize LC so that SEQN are reset!

	// Remain active in the new initialized piconet by switch to it if necessary
	switchPiconet(piconet_no); 

	CLKEvent* clk_ev = new CLKEvent(piconet_no);
	s.schedule(&(clk_handler_), clk_ev, delay);
	piconet_attr_[linkId]->clk_ev_ = clk_ev;		
	polled_ = 0; 

	updateScatCount(this, lm(addr));
}

void
Baseband::delSlaveLink(int piconet_no) 
{
	num_piconets_--;
	int linkId = pid2lid(piconet_no);
	int addr = lid2addr(linkId, true);
	link_pids_[linkId] = InvalidPiconetNo;

	TRACE_BT(LEVEL_ACCT, "%s _%d_ DISCONNECTED: MAS %d-%d SLV\n", 
		  TraceAcctStr, bd_addr(), addr, lid2addr(linkId, false));

	Scheduler::instance().cancel(piconet_attr_[linkId]->clk_ev_);
	delete piconet_attr_[linkId]->clk_ev_;
	delete piconet_attr_[linkId];
	piconet_attr_[linkId] = NULL;

	curr_piconet_ = InvalidPiconetNo; // just invalidate and wait until other timers expire
	tx_clock_ = CLKN; 

	if(num_acl_links_ <= 0 && num_piconets_ <= 0)
		prev_state_ = STANDBY;

	if(!(getSessionInProg() == NONE_IN_PROG || getSessionInProg() == HOST_IN_PROG || 
	     getSessionInProg() == SCHED_IN_PROG || getSessionInProg() == SWITCH_IN_PROG))
		ASSERT(0);

	changeState(STANDBY); // don't use addr since this link has been destroyed
	reduceScatCount(this);
	linkq_[linkId]->linkDestroyed(false);

	lc_[linkId]->initialize();
}

void
Baseband::linkEstablished(int lid)
{
	if(roleChangeInProg()) {
		linkq_[lid]->roleChanged(isMasLink(lid));	
	}
	else {
		linkq_[lid]->linkEstablished(isMasLink(lid));	
	}
}

void
Baseband::detach(LMP* linkq) 
{
	int i = 0;
	for(i = 0; i < MaxNumLinks; i++)
		if(linkq == linkq_[i])
			break;

	if(i < MaxNumSlaves) {
		ASSERT(currentRole() == AS_MASTER);
		delMasterLink((uchar)i+1);
	}
	else {
		ASSERT(i < MaxNumLinks);
		if(curr_piconet_ != link_pids_[i])
			ASSERT(0);
		delSlaveLink(link_pids_[i]);
	}
}

void
Baseband::continueHold(int lid, int intv)
{
	int res = 0;
	if(mode(lid) != Hold)
		ASSERT(0);
	if(isMasLink(lid)) {
		scheduler()->hold(lid, intv, clkn_);
		int hold = scheduler()->tillNextActiveLink(clkn_, NULL);
		res = my_piconet_attr_.hold_time = max(hold, 1); //hold_timer is decremented first so 1 instead of 0
	}
	else {
		res = piconet_attr_[lid]->hold_time = intv;
	}
	TRACE_BT(LEVEL_MED, "_%d_ Baseband::continueHold CLKN %-5d LID %d INTV %d RES %d\n", 
		  bd_addr(), clkn_, lid, intv, res);
}

// Hold the link with LID for INTV ticks, i.e. from now until the master clock reached MCLK+INTV. 
// BRECV is TRUE if this node received the ACCEPTED pkt and thus, needed to send back ACK.
void
Baseband::holdLink(int lid, int intv, int mclk, bool bRcvd) 
{
	int i = 0;
	TRACE_BT(LEVEL_LOW, "_%d_ Baseband::holdLink CLKN %-5d %-5s %-5d %s\n", bd_addr(), clkn_, 
		  BTScheduler::modeString(my_piconet_attr_.mode), my_piconet_attr_.hold_time, scheduler()->toString());
	for(i= MaxNumSlaves; i < MaxNumLinks; i++) {
		if(piconet_attr_[i]) {
			TRACE_BT(LEVEL_LOW, "\tPNET %-2d %-5s %-5d\n", 
				  lid2pid(i), BTScheduler::modeString(piconet_attr_[i]->mode), piconet_attr_[i]->hold_time);
		}
	}

	if(curr_piconet_ != lid2pid(lid))
		ASSERT(0);
	if(mode(lid) != Active)
		ASSERT(0);

	Scheduler& s = Scheduler::instance();
	int ticks = 0;

	if(bRcvd) {
		if(isSessionAvail()) 
			beginSession(HOLD_IN_PROG); 
		else 
			ASSERT(0);
		// Schedule it until the next even slot so that this node can ack back the last
		// packet received before it puts LID link on hold. This is true for both master
		// and slave. 
		double time = SlotTime - (s.clock() - recv_start_) + 100*usec;
		ASSERT(time >= 0);
		switch_ev_.mclkn_ = mclk;
		switch_ev_.lid_ = lid;
		switch_ev_.b_rcvd_ = false;
		switch_ev_.intv_ = intv;
		s.schedule(&(switch_handler_), &switch_ev_, time);
		TRACE_BT(LEVEL_MED, "_%d_ Scheduling to hold link %d in %f s; cur %d next %d.\n", 
			  bd_addr_, lid, time, curr_piconet_, next_piconet_);
		return;
	}

	ticks = mclk - mclkn(lid) + intv;
	if(isMasLink(lid)) {
		scheduler()->hold(lid, ticks, clkn_);
		if(scheduler()->numLinks(Active) <= 0) {
			changeState(STANDBY, lid2addr(lid));
			holdPiconet(pid(), scheduler()->tillNextActiveLink(clkn(), NULL)); 
		}
		else {
			changeState(CONNECTION, lid2addr(lid));
		}
	}
	else {
		changeState(STANDBY, lid2addr(lid));
		holdPiconet(lid2addr(lid), ticks);
	}
	if(getSessionInProg() == HOLD_IN_PROG)
		endSession(HOLD_IN_PROG);
	host()->hciModeChangeEvent(lid, true, Hold, ticks);
} 

void 
Baseband::linkHoldExpires(int lid, bool bSuccess = true) 
{
	TRACE_BT(LEVEL_MED, "_%d_ LINK %d HOLD EXPIRES CLKN %d\n", bd_addr(), lid, clkn());
#ifdef HOLD_LINK_FOREVER
	if(isMasLink(lid)) {
		TRACE_BT(LEVEL_MED, "_%d_ GT_HACK: HOLDING MAS LINK %d FOREVER\n", bd_addr(), lid);
		holdLink(lid, MaxHoldTime * 100, clkn(), false);
		return;
	}
#endif 
	if(bSuccess) {
		changeState(CONNECTION);
		if(isMasLink(lid)) {
			scheduler()->holdExpires(lid);
		}
		curr_lid_ = lid;
		host()->hciModeChangeEvent(lid, true, Active, 0);
	}
	else {
		host()->hciHoldExpiredEvent(lid);
	}
}

int
Baseband::getNextPiconet() const {
	if(last_piconet_ == InvalidPiconetNo)
		return curr_piconet_;
	return last_piconet_;
}

// Hold PNET piconet for HOLD_TIME. If the piconet is already on hold,
// the timer is not updated. If NEXT_STATE is one of the scan states,
// switch from the current state.
void
Baseband::holdPiconet(int pnet, int hold_time)
{
	TRACE_BT(LEVEL_LOW, "_%d_ Baesband::holdPiconet PNET %d\n", bd_addr(), pnet);
	bool bUpdate = true;

	if (next_state_ == PAGE_SCAN || next_state_ == INQ_SCAN) {
		state_type cur = next_state_;
		tdd_state_ = IDLE;
		prev_state_ = state_;
		next_state_ = CONNECTION;
		changeState(cur);
		if(cur == PAGE_SCAN) {
			pagescan_timer_ = 0;
		}
		else if(cur == INQ_SCAN) {
			inqscan_timer_ = 0;
		}
		if(pnet == InvalidPiconetNo || getPnetAttr(pnet).mode == Hold)
			bUpdate = false;
	}
		if(bUpdate && pnet != InvalidPiconetNo) {
			hold_time = max(hold_time, 1);

		updateHoldTimer(getPnetAttr(pnet), hold_time);
		if(pnet != pid()) // slave
			resetPolledStates();
	}

	if(pnet == currentPiconet()) {
		curr_piconet_ = InvalidPiconetNo;
	}
}	

void
Baseband::updateHoldTimer(con_attr& attr, int hold_time) 
{
	if(attr.mode == Hold) // if it's already on hold we should not update the hold time
		attr.hold_time = min(attr.hold_time, hold_time);
	else
		attr.hold_time = hold_time;
	attr.mode = Hold;
	TRACE_BT(LEVEL_MED, "_%d_ HOLDING PICONET %d for %d ticks, next %d, last %d\n", 
		  bd_addr(), curr_piconet_, attr.hold_time, next_piconet_, last_piconet_);
}

// The hold timer has expired for NEXT piconet. We need to hold the current piconet and
// switch it to NEXT if possible. 
bool 	
Baseband::holdExpires(int next, int lid) 
{
	TRACE_BT(LEVEL_LOW, "BD_ADDR %d PICONET %d HOLD TIMER EXPIRED, cur %d %s\n", 
		  bd_addr_, next, curr_piconet_, ProgTypeStr[getSessionInProg()]);
	bool bResult = true;
	if(state_ != CONNECTION && state_ != STANDBY) 
		bResult = false; // let scan finish first 
	else if(getSessionInProg() != NONE_IN_PROG) // some session in Connection mode
		bResult = false;
	else if(new_connection_timer_) //this is like a session
		bResult = false;
	if(bResult) {
		resetPolledStates();
		if(currentPiconet() != next && currentPiconet() != InvalidPiconetNo) {
			switchPiconet(next);
		}
		else {
			switchFHInputs(next);
		}
		linkHoldExpires(lid);
	}
	else {
		if(getSessionInProg() == SCHED_IN_PROG || getSessionInProg() == HOLD_IN_PROG) {
			TRACE_BT(LEVEL_LOW, "_%d_ %s: RETRY\n", bd_addr(), ProgTypeStr[getSessionInProg()]);
		}
		else {
			linkHoldExpires(lid, false);
		}
	}
	return bResult;
}

void
SwitchHandler::handle(Event* e) 
{
	SwitchEvent* ev = static_cast<SwitchEvent*>(e);
	lm_->holdLink(ev->lid_, ev->intv_, ev->mclkn_, ev->b_rcvd_);
}

// Switch to NEXT piconet. Hold off the current piconet if necessary.
void
Baseband::switchPiconet(int next) 
{
	if(currentPiconet() != InvalidPiconetNo) {
		if(getPnetAttr(currentPiconet()).mode == Hold) {
			switchFHInputs(next);
		}
		else {
			if(getPnetAttr(currentPiconet()).mode == Active) {
				//if(!gUsingTSS)
				holdPiconet(currentPiconet(), piconet_hold_time_);
				//else {
				//	TRACE_BT(LEVEL_HIGH, "_%d_ FAILED cur %d next %d %s\n",
				//		  bd_addr(), currentPiconet(), next, ProgTypeStr[getSessionInProg()]);
				//	ASSERT(0);
				//}
			}
			switchFHInputs(next);
		}
	}
	else {
		switchFHInputs(next);
	}
}

void
Baseband::switchFHInputs(int piconet_no) 
{
	TRACE_BT(LEVEL_TMP, "BD_ADDR %d SWITCHING TO PICONET %d PARAMETERS\n", bd_addr_, piconet_no);

	tdd_state_ = IDLE;
	curr_piconet_ = piconet_no; 
	if(piconet_no != pid()) {
		piconet_attr_[pid2lid(piconet_no)]->mode = Active;
		master_addr_ = piconet_attr_[pid2lid(piconet_no)]->master_addr;
		master_clk_ = piconet_attr_[pid2lid(piconet_no)]->clk;
		tx_clock_ = CLK;
	}
	else {
		my_piconet_attr_.mode = Active;
		tx_clock_ = CLKN;
	}
}
	
void 
RespIDHandler::handle(Event* e)
{
	if (lm_->state_ == INQ_RESP) {
		lm_->sendFHSPacket();
		lm_->changeState(INQ_SCAN);
		lm_->nfhs_++;
		lm_->tx_clock_ = CLKN;
		lm_->host()->hciInqRespSentEvent();
	}
	else if (lm_->state_ == SLAVE_RESP) { 
		TRACE_BT(LEVEL_LOW,"_%d_ respidhandler CLKN %d CLKF %d CLKE %d RECVFREQ %d %s\n",
			 lm_->bd_addr(), lm_->clkn(), lm_->clkf_, lm_->clke_, lm_->recv_freq_, StateTypeStr[lm_->state_]);

		if (lm_->newconn_addr_ == -1) {
			// The first ID response
			lm_->nsr_ = 0;
			lm_->pageresp_timer_ = PageRespTO;
			lm_->sendIDPacket(lm_->bd_addr_);
			lm_->tx_clock_ = CLKN;  
		}
		else {  // The second ID response after receiving the FHS pkt
			lm_->sendIDPacket(lm_->bd_addr_);
			lm_->prepareSlvLink();
			lm_->nsr_ = 0;
			lm_->freeze_ = 0; // end the page response session
		}
	}
	delete e;
	is_scheduled_ = false;
}
	
void 
Baseband::updateInqPageParam ()
{
	int n;
	n = (state_ == INQUIRY) ? n_inq_train_ : n_page_train_;	

	// Time to change train
	if ( num_id_ == TrainSize ) 
	{
		num_id_ = 0;   // reset numpackets
	        num_trains_sent_++;
	        if ( num_trains_sent_ == n ) 
	        {
			TRACE_BT(LEVEL_INQPG, "_%d_ SWITCHING TRAIN FROM %d to %d\n",  
				 bd_addr(), train_type_, (train_type_ == A) ? B : A);
	        	num_trains_sent_ = 0;
		        train_type_ = (train_type_ == A) ? B : A;
		} 
	}	
	num_id_++;
}

void
Baseband::handleInqRespTO()
{
	inqresp_timer_ = 0;
	inqbackoff_timer_ = 0;	
	inqscan_timer_ = -TinqScan;
	freeze_ = 0;
	nfhs_ = 0;

	if(getSessionInProg() == INQ_IN_PROG) 
		endSession(INQ_IN_PROG);

	if(state_ == INQ_SCAN || state_ == INQ_RESP) {
		// Should only change it if BB is in the right state.
		changeState(prev_state_);
	}
	
}

void
Baseband::initInqPageParam()
{
	num_id_ = 0;
	train_type_ = A;
	num_trains_sent_ = 0;
}	

int
Baseband::newAmAddr()
{
	int i = 0;
	for (i=1; (active_list_[i]!=-1 && i<(MaxNumSlaves + 1)); i++)
		;
	new_am_addr_ = i;
	return new_am_addr_;
}


// clk can be Master clk, or clkn, or clke, the esimate of paged unit's clk by 
// the paging unit, clk_frozen is the frozen value of the clock when page/inquiry 
// message is received. this is same as clk, if clk is not frozen
// inquiry: clk = CLKN. page: clk = CLKE
// This procedure closely follows the Baseband Spec 1.1. The only difference is in choosing
// Y1 (ip1_EXOR2) and Y2 (ip4_ADD_79) for master/slave response and inquiry response hopping
// sequences. Instead of relying on the clk_1 bit (which does not  work) as the Spec suggested 
// we rely on the tdd_state_. 
// Also, the Baseband Spec 1.1 has some bugs in calculating the inquiry hopping sequence and as
// a result, the worst case scenario for two nodes, one in INQ and the other in INQ_SCAN, to 
// discover each other can be more than 10.24s as suggested by the Spec. 
int
Baseband::FH_kernel(int clk, int clk_frozen, FH_sequence_type fh_seq, int addr)
{
	if (addr != GIAC) {
		ASSERT(addr >= 0 && addr < MaxNumNodes);
		addr = (int)modulo(lm(addr)->uap_lap(), (unsigned)(1 << 28)); // only 28 bits are used
	}

	int res = freqCacheHit(clk, clk_frozen, fh_seq, addr);
	if(res != InvalidFreq) {
		n_hits_++;
		return res;
	}

	int ip1_ADD_32, ip1_EXOR2, ip4_ADD_79; // X, Y1, Y2
	int ip2_ADD_32, ip2_EXOR1, ip2_EXOR2, ip3_PERM, ip2_ADD_79, ip3_ADD_79; // A, B, C, D, E, F

	int Xp_or_i, Xp_or_i_rs, Xprm, k_off; 
	int ones = (int)(-1); 

	int clk_1 = subBits(clk, 1, 1); 
	int clk_12to16 = subBits(clk, 12, 5);
	int clk_frozen_12to16 = subBits(clk_frozen, 12, 5);
	int clk_0_2to4 = (clk & 0x01) + subBits(clk, 2, 3, 1);
	int clk_frozen_0_2to4 = (clk_frozen & 0x01) + subBits(clk_frozen, 2, 3, 1);
	
	if (train_type_ == A)
		k_off = 24;
	else  
		k_off = 8;

	hash_map<unsigned, addr_inputs>::const_iterator it = addr_cache_.find(addr);
	if (it == addr_cache_.end()) { 
		ip2_ADD_32 = subBits(addr, 23, 5); // A
		ip2_EXOR1 = subBits(addr, 19, 4);  // B 
		ip2_EXOR2 = subBits(addr, 0, 1, 0) + subBits(addr, 2, 1, 1) + subBits(addr, 4, 1, 2) +
			subBits(addr, 6, 1, 3) + subBits(addr, 8, 1, 4); // C
		ip3_PERM = (addr >> 10) & 0x01ff; // D
		ip2_ADD_79 = subBits(addr, 1, 1, 0) + subBits(addr, 3, 1, 1) + subBits(addr, 5, 1, 2) +
			subBits(addr, 7, 1, 3) + subBits(addr, 9, 1, 4) + subBits(addr, 11, 1, 5) +
			subBits(addr, 13, 1, 6); // E
		addr_inputs inputs;
		inputs.init(ip2_ADD_32, ip2_EXOR1, ip2_EXOR2, ip3_PERM, ip2_ADD_79);  
		addr_cache_[addr] = inputs;
	}
	else {
		ip2_ADD_32 = it->second.ip2_ADD_32_;
		ip2_EXOR1 = it->second.ip2_EXOR1_;
		ip2_EXOR2 = it->second.ip2_EXOR2_;
		ip3_PERM  = it->second.ip3_PERM_;
		ip2_ADD_79 = it->second.ip2_ADD_79_;
	}
	ip3_ADD_79 = (int) 0; // F
	
	switch  (fh_seq) {

	case inquiry_hopping:
	case page_hopping:
		Xp_or_i = modulo(clk_12to16 + k_off + modulo(clk_0_2to4 - clk_12to16, 16), 32);
		ip1_ADD_32 = Xp_or_i & 0x1f; // X
		ip1_EXOR2 = clk_1; // Y1
		ip4_ADD_79 =  32 * clk_1; // Y2
		//TRACE_BT(LEVEL_INQPG, "clk 0x%x, clk_12to16 0x%x, k_off %d, clk_0_2to4 0x%x, clk_12to16 0x%x\n", 
		//		 clk, clk_12to16, k_off, clk_0_2to4, clk_12to16);
		break;

	case page_scan:
	case inquiry_scan:
#ifndef VER11
		ip1_ADD_32 = clk_12to16;
#else
		// 1.1 says we should use the same as INQ RESPONSE for INQ_SCAN
		ip1_ADD_32 = modulo(clk_12to16 + nfhs_, 32);
#endif
		ip1_EXOR2 = 0;
		ip4_ADD_79 = 0;
		break;

	case slave_response:
		Xp_or_i_rs = modulo(clk_frozen_12to16 + nsr_, 32);
		ip1_ADD_32 = Xp_or_i_rs & 0x1f;

		if (tdd_state_ == TRANSMIT) {
			ip1_EXOR2 = (int) 1;
			ip4_ADD_79 =  (int) 32;	
		}
		else {
			ip1_EXOR2 = (int) 0;
			ip4_ADD_79 =  (int) 0;
		}
		break;
		
	case inquiry_response:
#ifndef VER_11
		Xp_or_i_rs = modulo(clk_frozen_12to16 + nfhs_, 32);
#else
		// 1.1 says frozen is unnecessary and just use clk_12to16
		Xp_or_i_rs = modulo(clk_12to16 + nfhs_, 32);
#endif
		ip1_ADD_32 = Xp_or_i_rs & 0x1f;

		if (tdd_state_ == TRANSMIT) {
			ip1_EXOR2 = (int) 1;
			ip4_ADD_79 =  (int) 32;	
		}
		else {
			ip1_EXOR2 = (int) 0;
			ip4_ADD_79 =  (int) 0;
		}
		break;

	case master_response:
		Xprm = modulo(modulo(clk_frozen_0_2to4 - clk_frozen_12to16, 16) +
			      clk_frozen_12to16 + k_off + nmr_, 32);

		ip1_ADD_32 = Xprm & 0x1f;
         
		if (tdd_state_ == TRANSMIT) {	
			ip1_EXOR2 = (int) 0;
			ip4_ADD_79 =  (int) 0;
		}
		else {
			ip1_EXOR2 = (int) 1;
			ip4_ADD_79 =  (int) 32;
		}
		break;

	case channel_hopping:
		
		int clk_2to6 = subBits(clk, 2, 5); //(int)(clk >> 2) & 0x1f;
		ip1_ADD_32 = clk_2to6;
		
		ip1_EXOR2 = clk_1;
		ip4_ADD_79 = 32 * clk_1;
		
		int clk_21to25 = subBits(clk, 21, 5); //(int)(clk >> 21) & 0x1f;
		ip2_ADD_32 = EXOR_5(ip2_ADD_32, clk_21to25);
		
		int clk_16to20 = subBits(clk, 16, 5); 
		ip2_EXOR2 = EXOR_5(ip2_EXOR2, clk_16to20);
		
		int clk_7to15 = subBits(clk, 7, 9); //(clk >> 7) & 0x01ff;
		ip3_PERM = EXOR_9(ip3_PERM, clk_7to15);
		
		int clk_7to27 = subBits(clk, 7, 21); //(int)(clk >> 7) & 0x001fffff;
		ip3_ADD_79 = modulo(16 * clk_7to27, 79) & 0x7f; 
			//(int)((16 * clk_7to27) % 79) & 0x7f;
		
		break;
	}

	// Y1 will bit-wise XORed with every bit of C
	if(ip1_EXOR2 == 1) {
		ip1_EXOR2 = ((int)ones & 0x1f);
	}

	assert(ip2_EXOR1 < (1 << 4));
	int ip1_EXOR1 = ADD_mod32(ip1_ADD_32, ip2_ADD_32); // (X + A) mod 32
	int ip1_PERM  = EXOR_5(ip1_EXOR1, ip2_EXOR1); //  ip1_EXOR xor B
	int ip2_PERM  = EXOR_5(ip1_EXOR2, ip2_EXOR2); // (Y1 extended) xor C
	int ip1_ADD_79 = PERM(ip1_PERM, ip2_PERM, ip3_PERM); // PERM(ip1_PERM, ip2_PERM, D)
	
	int index = ADD_mod79(ip1_ADD_79, ip2_ADD_79, ip3_ADD_79, ip4_ADD_79); // ip1_ADD_79, E, F, Y2
	int freq = mappedFreq(index);

	//TRACE_BT(LEVEL_INQPG, "clk 0x%x, addr 0x%x\n", clk, addr);
	//	TRACE_BT(LEVEL_INQPG, "ip1_ADD_32 %d ip2_ADD_32 %d, ip1_EXOR1 %d, ip1_PERM %d, ip2_PERM %d, ip1_ADD_79 %d, i %d, f %d\n", 
	//ip1_ADD_32, ip2_ADD_32, ip1_EXOR1, ip1_PERM, ip2_PERM, ip1_ADD_79, index, freq);

	cache_[fh_seq].init(clk, clk_frozen, fh_seq, addr, tdd_state_, 
			    nsr_, nmr_, train_type_, nfhs_, freq);
	return (int)(freq);
}

// The INDEXed frequency is remapped to a register with even freqs listed before odd freqs. 
int 
Baseband::mappedFreq(int ind)
{
	if (ind < 40) {
		return ind * 2;
	}
	else {
		return ((ind - 39) * 2) - 1;
	}
}

int
Baseband::freqCacheHit(int clk, int clk_frozen, FH_sequence_type seq, int addr) const
{
	int res;
	switch(seq) {
	case channel_hopping:
	case page_scan:
	case inquiry_scan:
		res = cache_[seq].equal(clk, addr);
		break;

	case page_hopping:
	case inquiry_hopping:
		res = cache_[seq].equal(clk, addr, train_type_);
		break;
	default:
		//case slave_response:
		//case master_response:
		//case inquiry_response:
		res = cache_[seq].equal(clk, clk_frozen, addr, tdd_state_, nsr_, nmr_, train_type_, nfhs_);
		break;
	}
	return res;
}

int 
Baseband::subBits(int bits, int start, int len, int left_shift = 0)
{
	ASSERT((start + len) <= 32 && left_shift <= 32);
	return (((bits >> start)) & ((1 << len) - 1)) << left_shift;
}

int 
Baseband::ADD_mod32(int ip1, int ip2) 
{
	return ((((((ip1 & 0x1f) + (ip2 & 0x1f))) % 32)) & 0x1f);
} 

// IP2: E, IP3: F, IP4: Y2
int 
Baseband::ADD_mod79(int ip1, int ip2, int ip3, int ip4) 
{
	//	return ((((((ip1 & 0x1f) + (ip2 & 0x7f) +
	//    (ip3 & 0x7f) + (ip4 & 0x7f))) % 79)) & 0x7f);
	return modulo((ip1 & 0x1f) + (ip2 & 0x7f) + (ip3 & 0x7f) + (ip4 & 0x3f), 79) & 0x7f;
} 


int 
Baseband::EXOR_5(int ip1, int ip2)
{
	ASSERT(ip1 >= 0  && ip2 >= 0);
	return (ip1 ^ ip2) & 0x1f;
}


int 
Baseband::EXOR_9(int ip1, int ip2)
{
	ASSERT(ip1 >= 0  && ip2 >= 0);
	//uint ip1_c= ~ip1;  
	//uint ip2_c= ~ip2;  
	//return (((ip1 & ip2_c) | (ip1_c & ip2)) & 0x01ff);
	return (ip1 ^ ip2) & 0x01ff;
}

// If CTRL bit is on swap IP1 and IP2
void
Baseband::BFLY(int ctrl, int& ip1, int& ip2)
{
	if ((ctrl & 0x01) == 1) {
		int temp = ip1;
		ip1 = ip2;
		ip2 = temp;
	}
	return;
}

// ip3 = D, 
int 
Baseband::PERM(int ip1, int ip2, int ip3)
{
	ASSERT(ip1 >= 0  && ip2 >= 0 && ip3 >= 0);

	int z[5], p[14], op;

	for (int i= 0; i < 5; i++)
		z[i] = (ip1 >> i) & 0x1;


	for (int i= 0; i < 14; i++) {
		if (i < 9)
			p[i] = ((ip3 >> i) & 0x1);
		else
			p[i] = (ip2 >> (i-9)) & 0x1;
	}

	for (int stage_bfly = 1; stage_bfly < 8; stage_bfly++) {
		switch  (stage_bfly) {
		case 1:
			BFLY(p[13], z[1], z[2]);
			BFLY(p[12], z[0], z[3]);
			break;
			
		case 2:
			BFLY(p[11], z[1], z[3]);
			BFLY(p[10], z[2], z[4]);
			break;
			
		case 3:
			BFLY(p[9], z[0], z[3]);
			BFLY(p[8], z[1], z[4]);
			break;

		case 4:
			BFLY(p[7], z[3], z[4]);
			BFLY(p[6], z[0], z[2]);
			break;

		case 5:
			BFLY(p[5], z[1], z[3]);
			BFLY(p[4], z[0], z[4]);
			break;
			
		case 6:
			BFLY(p[3], z[3], z[4]);
			BFLY(p[2], z[1], z[2]);
			break;
			
		case 7:
			BFLY(p[1], z[2], z[3]);
			BFLY(p[0], z[0], z[1]);
			break;
			
		}
	}
	
	op = z[0];
	op = op + ((z[1] << 1) & 0x02);
	op = op + ((z[2] << 2) & 0x04);
	op = op + ((z[3] << 3) & 0x08);
	op = op + ((z[4] << 4) & 0x10);
	
	return (op);
}


void
Baseband::page(int addr, int clock_offset, int pageto)
{
	TRACE_BT(LEVEL_ACCT, "_%d_ Baseband::hciCreateConnection %d -> %d clk_offset %d pageto %d\n", 
		  bd_addr(), bd_addr(), addr, clock_offset, pageto); 
	// Create Request for connection and enque it in request queue
	ConnectionRequest* cr = new ConnectionRequest; 
	cr->bd_addr = addr; 
	cr->clock_offset = clock_offset; 
	request_q_->push(cr);
	ASSERT(request_q_->size() == 1); 
	tx_clock_ = CLKN;

	if(getSessionInProg() == SCHED_IN_PROG) {
		ASSERT(0);
	}
	tm_periods_[PAGE_TM] = pageto; 
}	

// Use set/getIAC to set and get the Inquiry Access Code contained ID packets sent during Inquiry. 	
void
Baseband::inquire(int inqlen, int num_responses, int iac)
{
	TRACE_BT(LEVEL_INQPG, "_%d_ hciINQUIRY: period=%d, responses=%d, iac=%d\n", 
		  bd_addr(), inqlen, num_responses, iac);

	num_responses_ = num_responses;
	setTimer(INQ_TM, inqlen, 0);
	// Clear all the responses whenever a new session starts
	addr_vec_.clear();
	setIAC(iac);
}

void
Baseband::beginScan(timer_type type, int ticks, int window) 
{
	ASSERT(type == INQ_SCAN_TM || type == PAGE_SCAN_TM);
	setTimer(type, ticks, window);
}

void 
Baseband::cancel(timer_type type) 
{
	if(!(type == INQ_SCAN_TM || type == PAGE_SCAN_TM || type == PAGE_TM || type == INQ_TM || type == HOST_TM))
		ASSERT(0);
	tm_valid_[type] = 0;

	switch(type) {
	case INQ_SCAN_TM:
		if(getSessionInProg() != NONE_IN_PROG) 
			handleInqRespTO();
		else 
			endScan(INQ_SCAN);
		break;

	case PAGE_SCAN_TM:
		if(getSessionInProg() == PAGE_IN_PROG) {
			handlePageRespTO();
			if(new_connection_timer_) {
				ASSERT(0); 
				//handleNewConnectionTO(); // this might trigger assert as well
			}
		}
		else
			endScan(PAGE_SCAN);
		break;

	case PAGE_TM:

		if(getSessionInProg() != NONE_IN_PROG)
			ASSERT(0);
		break;

	case INQ_TM:
		if(getSessionInProg() != NONE_IN_PROG)
			ASSERT(0);
		if(state_ == INQUIRY)
			inquiryComplete(prev_state_, false);
		break;
	}
}

void
Baseband::inquiryComplete(state_type state, bool callback = true) 
{
	inq_timer_ = 0;
	initInqPageParam();	
	changeState(state);
	if(callback)
		host()->hciInquiryResult(addr_vec_);
	addr_vec_.clear();
	tm_valid_[INQ_TM] = 0;
}

double
Baseband::calcLossProb (bt_packet_type type, double dist) const
{
	dist = (dist > MaxDist) ? MaxDist : dist;
	int index = (int)(floor(dist/DistStepSize));
	return (FERvsDist[type][index]);
}


// Called back by the link controller when it drops the packet.
void 
Baseband::dropped(Packet* p) 
{
	TRACE_BT(LEVEL_LOW, "_%d_ BASEBAND DROPPED %s %s\n",
		  bd_addr(), HDR_BT(p)->toString(), HDR_L2CAP(p)->toString());
}

void    
Baseband::sendSlotOffset(int lid) 
{
	ASSERT(currentRole() == AS_SLAVE);
	linkq_[lid]->sendLMPCommand(LMP_SLOT_OFFSET, 2, clkn_ - master_clk_, bd_addr_);
	newconn_addr_ = lid2addr(lid);
}

void
Baseband::recvSlotOffset(int offset, int slv_addr) 
{
	other_offset_ = offset;
	other_addr_ = slv_addr;
	newconn_addr_ = slv_addr;
}

void
Baseband::roleChangeInProg(int b) 
{
	b_switch_ = (b) ? 1 : 0;
}

void
Baseband::switchSlaveRole(int am_addr) 
{
	// Schedule a FHS packet to be sent to the master
	ASSERT(!vip_pkt_);
	vip_pkt_ = allocPkt(BT_FHS, am_addr);
	hdr_bt* bt = HDR_BT(vip_pkt_);

	FHS_payload* fhs = (FHS_payload*)(bt->ph.data);
	fhs->piconet_no = pid();
	vip_piconet_ = curr_piconet_;

	float delay = SlotTime - (Scheduler::instance().clock() - recv_start_) + 10*usec;
	switchRoles(delay);    
}

void 
Baseband::switchRoles(float delay = 0, Event* e = NULL) 
{
	if(delay > 0) {
		Scheduler& s = Scheduler::instance();		
		s.schedule(&rswitch_handler_, (e) ? e : &intr_, delay);
		TRACE_BT(LEVEL_MED, "_%d_ Scheduling to switch roles in %f s.\n", bd_addr_, delay);
		return;
	}

	int mas = -1, slv = -1, lid = -1;
	if(curr_piconet_ == pid()) {
		// Change role with the slave
		Packet* p = (Packet*)e;
		hdr_bt* bt = HDR_BT(p);
		lid = AM2LID(bt->am_addr);
		mas = lid2addr(lid, true);
		slv = lid2addr(lid, false);

		delMasterLink(bt->am_addr); 
		initSlaveLink(p, true);
		ASSERT(new_connection_timer_); // it can't be the existing connection. 
		prepareSlvLink();
	}
	else {
		// Change role with the master of curr_piconet_
		lid = pid2lid(curr_piconet_);
		// set page_addr_ so that correct link is formed when initMasterLink is called
		int addr = lid2addr(lid); 
		mas = lid2addr(lid, true);
		slv = lid2addr(lid, false);

		delSlaveLink(curr_piconet_);
		page_addr_ = addr;
		prepareMasLink();
	}
	TRACE_BT(LEVEL_HIGH, "_%d_ SWITCHING ROLE: MAS %d <-> %d SLV\n", 
		  bd_addr(), mas, slv);
}

void
RolesSwitchHandler::handle(Event* e) 
{
	lm_->switchRoles(0, e);
}

void
Baseband::beginSession(state_progress prog, int ticks = 30, Handler* h = NULL) 
{
	TRACE_BT(LEVEL_LOW, "_%d_ BEGIN SESSION: %s %d ticks\n", 
		 bd_addr(), ProgTypeStr[prog], ticks);

	if(state_prog_ == NONE_IN_PROG) {
		sess_ev_.prog_ = prog; 
	        changeProg(prog);
		sess_ev_.handler_ = h;
		sess_ev_.ticks_ = ticks;
		Scheduler::instance().schedule(&sess_handler_, &sess_ev_, ticks*ClockTick);
	}
	else
		ASSERT(0);
}

void
Baseband::endSession(state_progress prog) 
{
	TRACE_BT(LEVEL_LOW, "_%d_ END SESSION: %s\n", bd_addr(), ProgTypeStr[prog]);

	if(state_prog_ == prog) {
	        changeProg(NONE_IN_PROG);
		Scheduler::instance().cancel(&sess_ev_);
		sess_ev_.prog_ = NONE_IN_PROG; 
		Handler* h = sess_ev_.handler_;
		sess_ev_.handler_ = NULL;
		sess_ev_.ticks_ = 0;

		// clean up code
		switch(prog) {
		case HOLD_IN_PROG:
			next_piconet_ = -1;
			break;
		}
		if(h) h->handle(NULL);
	}
	else
		ASSERT(0);
}

bool
Baseband::isSessionAvail(int lid = -1) const
{ 
	if(lid == -1)
		return state_prog_ == NONE_IN_PROG; 
	else
		return (state_prog_ == NONE_IN_PROG) && (lid2pid(lid) == curr_piconet_);
}

void
SessionHandler::handle(Event* e) 
{
	TRACE_BT(LEVEL_FUNCTION, "_%d_ SESSION TIME OUT %s\n", 
		 lm_->bd_addr(), ProgTypeStr[((SessionEvent*)e)->prog_]);
	lm_->endSession(((SessionEvent*)e)->prog_);
}

void 
Baseband::changeProg(state_progress prog) 
{
	TRACE_BT(LEVEL_FUNCTION, "_%d_ CHANGING SESSION PROGRESS: %s -> %s\n", 
		 bd_addr(), ProgTypeStr[state_prog_], ProgTypeStr[prog]);
	state_prog_ = prog;
}

state_progress
Baseband::getSessionInProg() const 
{ 
	if(state_prog_ != NONE_IN_PROG)
		return state_prog_;
	else if(roleChangeInProg())
		return SWITCH_IN_PROG;
	else if(new_connection_timer_)
		return NEW_CONN_IN_PROG; 
	return state_prog_; 
}

int
Baseband::pid() const 
{
	return bd_addr();
}

con_attr& 
Baseband::getPnetAttr(int pnet)
{
	if(pnet != pid()) {
		return *piconet_attr_[pid2lid(pnet)];
	} 
	else {
		return my_piconet_attr_;
	}
}

// Generate a new LID (link id). 
int
Baseband::newLid() const
{
	int i = -1;
	// LIDs 1-MaxNumSlaves are reserved for the slaves belonging to THIS piconet. 
	for (i= MaxNumSlaves; (link_pids_[i] != -1 && i < MaxNumLinks); i++)
		;
	ASSERT(i != -1);
	return i;
}

int     
Baseband::lid2pid(int linkIndex) const
{
	return link_pids_[linkIndex];
}

//The address of the other end node on link LINKINDEX.
int
Baseband::lid2addr(int linkIndex) const
{
	if(linkIndex < MaxNumSlaves)
		return active_list_[linkIndex+1]; //active_list_'s index starts from 1!
	return piconet_attr_[linkIndex]->master_addr;
}

int    
Baseband::pid2lid(int pid) const
{
	if(pid < 0)
		ASSERT(0);

	int res = -1;
	for(int i = MaxNumSlaves; i < MaxNumLinks; i++) {
		if(link_pids_[i] == pid) {
			res = i;
			break;
		}
	}
        if(res == -1) {
		ASSERT(0);
	}
	return res;
}

bool 
Baseband::isMasLink(int lid) const
{
	if(!(lid >= 0 && lid < MaxNumLinks))
		ASSERT(0);
	return (lid < MaxNumSlaves) ? true : false;
}

int
Baseband::lid2addr(int lid, bool bMaster) const
{
	if(lid< MaxNumSlaves) {
		if(bMaster)
			return bd_addr();
		else
			return active_list_[lid+1]; //active_list_'s index starts from 1!
	}
	else {
		if(bMaster)
			return piconet_attr_[lid]->master_addr;
		else
			return bd_addr();
	}
}

bool
Baseband::isExistingConn(int addr) const
{
	int i = 0;
	for(i = 0; i < MaxNumSlaves; i++) {
		if(addr == active_list_[i+1]) //active_list_'s index starts from 1!
			return true;
	}
	for(i = MaxNumSlaves; i < MaxNumLinks; i++) {
		if(piconet_attr_[i] && piconet_attr_[i]->master_addr == addr)
			return true;
	}
	return false;
}

int
Baseband::addr2lid(int addr) const
{
	int i = 0;
	for(i = 0; i < MaxNumSlaves; i++) {
		if(addr == active_list_[i+1]) //active_list_'s index starts from 1!
			return i;
	}
	for(i = MaxNumSlaves; i < MaxNumLinks; i++) {
		if(piconet_attr_[i] && piconet_attr_[i]->master_addr == addr)
			return i;
	}
	if(i == 0)
		ASSERT(0);
	return -1;
}

BT_mode
Baseband::mode(int lid) const
{
	if(isMasLink(lid))
		return scheduler()->mode(lid);
	return piconet_attr_[lid]->mode;
}

int
Baseband::mclkn(int lid) const
{
	if(isMasLink(lid))
		return clkn();
	return piconet_attr_[lid]->clk;
}

int
Baseband::clkn2mclkn(int lid, int clk) const
{
	if(isMasLink(lid))
		return clk;
	int mclkn = piconet_attr_[lid]->clk;
	mclkn += clk - clkn();
	return mclkn;
}

int
Baseband::mclkn2clkn(int lid, int mclkn) const
{
	if(isMasLink(lid))
		return mclkn;
	return (mclkn - piconet_attr_[lid]->clk + clkn());
}

device_role
Baseband::currentRole() const
{
	return ((curr_piconet_ == pid() && pid() != InvalidPiconetNo) ? AS_MASTER : AS_SLAVE);
}

bool    
Baseband::isActiveAsMaster() const 
{
	return (role_ & AS_MASTER);
}

bool
Baseband::isActiveAsSlave() const 
{
	return (role_ & AS_SLAVE);
}

void
Baseband::updateRole(device_role new_role) 
{
	role_ |= new_role;
}


/*=================================================================
  Timer Related Routines  
  ==================================================================*/

// Update tx_timer_ if TYPE == tx_clock_. 
void
Baseband::updateTxTimer(clock_type type)
{
	if (tx_timer_ && tx_clock_ == type) {	
		if (--(tx_timer_) == 0) {
			tdd_state_ = IDLE;
			if(tx_lid_ != -1 && lc_[tx_lid_]) {
				lc_[tx_lid_]->transmitted();
				tx_lid_ = -1; 
			}
		}
	}
}


// Activate a timer. The specified event will occur every TICKS ticks for
// WINDOW ticks. The first even occurs OFFSET ticks after setTimer is called. 
// OFFSET is only used when TYPE is INQ_SCAN_TM or PAGE_SCAN_TM. 
void 
Baseband::setTimer(timer_type type, int ticks, int window) 
{
	TRACE_BT(LEVEL_LOW, "_%d_ set_timer: %s period=%d, window=%d\n", bd_addr(), TimerTypeStr[type], ticks, window);
		
	switch(type) {
	case INQ_TM:
		// inquiry activity will stop
		inq_timer_ = ticks + 1;
		break;

	case INQ_SCAN_TM:
		// inquiry scan will periodically happen 
		inqscan_timer_ = -1; // happen right away
		break;

	case PAGE_SCAN_TM:
		// start page scan at every pagescan_timer_ ticks
		pagescan_timer_ = -1;
		break;

	case ALL_SCAN_TM:
		max_scan_period_ = ticks;
		break;
	      
	case INQ_BACKOFF_TM:
		// enter INQ_RESP state
		ASSERT(0); 		
		inqbackoff_timer_ = ticks  + 1;
		break;

	case INQ_RESP_TM:
		// will stop current INQ_SCAN or INQ_RESP activity and enter the previous state
		ASSERT(0); 		
		inqresp_timer_ = ticks + 1;
		break;

	case PAGE_TM:
		ASSERT(0); 		
		// paging activity will stop. inform host of an unsuccessful paging session.
		page_timer_ = ticks + 1;
		break;

	case PAGE_RESP_TM:
		ASSERT(0); 		
		pageresp_timer_ = ticks + 1;
		break;

	case NEW_CONN_TM:
		ASSERT(0); 		
		new_connection_timer_ = ticks + 1;
		break;

	case HOST_TM:
		host_timer_ = ticks + 1;
		break;

	default:
		ASSERT(0);
		
	}
	tm_windows_[type] = window;
	tm_periods_[type] = ticks;
	tm_valid_[type] = 1;
}

hci_cmd
Baseband::tm2hci(timer_type tm)
{
	switch(tm) {
	case INQ_TM:
		return HCI_INQ;
	case INQ_SCAN_TM: 
		return HCI_INQ_SCAN;
	case PAGE_TM: 
		return HCI_PAGE;
	case PAGE_SCAN_TM: 
		return HCI_PAGE_SCAN;
	default:
		ASSERT(0);
		return NUM_HCI_CMD;

	}
}

bool
Baseband::getTimer(timer_type type, int* period, int* window) const
{
	if(period) 
		*period = tm_periods_[type];
	if(window) 
		*window = tm_windows_[type];
	return tm_valid_[type];
}

void
Baseband::setIacFilter(vector<int>& filter, bool bAccept) 
{
	iac_filter_ = filter;
	for(unsigned i = 0; i < iac_filter_.size(); i++)
		ASSERT(iac_filter_[i] >= IACLow && iac_filter_[i] <= IACHigh);
	iac_filter_accept_ = bAccept;
}

bool
Baseband::getIacFilter(vector<int>* filter) const 
{
	if (filter) {
		copy(iac_filter_.begin(), iac_filter_.end(), filter->begin());
	}
	return iac_filter_accept_;
}

// IAC used to send out during PAGE or INQUIRY.
void
Baseband::setIAC(int iac) 
{
	iac_ = iac;
	ASSERT(iac_ >= IACLow && iac_ <= IACHigh);
}

int
Baseband::numLinks() const
{
	return num_acl_links_ + num_piconets_;
}

int
Baseband::clockDiff(int clock) const
{
	return ((clkn_ & 0xfffffffc) - clock);
}

char*
Baseband::toString() const
{
	snprintf(gBasebandBuf, BUF_LEN, "%-3d %s %s %1d:%3d tdd %d txtimer %d txclk %d polled %d", 
		 bd_addr_, StateTypeStr[state_], ProgTypeStr[getSessionInProg()], curr_piconet_, curr_lid_,
		 tdd_state_, tx_timer_, tx_clock_, (int)polled_);
	return gBasebandBuf;
}

void
Baseband::checkWrapAround(int* clk)
{
        if (*clk > MaxClock) {
		TRACE_BT(LEVEL_ACCT, "_%d_ CLOCK WRAP AROUND\n", bd_addr());
		*clk = modulo(*clk, MaxClock);
	}
}

/*=================================================================
  Misc routines
  ==================================================================*/

void
Baseband::staticInitialize()
{
	lms = new Baseband*[MaxNumNodes];
	memset(lms, 0, sizeof(Baseband*)*MaxNumNodes);
	gScatCount = 0;
	gScatHandler = new ScatHandler();
	gScatEv = new Event();
	Scheduler& s = Scheduler::instance();
	s.schedule(gScatHandler, gScatEv, 0.95);
}

extern void 
trace_hdrbt(hdr_bt* bt, const char* str) 
{
  printf("[P %-4d AM %-4d %-10s %-8s %4d -> %-4d]%s", 
	 bt->piconet_no, bt->am_addr, StateTypeStr[bt->state_], PacketTypeStr[bt->type], 
	 bt->send_id_, (bt->state_ == INQUIRY) ? -1 : bt->recv_id_, str);
}

const char* StateTypeStr[12] = {
	"STANDBY", 
	"NEW_CONNECTION",
	"CONNECTION",
	"PAGE", 
	"PAGE_SCAN",
	"SLAVE_RESP",
	"SLAVE_RESP_ID_SENT",
	"MASTER_RESP",
	"INQUIRY", 
	"INQ_SCAN", 
	"INQ_RESP",
	"INVALID_STATE",
};

const char* PacketTypeStr[15] = { 
	"BT_NULL", "BT_POLL", "BT_FHS", "BT_DM1", "BT_DH1", "BT_HV1", "BT_HV2", "BT_HV3", "BT_DV", "BT_AUX1", 
	"BT_DM3", "BT_DH3", "BT_DM5", "BT_DH5", "BT_ID"
};


const char* ProgTypeStr[9] = {
	"NONE_IN_PROG",
	"INQ_IN_PROG",
	"PAGE_IN_PROG",
	"LMP_IN_PROG",
	"HOLD_IN_PROG",
	"ROLE_SWITCH_IN_PROG",
	"HOST_IN_PROG",
	"NEW_CONN_IN_PROG",
	"SCHED_IN_PROG",
};

const char* TimerTypeStr[11] = {
	"INQ_TM",
	"INQ_SCAN_TM",
	"INQ_BACKOFF_TM",
	"INQ_RESP_TM",
	"PAGE_TM",
	"PAGE_SCAN_TM",
	"PAGE_RESP_TM",
	"NEW_CONN_TM",
	"ALL_SCAN_TM",
	"HOST_TM",
	"INVALID_TM",
};

const char* LMPCommandStr[8] = {
	"LMP_HOST_CONN_REQ",
	"LMP_QOS_REQ",
	"LMP_HOLD_REQ",
	"LMP_ACCEPTED",
	"LMP_HOLD",
	"LMP_SLOT_OFFSET",
	"LMP_SWITCH_REQ",
	"LMP_DETACH",
};


/*=================================================================
  Scatternet statistics
 ==================================================================*/

 
void
Baseband::updateScatCount(Baseband* n1, Baseband* n2) 
{
	int oldScat = 0;
	if(n2->scat_id_ < n1->scat_id_) {
		oldScat = n1->scat_id_;
		n1->prev_scat_id_ = oldScat;
		n1->scat_id_ = n2->scat_id_;
		if(gScatCount > 0) gScatCount--;
		
		for(int i = 0; i < MaxNumNodes; i++) {
			if(lm(i) && lm(i)->scat_id_ == oldScat) {
				lm(i)->prev_scat_id_ = lm(i)->scat_id_; // this is prob unnecess
				lm(i)->scat_id_ = n2->scat_id_;
			}
		}
	}
	else {
		n1->prev_scat_id_ = n1->scat_id_; // n1 wins, so write its own id
	}
}

void
Baseband::reduceScatCount(Baseband* lm) 
{
	if(lm->prev_scat_id_ != lm->scat_id_) {  
		lm->scat_id_ = lm->prev_scat_id_;
		gScatCount++;
	}

}

void 
Baseband::stopAll(bool bStop) 
{
	for(int i = 0 ; i < MaxNumNodes; i++) {
		if(lm(i))
			lm(i)->stop(bStop);
	}
}

Baseband*
Baseband::lm(int addr) 
{
	ASSERT(addr >= 0 && addr < MaxNumNodes);
	return lms[addr];
}

void
Baseband::lm(int addr, Baseband* lm) 
{
	ASSERT(addr >= 0 && addr < MaxNumNodes);
	lms[addr] = lm;
}

void 
Baseband::specialSwitch(int lid) 
{
	next_piconet_ = link_pids_[lid];
}

