/* -*-	Mode:C++; c-basic-offset:8; tab-width:8; indent-tabs-mode:t -*- */
/**************************************************************************************************
*IBM Public License Version 1.0 
*
*THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS IBM PUBLIC LICENSE ("AGREEMENT"). ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS AGREEMENT. 
*
*1. DEFINITIONS 
*
*"Contribution" means: 
*
*       a) in the case of International Business Machines Corporation ("IBM"), the Original Program, and 
*
*       b) in the case of each Contributor, 
*
*       i) changes to the Program, and
*
*       ii) additions to the Program;
*
*       where such changes and/or additions to the Program originate from and are distributed by that particular Contributor. A Contribution 'originates' from a Contributor if it
*       was added to the Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions do not include additions to the Program which: (i) are
*       separate modules of software distributed in conjunction with the Program under their own license agreement, and (ii) are not derivative works of the Program.
*
*  "Contributor" means IBM and any other entity that distributes the Program. 
*
*  "Licensed Patents " mean patent claims licensable by a Contributor which are necessarily infringed by the use or sale of its Contribution alone or when combined with the
*  Program. 
*
*  "Original Program" means the original version of the software accompanying this Agreement as released by IBM, including source code, object code and documentation, if
*  any. 
*
*  "Program" means the Original Program and Contributions. 
*
*  "Recipient" means anyone who receives the Program under this Agreement, including all Contributors. 
*
*  2. GRANT OF RIGHTS 
*
*       a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive, worldwide, royalty-free copyright license to reproduce, prepare
*       derivative works of, publicly display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, and such derivative works, in source code
*       and object code form.
*
*       b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive, worldwide, royalty-free patent license under Licensed Patents to
*       make, use, sell, offer to sell, import and otherwise transfer the Contribution of such Contributor, if any, in source code and object code form. This patent license shall
*       apply to the combination of the Contribution and the Program if, at the time the Contribution is added by the Contributor, such addition of the Contribution causes
*       such combination to be covered by the Licensed Patents. The patent license shall not apply to any other combinations which include the Contribution. No hardware per
*       se is licensed hereunder. 
*
*       c) Recipient understands that although each Contributor grants the licenses to its Contributions set forth herein, no assurances are provided by any Contributor that
*       the Program does not infringe the patent or other intellectual property rights of any other entity. Each Contributor disclaims any liability to Recipient for claims brought
*       by any other entity based on infringement of intellectual property rights or otherwise. As a condition to exercising the rights and licenses granted hereunder, each
*       Recipient hereby assumes sole responsibility to secure any other intellectual property rights needed, if any. For example, if a third party patent license is required to
*       allow Recipient to distribute the Program, it is Recipient's responsibility to acquire that license before distributing the Program.
*
*       d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its Contribution, if any, to grant the copyright license set forth in this
*       Agreement. 
*
*  3. REQUIREMENTS 
*
*  A Contributor may choose to distribute the Program in object code form under its own license agreement, provided that: 
*
*       a) it complies with the terms and conditions of this Agreement; and
*
*       b) its license agreement:
*
*       i) effectively disclaims on behalf of all Contributors all warranties and conditions, express and implied, including warranties or conditions of title and non-infringement,
*       and implied warranties or conditions of merchantability and fitness for a particular purpose; 
*
*       ii) effectively excludes on behalf of all Contributors all liability for damages, including direct, indirect, special, incidental and consequential damages, such as lost
*       profits; 
*
*       iii) states that any provisions which differ from this Agreement are offered by that Contributor alone and not by any other party; and
*
*       iv) states that source code for the Program is available from such Contributor, and informs licensees how to obtain it in a reasonable manner on or through a medium
*       customarily used for software exchange. 
*
*  When the Program is made available in source code form: 
*
*       a) it must be made available under this Agreement; and 
*
*       b) a copy of this Agreement must be included with each copy of the Program. 
*
*  Each Contributor must include the following in a conspicuous location in the Program: 
*
*       Copyright  2002 International Business Machines Corporation, 
*       Massachusetts Institute of Technology, and others. All Rights Reserved. 
*
*  In addition, each Contributor must identify itself as the originator of its Contribution, if any, in a manner that reasonably allows subsequent Recipients to identify the originator
*  of the Contribution. 
*
*  4. COMMERCIAL DISTRIBUTION 
*
*  Commercial distributors of software may accept certain responsibilities with respect to end users, business partners and the like. While this license is intended to facilitate the
*  commercial use of the Program, the Contributor who includes the Program in a commercial product offering should do so in a manner which does not create potential liability
*  for other Contributors. Therefore, if a Contributor includes the Program in a commercial product offering, such Contributor ("Commercial Contributor") hereby agrees to defend
*  and indemnify every other Contributor ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising from claims, lawsuits and other legal
*  actions brought by a third party against the Indemnified Contributor to the extent caused by the acts or omissions of such Commercial Contributor in connection with its
*  distribution of the Program in a commercial product offering. The obligations in this section do not apply to any claims or Losses relating to any actual or alleged intellectual
*  property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the Commercial Contributor in writing of such claim, and b) allow the Commercial
*  Contributor to control, and cooperate with the Commercial Contributor in, the defense and any related settlement negotiations. The Indemnified Contributor may participate in
*  any such claim at its own expense. 
*
*  For example, a Contributor might include the Program in a commercial product offering, Product X. That Contributor is then a Commercial Contributor. If that Commercial
*  Contributor then makes performance claims, or offers warranties related to Product X, those performance claims and warranties are such Commercial Contributor's
*  responsibility alone. Under this section, the Commercial Contributor would have to defend claims against the other Contributors related to those performance claims and
*  warranties, and if a court requires any other Contributor to pay any damages as a result, the Commercial Contributor must pay those damages. 
*
*  5. NO WARRANTY 
*
*  EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
*  KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT,
*  MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness of using and distributing the
*  Program and assumes all risks associated with its exercise of rights under this Agreement, including but not limited to the risks and costs of program errors, compliance with
*  applicable laws, damage to or loss of data, programs or equipment, and unavailability or interruption of operations. 
*
*  6. DISCLAIMER OF LIABILITY 
*
*  EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE ANY LIABILITY FOR ANY DIRECT,
*  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND
*  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
*  OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF ADVISED OF THE POSSIBILITY OF
*  SUCH DAMAGES. 
*
*  7. GENERAL 
*
*  If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not affect the validity or enforceability of the remainder of the terms of this
*  Agreement, and without further action by the parties hereto, such provision shall be reformed to the minimum extent necessary to make such provision valid and enforceable. 
*
*  If Recipient institutes patent litigation against a Contributor with respect to a patent applicable to software (including a cross-claim or counterclaim in a lawsuit), then any
*  patent licenses granted by that Contributor to such Recipient under this Agreement shall terminate as of the date such litigation is filed. In addition, If Recipient institutes
*  patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding combinations of the Program with other
*  software or hardware) infringes such Recipient's patent(s), then such Recipient's rights granted under Section 2(b) shall terminate as of the date such litigation is filed. 
*
*  All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the material terms or conditions of this Agreement and does not cure such failure in a
*  reasonable period of time after becoming aware of such noncompliance. If all Recipient's rights under this Agreement terminate, Recipient agrees to cease use and
*  distribution of the Program as soon as reasonably practicable. However, Recipient's obligations under this Agreement and any licenses granted by Recipient relating to the
*  Program shall continue and survive. 
*
*  IBM may publish new versions (including revisions) of this Agreement from time to time. Each new version of the Agreement will be given a distinguishing version number. The
*  Program (including Contributions) may always be distributed subject to the version of the Agreement under which it was received. In addition, after a new version of the
*  Agreement is published, Contributor may elect to distribute the Program (including its Contributions) under the new version. No one other than IBM has the right to modify this
*  Agreement. Except as expressly stated in Sections 2(a) and 2(b) above, Recipient receives no rights or licenses to the intellectual property of any Contributor under this
*  Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not expressly granted under this Agreement are reserved. 
*
*  This Agreement is governed by the laws of the State of New York and the intellectual property laws of the United States of America. No party to this Agreement will bring a
*  legal action under this Agreement more than one year after the cause of action arose. Each party waives its rights to a jury trial in any resulting litigation. 
**********************************************************************************************************************/


#ifndef bt_baseband_h
#define bt_baseband_h

#include <queue>
#include <math.h>

#include <bi-connector.h>
#include <queue.h>
#include <hash_map>


class LinkController;
class BTScheduler;
class FHChannel;
class Baseband;
class BTHost;
class LBF;
class LMP;
class TopoConstructor;
class Trace;
class LMPTestHandler;
class TaskScheduler;
class HostTask;


// Connection attributes received in hciCreate_Connection
struct ConnectionRequest {
	int 	bd_addr;
	int 	clock_offset;
	uchar   packet_type;
};


class CLKEvent : public Event {
public:
	CLKEvent(int num) : Event(), piconet_no(num) {}
	int 	piconet_no;
};


class SwitchEvent : public Event {
public:
	SwitchEvent() : Event() {}
	int     mclkn_;
	int     lid_;
	int     intv_;
	bool    b_rcvd_;
	
};


class SessionEvent : public Event {
public:
	SessionEvent() : Event(), prog_(NONE_IN_PROG) {}
	state_progress prog_;
	Handler* handler_;
	int      ticks_;
};


// Native clock (CLKN) Handler class
class CLKNHandler : public Handler {
public:
	CLKNHandler(Baseband* lm) : lm_(lm) {}
	void handle(Event* e);
	Baseband* lm_;
};


// Master clock (CLK) Handler class
class CLKHandler : public Handler {
public:
	CLKHandler(Baseband* lm) : lm_(lm) {}
	void handle(Event* e);
	Baseband* lm_;
};


// Handles received packets destined for a device
class RecvHandler : public Handler {
public:
	RecvHandler(Baseband* lm) : lm_(lm) {}
	void handle(Event* e);
	Baseband* lm_;
};


// simulates propagation delay
class TxHandler : public Handler {
public:
	TxHandler(Baseband* lm) : lm_(lm) {}
	void handle(Event* e);
	Baseband* lm_;
};


// Changes TDD state to IDLE (not used in this version)
class TDDHandler : public Handler {
public:
	TDDHandler(Baseband* lm) : lm_(lm) {}
	void handle(Event* e);
	Baseband* lm_;
};


class RespIDHandler : public Handler {
public:
	RespIDHandler(Baseband* lm) : lm_(lm), is_scheduled_(false)  {}
	void handle(Event* e);
	Baseband* lm_;
	bool is_scheduled_;
};


// To handle switching between multiple piconets
class SwitchHandler : public Handler {
public:
	SwitchHandler(Baseband* lm) : lm_(lm) {}
	void handle(Event* e);
	Baseband* lm_;
};


class RolesSwitchHandler : public Handler {
public:
	RolesSwitchHandler(Baseband* lm) : lm_(lm) {}
	void handle(Event* e);
	Baseband* lm_;
};


class SessionHandler : public Handler {
public:
	SessionHandler(Baseband* lm) : lm_(lm) {}
	void handle(Event* e);
	Baseband* lm_;
};


/*============================================================
			THE BASEBAND MODULE
 ============================================================*/

class Baseband : public BiConnector {

        // Handler classes
	friend class CLKNHandler;		
	friend class CLKHandler;		 
	friend class RecvHandler;
	friend class TxHandler;
	friend class TDDHandler;
	friend class RespIDHandler;
	friend class SwitchHandler; 
	friend class ScatHandler;
	friend class RolesSwitchHandler;
	friend class SessionHandler;
	friend class BTScheduler;

	friend class BTHost; 
	friend class LMP;
	friend class LinkController;

public:
	Baseband();

	void 	sendUp (Packet* p, Handler* h);
	int 	command (int, const char*const* );
	static  Packet* allocBBPkt(bt_packet_type pktType, int addr);
	
	// The following routines are accessed by the task scheduler (task-sched.cc) and link scheduling schemes
	// such as TSS. Most of these functions can be implemented by the upper layers by storing appropriate
	// values such as mapping of LIDs and BD_ADDRs contained as parameters to hciInquiryResults. 
	int     clkn() const { return clkn_; }
	int     mclkn(int lid) const;
	int     clkn2mclkn(int lid, int clkn) const;
	int     mclkn2clkn(int lid, int mclkn) const;
	int     clockDiff(int clock) const;
	void    checkWrapAround(int* clk);

	int     lid2addr(int lid, bool bMaster) const;
	int     lid2addr(int lid) const;
	int     addr2lid(int addr) const;
	int     numLinks() const; 
	BTHost*   host() const { return host_; }

	// For debugging, accounting, testing purposes
	char*   toString() const;
	int     startClkn() const { return start_clkn_; } 
	int     lid2pid(int lid) const;
	int     pid2lid(int pid) const;
	int     pid() const; 
	void    specialSwitch(int lid); // hack (for evaluation purposes only)
	int     currentPiconet() const { return curr_piconet_; }

	// simulation related
	double  xpos() const { return xpos_; }
	double  ypos() const { return ypos_; }
	bool    isWithinRange(double xpos, double ypos) const { return (distance(xpos_, ypos_, xpos, ypos) <= BTMaxRange); }
	inline BTScheduler* scheduler() const;
	static double    distance(double xpos, double ypos, double xpos2, double ypos2) 
	        { return sqrt(pow((xpos - xpos2), 2) + pow((ypos - ypos2), 2)); }
	static Baseband* lm(int addr);

	// TODO: after full testing; these routines should be protected
	int     roleChangeInProg() const { return b_switch_; }

protected:

	state_type getState() const { return state_; }
	bool    isMasLink(int lid) const;	
	void    setIacFilter(vector<int>& filter, bool);
	bool    getIacFilter(vector<int>* filter) const; 

	bool    isExistingConn(int addr) const; 
	void    roleChangeInProg(int b);
	BT_mode mode(int lid) const;
	int     newLid() const;
	int     bd_addr() const { return bd_addr_; }
	unsigned uap_lap() const { return uap_lap_; }
	void	start();
	void    stop(bool bStop = true); 
	int 	numResponses() const { return num_responses_; }

	// Session 
	void    beginSession(state_progress prog, int ticks = 30, Handler* h=NULL);
	void    endSession(state_progress prog);
	bool    isSessionAvail(int lid = -1) const;
	state_progress getSessionInProg() const;
	void    setTimer(timer_type type, int period, int window);
	bool    getTimer(timer_type type, int* period, int* window) const;

	// Baseband connection state machine
	void    resetState();
	void 	changeState(state_type next, int addr = -1);
	void    saveAndChangeState(state_type state);
        void    resetPolledStates();
	void    changeProg(state_progress prog);

	// Master/Slave roles
	bool    isActiveAsMaster() const;
	bool    isActiveAsSlave() const;
	void    updateRole(device_role);
	device_role currentRole() const;

	// Packets
	Packet*	sendIDPacket(int);
	void 	sendFHSPacket();
	Packet*	sendPOLLPacket(uchar);
	void 	sendNULLPacket(uchar);
	void 	sendPacket(Packet* p);
	int 	isValidPacket(Packet*);
	bool    isErrorFree(Packet*);
	double 	calcLossProb(bt_packet_type, double) const; 
	Packet* allocPkt(bt_packet_type pktType, int addr);
	
	// Inq and page
	void 	inquire(int inqlen, int num_responses, int iac);
	void	page(int addr, int offset, int pageto);
	void    beginScan(timer_type type, int ticks, int window);
	void    cancel(timer_type type);
	void 	updateInqPageParam();
	void 	initInqPageParam();
	void    inquiryComplete(state_type state, bool callback = true);
        bool	scan(state_type scan_state);
	void    endScan(state_type state);
	void 	handleInqRespTO();
	void    handleNewConnectionTO();
	void    handlePageRespTO();
	void    beginPageRespSession();
	void    endPageRespSession();
	void    setIAC(int iac);
	int     getIAC() const { return iac_; }

	// Frequency hopping
	int     freqCacheHit(int clk, int clk_frozen, FH_sequence_type fh_type, int bd_addr) const;
	void    updateRecvFreq();
        int 	FH_kernel(int clk, int clk_frozen, FH_sequence_type fh_type, int bd_addr); 
	int     mappedFreq(int ind);

	static int 	ADD_mod32(int ip1, int ip2);
	static int 	EXOR_5(int ip1, int ip2);
	static int 	EXOR_9(int ip1, int ip2);
	static int 	PERM(int ip1, int ip2, int ip3);
	static int 	ADD_mod79(int ip1, int ip2, int ip3, int ip4);
	static void  	        BFLY(int ctrl, int& ip1, int& ip2);
	static int         subBits(int bits, int start, int len, int left_shift = 0);

	// Link creation and deletion
	void    detach(LMP* lq);
	void    initSlaveLink(Packet* fhs, bool new_conn);
	void    delSlaveLink(int pid);
	void    initMasterLink(uchar am_addr);
	void    delMasterLink(uchar am_addr);
	void    linkEstablished(int lid);
	int 	newAmAddr();
	void    prepareMasLink();
	void    prepareSlvLink();

	// roles
	void    switchSlaveRole(int am_addr);
	void    switchRoles(float delay = 0, Event*  e = NULL);
	void    recvSlotOffset(int offset, int slv_addr);
	void    sendSlotOffset(int lid);
	Packet* last_recv() const { return last_recv_; }

	// Scheduling and low power modes
	void    holdLink(int lid, int intv, int mclkn, bool bRcvd);
	void    continueHold(int lid, int intv);
	void    setPiconetHoldTime(int time) { piconet_hold_time_ = time; }
	bool    holdExpires(int next, int lid);
	void    linkHoldExpires(int next, bool bSuccess = true);
	void    holdPiconet(int pid, int hold_time);
	void    updateHoldTimer(con_attr& attr, int hold_time);

	void 	switchPiconet(int next);
	void 	switchFHInputs(int);
	void 	scheduleNext();
	int     getNextPiconet() const;
        con_attr& getPnetAttr(int pnet);
	void    updateTxTimer(clock_type type);

	// misc
	void    dropped(Packet* p); 
	void    updateTimeSpent(state_type state, double dur, int addr = -1);
	int     lastEvenTick() const { return clkn_ & 0xfffffffc; }
	static  hci_cmd tm2hci(timer_type tm);

	// scatternet statistics 
	static void staticInitialize();
	static void updateScatCount(Baseband* n1, Baseband* n2);
	static void reduceScatCount(Baseband* n1);
	static void stopAll(bool bStop);
	static void lm(int addr, Baseband* lm);

protected:

	// IACs 
	int 	giac_;
	int 	diac_;
	vector<int> iac_filter_;
	int         iac_;
	bool        iac_filter_accept_;

	// piconets and links
	int 	curr_piconet_;
	int 	next_piconet_;
        int 	last_piconet_;
	int 	num_piconets_;	// # of piconets a node currently participates in. 
	con_attr  my_piconet_attr_;
	con_attr* piconet_attr_[MaxNumLinks];
	int       link_pids_[MaxNumLinks];   // Piconet IDs of links
	int       curr_lid_; //current active link
	int       tx_lid_;
	int	  active_list_[MaxNumSlaves + 1]; // active links within my piconet; 0th slot is invalid

	// addresses 
	int 	bd_addr_; // bluetooth device address [0, MaxNumDevices]
	int 	master_addr_; // current master's addr 
	int 	page_addr_;
	unsigned uap_lap_; // upper and lower address parts; this is used to generate freq hopping seq

	// clocks: native, master's, frozen and estimate
	int 	clkn_; 
	int	clkf_; 
	int	clke_;
	int     start_clkn_; // initial clock value
	int 	master_clk_; // current master's clkn

	// transmit and receive timer
	clock_type tx_clock_;
	int 	tx_timer_;
	double 	recv_start_;
	int 	recv_freq_;
	int 	reply_slot_;

	// timers/counters related to inquiry/inquiry scan 
	int 	inq_timer_;
	int 	inqscan_timer_;
	int 	inqbackoff_timer_;
	int 	inqresp_timer_;
	int	nfhs_;
	int 	num_responses_;
	vector<FHS_payload *> 	addr_vec_; // results of inquiry

	// timers/counters related to page/page scan
	int 	page_timer_;
	int 	pagescan_timer_;
	int 	pageresp_timer_;
	int 	new_connection_timer_;
	int 	nmr_; 
	int	nsr_;
	uchar 	nsr_incr_offset_;
	int  	last_paged_;
	int 	wait_timer_;
	queue<ConnectionRequest*>* request_q_;	// queue of page requests		
	int     scanned_addr_;
	int     newconn_addr_;

	// mics vars related to page and inquiry
	int 		num_id_; 
	int		num_trains_sent_;
	train_type      train_type_;
	uchar 		freeze_;
	int             n_inq_train_;
	int             n_page_train_;

	// HOLD mode related
	int 	min_hold_time_;
	int 	max_hold_time_;
	int     piconet_hold_time_;

	// state variables
	state_type      state_, prev_state_, next_state_;
	tdd_state_type  tdd_state_;
	uchar		polled_;
	state_progress  state_prog_; 
	
	// events and handlers
	Event 		clkn_ev_;		
	Event 		req_ev_;		
	Event 		tdd_ev_;		
	SwitchEvent     switch_ev_; 

	CLKNHandler		clkn_handler_;		
	CLKHandler		clk_handler_; 
	RecvHandler		recv_handler_;
	TxHandler 		tx_handler_;
	TDDHandler 		tdd_handler_;
	RespIDHandler		resp_id_handler_;
	SwitchHandler           switch_handler_;

	int 	master_index_; // 1 if a node is initially configured as the master node. 
	uchar 	am_addr_;
	uchar 	new_am_addr_;
	int 	num_acl_links_;

	double	xpos_;
	double  ypos_;

	// role switching
	int                other_offset_; // Slot offset info. from slave
	int                other_addr_;
	int                b_switch_; // 1 if roleswitch is in progress.
	double             prev_clk_;
	RolesSwitchHandler rswitch_handler_;
	int                role_;

	// sessions 
	SessionHandler     sess_handler_;
	SessionEvent       sess_ev_;
	Event              intr_;
	// The real time of the last clkn_ even tick
	double             last_even_tick_; 
	// When clkn_ has elapsed for this many ticks, all scanning activities stop.
	int64_t            max_scan_period_;

	// timer related 
	int*               tm_windows_;
	int*               tm_periods_;
	int*               tm_valid_;
	int                host_timer_;
	
	// cache 
	cache_entry*       cache_;
	int                n_hits_;

	// trace 
	Trace*             trace_;
	int 		   nam_trace_;

	// ptrs to other modules
	FHChannel*         channel_;
	LMP** 		   linkq_; // arrays of LMPs associated with all active links
	LinkController**   lc_;
	BTHost* 	   host_;
	static Baseband**  lms; // global collection of LMs
	static hash_map<unsigned, addr_inputs> addr_cache_; // address cache

	// debugging and statistics
	Packet*            last_recv_; // last packet successfully received 
	double             time_spent_[NUM_STATE];
	double             time_spent_in_conn_[MaxNumLinks];
	int                scat_id_;
	int                prev_scat_id_;

	// misc
	bool               b_stop_;
	bool               b_connect_as_master_;
	Packet*            vip_pkt_;     // special BB packet to be sent right away
	int                vip_piconet_; 

};


 
/*=============================================================
  Testing and gathering statistics 
 =============================================================*/

class ScatHandler : public Handler {
public:
	ScatHandler() {}
	void handle(Event* e);

};


#endif // bt_baseband_h


