/* -*-	Mode:C++; c-basic-offset:8; tab-width:8; indent-tabs-mode:t -*- */
/**************************************************************************************************
*IBM Public License Version 1.0 
*
*THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS IBM PUBLIC LICENSE ("AGREEMENT"). ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS AGREEMENT. 
*
*1. DEFINITIONS 
*
*"Contribution" means: 
*
*       a) in the case of International Business Machines Corporation ("IBM"), the Original Program, and 
*
*       b) in the case of each Contributor, 
*
*       i) changes to the Program, and
*
*       ii) additions to the Program;
*
*       where such changes and/or additions to the Program originate from and are distributed by that particular Contributor. A Contribution 'originates' from a Contributor if it
*       was added to the Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions do not include additions to the Program which: (i) are
*       separate modules of software distributed in conjunction with the Program under their own license agreement, and (ii) are not derivative works of the Program.
*
*  "Contributor" means IBM and any other entity that distributes the Program. 
*
*  "Licensed Patents " mean patent claims licensable by a Contributor which are necessarily infringed by the use or sale of its Contribution alone or when combined with the
*  Program. 
*
*  "Original Program" means the original version of the software accompanying this Agreement as released by IBM, including source code, object code and documentation, if
*  any. 
*
*  "Program" means the Original Program and Contributions. 
*
*  "Recipient" means anyone who receives the Program under this Agreement, including all Contributors. 
*
*  2. GRANT OF RIGHTS 
*
*       a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive, worldwide, royalty-free copyright license to reproduce, prepare
*       derivative works of, publicly display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, and such derivative works, in source code
*       and object code form.
*
*       b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive, worldwide, royalty-free patent license under Licensed Patents to
*       make, use, sell, offer to sell, import and otherwise transfer the Contribution of such Contributor, if any, in source code and object code form. This patent license shall
*       apply to the combination of the Contribution and the Program if, at the time the Contribution is added by the Contributor, such addition of the Contribution causes
*       such combination to be covered by the Licensed Patents. The patent license shall not apply to any other combinations which include the Contribution. No hardware per
*       se is licensed hereunder. 
*
*       c) Recipient understands that although each Contributor grants the licenses to its Contributions set forth herein, no assurances are provided by any Contributor that
*       the Program does not infringe the patent or other intellectual property rights of any other entity. Each Contributor disclaims any liability to Recipient for claims brought
*       by any other entity based on infringement of intellectual property rights or otherwise. As a condition to exercising the rights and licenses granted hereunder, each
*       Recipient hereby assumes sole responsibility to secure any other intellectual property rights needed, if any. For example, if a third party patent license is required to
*       allow Recipient to distribute the Program, it is Recipient's responsibility to acquire that license before distributing the Program.
*
*       d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its Contribution, if any, to grant the copyright license set forth in this
*       Agreement. 
*
*  3. REQUIREMENTS 
*
*  A Contributor may choose to distribute the Program in object code form under its own license agreement, provided that: 
*
*       a) it complies with the terms and conditions of this Agreement; and
*
*       b) its license agreement:
*
*       i) effectively disclaims on behalf of all Contributors all warranties and conditions, express and implied, including warranties or conditions of title and non-infringement,
*       and implied warranties or conditions of merchantability and fitness for a particular purpose; 
*
*       ii) effectively excludes on behalf of all Contributors all liability for damages, including direct, indirect, special, incidental and consequential damages, such as lost
*       profits; 
*
*       iii) states that any provisions which differ from this Agreement are offered by that Contributor alone and not by any other party; and
*
*       iv) states that source code for the Program is available from such Contributor, and informs licensees how to obtain it in a reasonable manner on or through a medium
*       customarily used for software exchange. 
*
*  When the Program is made available in source code form: 
*
*       a) it must be made available under this Agreement; and 
*
*       b) a copy of this Agreement must be included with each copy of the Program. 
*
*  Each Contributor must include the following in a conspicuous location in the Program: 
*
*       Copyright  2002 International Business Machines Corporation, 
*       Massachusetts Institute of Technology, and others. All Rights Reserved. 
*
*  In addition, each Contributor must identify itself as the originator of its Contribution, if any, in a manner that reasonably allows subsequent Recipients to identify the originator
*  of the Contribution. 
*
*  4. COMMERCIAL DISTRIBUTION 
*
*  Commercial distributors of software may accept certain responsibilities with respect to end users, business partners and the like. While this license is intended to facilitate the
*  commercial use of the Program, the Contributor who includes the Program in a commercial product offering should do so in a manner which does not create potential liability
*  for other Contributors. Therefore, if a Contributor includes the Program in a commercial product offering, such Contributor ("Commercial Contributor") hereby agrees to defend
*  and indemnify every other Contributor ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising from claims, lawsuits and other legal
*  actions brought by a third party against the Indemnified Contributor to the extent caused by the acts or omissions of such Commercial Contributor in connection with its
*  distribution of the Program in a commercial product offering. The obligations in this section do not apply to any claims or Losses relating to any actual or alleged intellectual
*  property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the Commercial Contributor in writing of such claim, and b) allow the Commercial
*  Contributor to control, and cooperate with the Commercial Contributor in, the defense and any related settlement negotiations. The Indemnified Contributor may participate in
*  any such claim at its own expense. 
*
*  For example, a Contributor might include the Program in a commercial product offering, Product X. That Contributor is then a Commercial Contributor. If that Commercial
*  Contributor then makes performance claims, or offers warranties related to Product X, those performance claims and warranties are such Commercial Contributor's
*  responsibility alone. Under this section, the Commercial Contributor would have to defend claims against the other Contributors related to those performance claims and
*  warranties, and if a court requires any other Contributor to pay any damages as a result, the Commercial Contributor must pay those damages. 
*
*  5. NO WARRANTY 
*
*  EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
*  KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT,
*  MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness of using and distributing the
*  Program and assumes all risks associated with its exercise of rights under this Agreement, including but not limited to the risks and costs of program errors, compliance with
*  applicable laws, damage to or loss of data, programs or equipment, and unavailability or interruption of operations. 
*
*  6. DISCLAIMER OF LIABILITY 
*
*  EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE ANY LIABILITY FOR ANY DIRECT,
*  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND
*  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
*  OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF ADVISED OF THE POSSIBILITY OF
*  SUCH DAMAGES. 
*
*  7. GENERAL 
*
*  If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not affect the validity or enforceability of the remainder of the terms of this
*  Agreement, and without further action by the parties hereto, such provision shall be reformed to the minimum extent necessary to make such provision valid and enforceable. 
*
*  If Recipient institutes patent litigation against a Contributor with respect to a patent applicable to software (including a cross-claim or counterclaim in a lawsuit), then any
*  patent licenses granted by that Contributor to such Recipient under this Agreement shall terminate as of the date such litigation is filed. In addition, If Recipient institutes
*  patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding combinations of the Program with other
*  software or hardware) infringes such Recipient's patent(s), then such Recipient's rights granted under Section 2(b) shall terminate as of the date such litigation is filed. 
*
*  All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the material terms or conditions of this Agreement and does not cure such failure in a
*  reasonable period of time after becoming aware of such noncompliance. If all Recipient's rights under this Agreement terminate, Recipient agrees to cease use and
*  distribution of the Program as soon as reasonably practicable. However, Recipient's obligations under this Agreement and any licenses granted by Recipient relating to the
*  Program shall continue and survive. 
*
*  IBM may publish new versions (including revisions) of this Agreement from time to time. Each new version of the Agreement will be given a distinguishing version number. The
*  Program (including Contributions) may always be distributed subject to the version of the Agreement under which it was received. In addition, after a new version of the
*  Agreement is published, Contributor may elect to distribute the Program (including its Contributions) under the new version. No one other than IBM has the right to modify this
*  Agreement. Except as expressly stated in Sections 2(a) and 2(b) above, Recipient receives no rights or licenses to the intellectual property of any Contributor under this
*  Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not expressly granted under this Agreement are reserved. 
*
*  This Agreement is governed by the laws of the State of New York and the intellectual property laws of the United States of America. No party to this Agreement will bring a
*  legal action under this Agreement more than one year after the cause of action arose. Each party waives its rights to a jury trial in any resulting litigation. 
**********************************************************************************************************************/

#ifndef bt_def_h
#define bt_def_h

#include <string>
#include <deque>

#include <packet.h>
#include <debug.h>
#include <util.h>


const int       InvalidPiconetNo = -1;
const char      InvalidLid = (char)-1;
const int       InvalidFreq = -1;

const double 	msec = 1e-3;
const double 	usec = 1e-6;
const double 	Mbps = 1e+6;
const double 	SlotTime = 625*usec;
const double 	ClockTick = 312.5*usec;
const double 	BandWidth = 1e+6;
const double 	PropDelay = 5*usec;
const double 	MaxRate = 0.7*Mbps;
const int       TotalQuanta = 20000;
const int    	MaxQuanta = 10000;
const int 	MaxQlen	= 100000;
const int 	MaxPollInterval[] = {300, 100};
const int 	MaxCID = 255;
const int 	MaxQueues = 7;

// Timer values: Generic Access Profile
const int 	T_GAP_103 = 98304;	// 30.72 sec
const int 	InquiryTO = 32768; 	// 10.24 sec
const int 	TinqScan = 4096;	// 1.28 sec 
const int 	TwInqScan = 36;         // 11.25 msec 
const int 	InqRespTO = 3200; 	// 1 sec
const int 	Ninq = 256;
const int 	TrainSize = 16;

const int 	L2capHdrSize = 4;	
const int 	TcpIpHdrSize = 40;
const int 	DefaultRate = 2000;

const int 	TpageScan = 4096;	// 1.28 sec
const int 	TwPageScan = 36;        // 11.25 msec
const int 	PageRespTO = 36; 	// 11.25 msec
const int 	PageTO = 8192; 		// 2.56 sec 
const int 	Npage = 128;

const int 	NewConnectionTimeout = 36; 	// 11.25 msec
const int 	MaximumBackoff = 2046;		// 1023 slots

const int	MinHoldTime = 100;
const int 	MaxHoldTime = 6400; // 2s
const int 	HoldWaitTime = 20;
const int 	PageWaitTime = 1; // wait time between successive page requests (1 means immediate)
const int       MaxClock = 0xFFFFFFF; // 28 bit clock
const int       Tretry = 2; // retry timer

// Packet Sizes
const int	IDSize = 9; 
const int	NullSize = 16; 
const int	PollSize = 16; 
const int	FHSSize = 30; 

const int       MaxDataQueSize = 60; //40 # of pkts

const double 	MaxDist = 20;
const double    DistStepSize = 1;

const int 	Payload[]  = {0, 0, 30, 21, 31, 0, 0, 0, 0, 0, 125, 187, 228, 339,   0}; //Size in bytes from DM1-DH5
const float     SlotSize[] = {1, 1,  1,  1,  1, 1, 1, 1, 1, 1,   3,   3,   5,   5, 0.5};
const int 	TotalSize[] = {0, 0, 34, 34, 44, 0, 0, 0, 0, 0, 138, 200, 0, 0, 241, 356};
const string 	StateName[] = {"ST", "NC", "C", "P", "PS", "SR", "SR", "MR", "I", "IS", "IR"}; 
const string 	ColorName[] = {"green", "brown", "blue", "red", "orange", "black", "black", "pink", "purple", "yellow", "beige"}; 
const string 	PacketColors[] = {"green", "brown", "blue", "red", "orange", "black", "crimson", "pink", "violet", "yellow", "beige", "carmine", "black", "red", "ochre", "sienna", "grey" }; 

// The following values have been hard-coded on the TCL side as well.
const int MaxNumSlaves = 7;
const int MaxNumPnets = 8;
const int MaxNumLinks = MaxNumSlaves + MaxNumPnets;

const int MaxNumNodes = 256; 
const int MaxNumTicks = 0x7fffffff;
const int MaxBtPktSize = 5;  // 5 slot pkt
const int BTMaxRange = 10; // 10m

// There are 64 IACs whose LAPs lie between 0x9e8b00 - 0x9e8b3f
const int GIAC = 0x9e8b33;
const int LIAC = 0x9e8b00;
const int IACLow  = 0x9e8b00; // start of dedicated inquiry access code
const int IACHigh = 0x9e8b3F; // end of dedicated inquiry access code
const int NUM_DIAC = 63;      // number of dedicated IACs other than GIAC

const int MinConnSetup = 100; // after a new link is established, end nodes remain active for at least this long. 
const char* const TraceAcctStr = " +";

#define BT_CLOCK() (Scheduler::instance().clock() / SlotTime)
#define TRACE_CLK(x) printf("(%.2f): %s", (Scheduler::instance().clock() / SlotTime), (const char*)(x))
#define TRACE_BT(lev, fmt, args...) \
                TRACE(lev, "(%.2f): " fmt, (Scheduler::instance().clock() / SlotTime), ## args)
/*
#define TRACE_BT(lev, fmt, args...) \
                TRACECAT(TRACECAT_NONE, lev, "(%.2f): " fmt, (Scheduler::instance().clock() / SlotTime), ## args)
*/


#define LEVEL_TIMER LEVEL_SPEC1 // baseband timers
#define LEVEL_HCI   LEVEL_SPEC2 // hci commands and events
#define LEVEL_STATE LEVEL_SPEC3 // baseband state machine
#define LEVEL_INQPG LEVEL_SPEC4 // inq and page, new conneciton related
#define LEVEL_SCHED LEVEL_SPEC5 // scheduling (hold, sniff) etc.
#define LEVEL_L2CAP LEVEL_SPEC6 // l2cap data read and write

#define LEVEL_TSF   LEVEL_SPEC7 // all tsf related
#define LEVEL_TMP   LEVEL_SPEC8 // tmp
#define LEVEL_LCS   LEVEL_SPEC9 // lcs related

#define AM2LID(x) (x-1)
#define LID2AM(x) (x+1)


// Once a connected scatternet is formed, only communication tasks are scheduled
// Useful for testing the performance of link scheduling schemes
#define  ONLYCOMM


// Testing macros: turn only one on at a time
//#define GT_TEST_ROLE_MAS   // rolesw.tcl: 0 (mas) asks 1 (slv) to switch roles. 
//#define GT_TEST_ROLE_SLV   // rolesw.tcl: 1 asks 0 to switch roles.
//#define GT_TEST_ROLE_MAS1  // rolesw1.tcl: 1 bridges 0 and 2 as slave; 2 asks 1 to switch roles.
//#define GT_TEST_ROLE_SLV1  // rolesw1.tcl: 1 asks 2 to switch roles.
//#define GT_TEST_HOLD_SLV // hold.tcl: slv->mas
//#define GT_TEST_HOLD_MAS // hold.tcl: mas->slv


/*==============================================================================
 types
 ============================================================================*/
	
typedef struct l2_cmd {
	uchar 	code;
	uchar 	identifier;
	uchar	length;
} L2cmd;

typedef enum {
	OPEN, CLOSED, W4_L2CAP_ConnectRsp, W4_L2CA_ConnectRsp
} L2CAP_state;

typedef enum { 
	Disconnected,Active,Hold,Sniff
} BT_mode;


typedef enum {
	BT_NULL, BT_POLL, BT_FHS, BT_DM1, BT_DH1, BT_HV1, BT_HV2, BT_HV3, BT_DV, BT_AUX1, 
	BT_DM3, BT_DH3, BT_DM5, BT_DH5, BT_ID, NUM_PKT_TYPES
} bt_packet_type;

// Modify this array whenever you modify  bt_packet_type
extern const char* PacketTypeStr[15]; 

struct hdr_l2cap {
	ushort 	length;
	ushort 	cid;
	L2cmd	cmd;
	static int 		offset_;
	static char     hdr_buf_[BUF_LEN];

	inline static int& 	offset() { return offset_; }
	inline static hdr_l2cap* access(Packet* p) {
		return (hdr_l2cap*)p->access(offset_);
	}

	inline const char* toString() {
		if(cmd.code) {
			snprintf(hdr_buf_, BUF_LEN, "[CH %-4d LEN %-4d CODE %-2d CMD_ID %-4d]", 
				 cid, length, cmd.code, cmd.identifier);
			return hdr_buf_;
		}
		else 
			return "";
	}
};


struct CID_attr {
	uchar 		lcid; 
	uchar 		rcid;
	uchar 		ch;
	uchar 		psm;
	int 		length; 
	int 		total_length;
	int 		identifier;
	NsObject* 	downtarget;
	Packet* 	packet;
	L2CAP_state	state;
	CID_attr() {    
		lcid = rcid = ch = psm = length = total_length = 0;
		downtarget = 0;
		packet = 0; 
		state = CLOSED;
	}
};

struct flowSpec {
	int 	mtu;
	int 	token_rate;	// multiples of kbps
	int 	token_bucket;   // bits
	int 	input_qlen;	// bits
	int 	peak_bw;	// multiples of kbps
	int  	latency;	// multiples of msec
	int	loss_sensitivity; 
};

class	CLKEvent;

struct con_attr {
	int 		clk;
	int 		master_addr;
	int 		hold_time;
	uchar 		am_addr;
	BT_mode		mode;
	bt_packet_type	packet_type;
	uchar 		polling_interval;
	con_attr() {clk = 0; am_addr = 0; hold_time = 0;}
	//GT
	CLKEvent*       clk_ev_;
};

struct WriteReq {
	Packet* pkt;
	uchar	cid;
};

typedef enum {
	page_hopping,
  	page_scan,
  	slave_response,
 	master_response,
  	inquiry_hopping,
  	inquiry_scan,
  	inquiry_response,
  	channel_hopping,
	num_sequence,
} FH_sequence_type;

typedef enum {
	STANDBY, 
	NEW_CONNECTION,
	CONNECTION,
	PAGE, 
	PAGE_SCAN,
	SLAVE_RESP,
	SLAVE_RESP_ID_SENT,
	MASTER_RESP,
	INQUIRY, 
	INQ_SCAN, 
	INQ_RESP,
	NUM_STATE,
} state_type;

// Modify this array whenever you modify  bt_packet_type
extern const char* StateTypeStr[12]; 

typedef enum {
	NONE_IN_PROG,
	INQ_IN_PROG,
	PAGE_IN_PROG,

	LMP_IN_PROG,
	HOLD_IN_PROG,
	SWITCH_IN_PROG,
	HOST_IN_PROG,
	NEW_CONN_IN_PROG,
	SCHED_IN_PROG,
} state_progress;

extern const char* ProgTypeStr[9];

typedef enum {
	TRANSMIT, 
	LISTEN,
	RECEIVE, 
	IDLE,
	RECV_WAIT
} tdd_state_type;

typedef enum {
	A, B 
} train_type;

typedef enum {
	CLKN, CLK
} clock_type;

struct access_code {
	uchar 		preamble : 4;
	uchar 		syncword[8];
	uchar 		trailer : 4;
};

typedef struct payload {
	uchar 		l_ch;
	uchar 		flow;
	unsigned int 	length;
	uchar*		data;
} BT_payload;

typedef struct fhspayload {
	int 	addr;
	int 	clock;

	// Helpful for simulation not used in actual protocol
	double  real_time; // real time at the CLOCK tick at the master
	int     piconet_no;
} FHS_payload;
	

struct hdr_bt {
	uchar 		am_addr;
	bt_packet_type  type;
	uchar           flow;
	uchar           arqn;
	uchar           seqn;
	uchar           hec;
	struct payload 	ph;

	uchar 		dir;
	int 		recv_id_;
	int 		send_id_;
	int 		piconet_no;
	int		fs_;
	double 		xpos_; 
	double 		ypos_;
		
	state_type      state_; // GT for debugging
	uchar           lid_;   // Connection ID or link ID used to index into arrays containing per-link infos

	inline bool        isSrcPkt() { return ((char)lid_ == InvalidLid); }

	inline const char* toString() {
		snprintf(hdr_buf_, BUF_LEN, "[P %-4d AM %-4d %-10s %-8s %4d -> %-4d FREQ %2d]", 
			 piconet_no, am_addr, StateTypeStr[state_], PacketTypeStr[type], 
			 send_id_, (state_ == INQUIRY) ? -1 : recv_id_, fs_);
		return hdr_buf_;
	}

	static int 	offset_;
	static char     hdr_buf_[BUF_LEN];

	inline static int& 	offset() { return offset_; }
	inline static hdr_bt* 	access(Packet* p) {
		return (hdr_bt*)p->access(offset_);
	}
	inline static void      copy(hdr_bt* dst, const hdr_bt* src) {
		memcpy((void*)dst, (const void*)src, sizeof(hdr_bt));
	}

};


struct HL_proto {
	NsObject* 	uptarget_;
	uchar		arp_table_[MaxNumNodes];
	uchar 		cid;			
	uchar		value;
};		


typedef enum {
	LMP_HOST_CONN_REQ = 0,
	LMP_QOS_REQ = 1, 
	LMP_HOLD_REQ = 2,
	LMP_ACCEPTED = 3,
	LMP_HOLD = 4, 
	LMP_SLOT_OFFSET = 5,
	LMP_SWITCH_REQ = 6,
	LMP_DETACH = 7,
	LMP_NOT_ACCEPTED = 8,
} LMP_Command;

extern const char* LMPCommandStr[8];

typedef enum {
	AS_MASTER = 0x0001,
	AS_SLAVE = 0x0002,
} device_role;


typedef enum {
	HCI_INQ = 0,     
	HCI_INQ_SCAN,
	HCI_PAGE,
	HCI_PAGE_SCAN,
	NUM_HCI_CMD,
} hci_cmd;


typedef enum {
	INQ_TM = 0,     
	INQ_SCAN_TM,
	INQ_BACKOFF_TM,
	INQ_RESP_TM,
	PAGE_TM,
	PAGE_SCAN_TM,
	PAGE_RESP_TM,
	NEW_CONN_TM,
	ALL_SCAN_TM,
	HOST_TM,
	NUM_TM,
} timer_type;

extern const char* TimerTypeStr[11];


typedef enum {
	LMP_CHAN = 0x03,
	L2CAP_CHAN = 0x0a,
	HOST_CHAN = 0x0f,
} LMP_Channel;


typedef enum {
	hciINQ_RES,
	hciCONN_COMP,
	hciCONN_REQ,
	hciDISCONN_COMP,

	hciQOS_SET_COMP,
	
	hciROLE_CHNG,
	hciMODE_CHNG,
	
	// new events
	hciINQ_RESP_SENT,
	hciSCAN_COMP,
	hciPAGE_BGN,
} hciEvent_type;


typedef struct {
	int   clk_;
	int   clk_frozen_;
	FH_sequence_type seq_;
	int   addr_;

	tdd_state_type  tdd_state_;
	int   nsr_;
	int   nmr_;
	
	train_type  train_type_;
	int         nfhs_;
	int         freq_;

        inline void init(int clk, int clk_frozen, FH_sequence_type seq, int addr, tdd_state_type tdd, 
			 int nsr, int nmr, train_type trainType, int nfhs, int freq) {
		clk_ = clk; clk_frozen_ = clk_frozen; seq_ = seq; addr_ = addr; 
		tdd_state_ = tdd, nsr_ = nsr; nmr_ = nmr; train_type_ = trainType; nfhs_ = nfhs;
		freq_ = freq;
	}

	inline int equal(int clk, int clk_frozen, int addr, tdd_state_type tdd, 
			   int nsr, int nmr, train_type trainType, int nfhs) {
		if(clk == clk_ && clk_frozen == clk_frozen_ && addr == addr_ && 
		   tdd == tdd_state_ && nsr == nsr_ && nmr == nmr_ && trainType == train_type_ && nfhs == nfhs_)
			return freq_;
		return InvalidFreq;
	}

	inline int equal(int clk, int addr) {
		if(clk == clk_ && addr == addr_)
			return freq_;
		return InvalidFreq;
	}

	inline int equal(int clk, int addr, train_type train) {
		if(clk == clk_ && addr == addr_ && train == train_type_)
			return freq_;
		return InvalidFreq;
	}

} cache_entry;


typedef struct {
	inline void init(int a, int b, int c, int d, int e) {
		ip2_ADD_32_ = a;
		ip2_EXOR1_ = b;
		ip2_EXOR2_ = c;
		ip3_PERM_ = d;
		ip2_ADD_79_ = e;
	}
	int ip2_ADD_32_;
	int ip2_EXOR1_;
	int ip2_EXOR2_;
	int ip3_PERM_;
	int ip2_ADD_79_;
} addr_inputs;


typedef enum {
	DIS_ALL = 0x00, // disable all
	EN_SWITCH = 0x01, // role switch
	EN_HOLD = 0x02,
	EN_SNIFF = 0x04,
	EN_PARK = 0x08,
	EN_CONN = 0x10, 	// The following operations should be turned on.
} link_policy;


typedef enum {
	SEND_CMD,  // send command or request
	RECV_CMD,  // received cmmd or req
	SEND_ACCP, // send accept
	RECV_ACCP,
	SEND_REJ,  // send reject
	RECV_REJ,
} LMP_proto_step;


// Task type 
typedef enum {
	INQ_TSK,
	INQ_SCAN_TSK,
	PAGE_TSK,
	PAGE_SCAN_TSK,
	COMM_TSK,
	NUM_TSK
} task_type;


typedef enum {
	TASK_BEGIN, // Task has begun
	TASK_END,
	TASK_CANCEL,
} task_status;


typedef enum {
	LINK_DISCON,
	LINK_ACTIVE,
	LINK_NEGO,  // Nodes are negotiating the next meeing time
	LINK_HOLD,
} link_state;


/*==============================================================================
 global functions and variables
 ============================================================================*/

class TSF;
class Baseband;
class ScatHandler;

extern void      trace_hdrbt(hdr_bt* bt, const char* str);
extern Packet*   dequePkt(deque<Packet*>& q, int pktSize);
extern int       printNodes(int type, bool bPrint = true);
extern uchar     lookupLidTsf(int src, int dst, int in);

extern int gMaxBDAddr;
extern int gTmp, gTmpAddr, gTmpClk; // for debugging

extern TSF** gHosts;
extern int gHostMaxAddr;

extern int gScatCount;
extern ScatHandler* gScatHandler;
extern Event* gScatEv;
extern int gNodeCount;

extern int  gNumFreeNodes;
extern int  gNumRootNodes;


#endif

