/* -*-	Mode:C++; c-basic-offset:8; tab-width:8; indent-tabs-mode:t -*- */
/**************************************************************************************************
*IBM Public License Version 1.0 
*
*THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS IBM PUBLIC LICENSE ("AGREEMENT"). ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS AGREEMENT. 
*
*1. DEFINITIONS 
*
*"Contribution" means: 
*
*       a) in the case of International Business Machines Corporation ("IBM"), the Original Program, and 
*
*       b) in the case of each Contributor, 
*
*       i) changes to the Program, and
*
*       ii) additions to the Program;
*
*       where such changes and/or additions to the Program originate from and are distributed by that particular Contributor. A Contribution 'originates' from a Contributor if it
*       was added to the Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions do not include additions to the Program which: (i) are
*       separate modules of software distributed in conjunction with the Program under their own license agreement, and (ii) are not derivative works of the Program.
*
*  "Contributor" means IBM and any other entity that distributes the Program. 
*
*  "Licensed Patents " mean patent claims licensable by a Contributor which are necessarily infringed by the use or sale of its Contribution alone or when combined with the
*  Program. 
*
*  "Original Program" means the original version of the software accompanying this Agreement as released by IBM, including source code, object code and documentation, if
*  any. 
*
*  "Program" means the Original Program and Contributions. 
*
*  "Recipient" means anyone who receives the Program under this Agreement, including all Contributors. 
*
*  2. GRANT OF RIGHTS 
*
*       a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive, worldwide, royalty-free copyright license to reproduce, prepare
*       derivative works of, publicly display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, and such derivative works, in source code
*       and object code form.
*
*       b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive, worldwide, royalty-free patent license under Licensed Patents to
*       make, use, sell, offer to sell, import and otherwise transfer the Contribution of such Contributor, if any, in source code and object code form. This patent license shall
*       apply to the combination of the Contribution and the Program if, at the time the Contribution is added by the Contributor, such addition of the Contribution causes
*       such combination to be covered by the Licensed Patents. The patent license shall not apply to any other combinations which include the Contribution. No hardware per
*       se is licensed hereunder. 
*
*       c) Recipient understands that although each Contributor grants the licenses to its Contributions set forth herein, no assurances are provided by any Contributor that
*       the Program does not infringe the patent or other intellectual property rights of any other entity. Each Contributor disclaims any liability to Recipient for claims brought
*       by any other entity based on infringement of intellectual property rights or otherwise. As a condition to exercising the rights and licenses granted hereunder, each
*       Recipient hereby assumes sole responsibility to secure any other intellectual property rights needed, if any. For example, if a third party patent license is required to
*       allow Recipient to distribute the Program, it is Recipient's responsibility to acquire that license before distributing the Program.
*
*       d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its Contribution, if any, to grant the copyright license set forth in this
*       Agreement. 
*
*  3. REQUIREMENTS 
*
*  A Contributor may choose to distribute the Program in object code form under its own license agreement, provided that: 
*
*       a) it complies with the terms and conditions of this Agreement; and
*
*       b) its license agreement:
*
*       i) effectively disclaims on behalf of all Contributors all warranties and conditions, express and implied, including warranties or conditions of title and non-infringement,
*       and implied warranties or conditions of merchantability and fitness for a particular purpose; 
*
*       ii) effectively excludes on behalf of all Contributors all liability for damages, including direct, indirect, special, incidental and consequential damages, such as lost
*       profits; 
*
*       iii) states that any provisions which differ from this Agreement are offered by that Contributor alone and not by any other party; and
*
*       iv) states that source code for the Program is available from such Contributor, and informs licensees how to obtain it in a reasonable manner on or through a medium
*       customarily used for software exchange. 
*
*  When the Program is made available in source code form: 
*
*       a) it must be made available under this Agreement; and 
*
*       b) a copy of this Agreement must be included with each copy of the Program. 
*
*  Each Contributor must include the following in a conspicuous location in the Program: 
*
*       Copyright  2002 International Business Machines Corporation, 
*       Massachusetts Institute of Technology, and others. All Rights Reserved. 
*
*  In addition, each Contributor must identify itself as the originator of its Contribution, if any, in a manner that reasonably allows subsequent Recipients to identify the originator
*  of the Contribution. 
*
*  4. COMMERCIAL DISTRIBUTION 
*
*  Commercial distributors of software may accept certain responsibilities with respect to end users, business partners and the like. While this license is intended to facilitate the
*  commercial use of the Program, the Contributor who includes the Program in a commercial product offering should do so in a manner which does not create potential liability
*  for other Contributors. Therefore, if a Contributor includes the Program in a commercial product offering, such Contributor ("Commercial Contributor") hereby agrees to defend
*  and indemnify every other Contributor ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising from claims, lawsuits and other legal
*  actions brought by a third party against the Indemnified Contributor to the extent caused by the acts or omissions of such Commercial Contributor in connection with its
*  distribution of the Program in a commercial product offering. The obligations in this section do not apply to any claims or Losses relating to any actual or alleged intellectual
*  property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the Commercial Contributor in writing of such claim, and b) allow the Commercial
*  Contributor to control, and cooperate with the Commercial Contributor in, the defense and any related settlement negotiations. The Indemnified Contributor may participate in
*  any such claim at its own expense. 
*
*  For example, a Contributor might include the Program in a commercial product offering, Product X. That Contributor is then a Commercial Contributor. If that Commercial
*  Contributor then makes performance claims, or offers warranties related to Product X, those performance claims and warranties are such Commercial Contributor's
*  responsibility alone. Under this section, the Commercial Contributor would have to defend claims against the other Contributors related to those performance claims and
*  warranties, and if a court requires any other Contributor to pay any damages as a result, the Commercial Contributor must pay those damages. 
*
*  5. NO WARRANTY 
*
*  EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
*  KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT,
*  MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness of using and distributing the
*  Program and assumes all risks associated with its exercise of rights under this Agreement, including but not limited to the risks and costs of program errors, compliance with
*  applicable laws, damage to or loss of data, programs or equipment, and unavailability or interruption of operations. 
*
*  6. DISCLAIMER OF LIABILITY 
*
*  EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE ANY LIABILITY FOR ANY DIRECT,
*  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND
*  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
*  OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF ADVISED OF THE POSSIBILITY OF
*  SUCH DAMAGES. 
*
*  7. GENERAL 
*
*  If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not affect the validity or enforceability of the remainder of the terms of this
*  Agreement, and without further action by the parties hereto, such provision shall be reformed to the minimum extent necessary to make such provision valid and enforceable. 
*
*  If Recipient institutes patent litigation against a Contributor with respect to a patent applicable to software (including a cross-claim or counterclaim in a lawsuit), then any
*  patent licenses granted by that Contributor to such Recipient under this Agreement shall terminate as of the date such litigation is filed. In addition, If Recipient institutes
*  patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding combinations of the Program with other
*  software or hardware) infringes such Recipient's patent(s), then such Recipient's rights granted under Section 2(b) shall terminate as of the date such litigation is filed. 
*
*  All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the material terms or conditions of this Agreement and does not cure such failure in a
*  reasonable period of time after becoming aware of such noncompliance. If all Recipient's rights under this Agreement terminate, Recipient agrees to cease use and
*  distribution of the Program as soon as reasonably practicable. However, Recipient's obligations under this Agreement and any licenses granted by Recipient relating to the
*  Program shall continue and survive. 
*
*  IBM may publish new versions (including revisions) of this Agreement from time to time. Each new version of the Agreement will be given a distinguishing version number. The
*  Program (including Contributions) may always be distributed subject to the version of the Agreement under which it was received. In addition, after a new version of the
*  Agreement is published, Contributor may elect to distribute the Program (including its Contributions) under the new version. No one other than IBM has the right to modify this
*  Agreement. Except as expressly stated in Sections 2(a) and 2(b) above, Recipient receives no rights or licenses to the intellectual property of any Contributor under this
*  Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not expressly granted under this Agreement are reserved. 
*
*  This Agreement is governed by the laws of the State of New York and the intellectual property laws of the United States of America. No party to this Agreement will bring a
*  legal action under this Agreement more than one year after the cause of action arose. Each party waives its rights to a jury trial in any resulting litigation. 
**********************************************************************************************************************/

/*==============================================================================
  Simulates a scheduling scheme which is a slight variation 
  of Deficit Round Robin (DRR). 
  This file is not used in Blueware 1.0 instead BTScheuler (the round-robin scheduler) is used. 
  ============================================================================*/


#include <bt-core.h>

// Bluehoc implementation is funky. The following macro will ensure links are served in round-robin fashion. 
#define  REAL_DRR


static class BT_DRRClass : public TclClass 
{
public:
	BT_DRRClass() : TclClass("BT_DRR"){}
	TclObject* create( int, const char*const*) {
	 	return (new BT_DRRScheduler);
	}
} class_drr;

BT_DRRScheduler::BT_DRRScheduler() : ph_(this), curr_queue_(0), num_flows_(0), slots_per_cycle_(0), nextround_(1)
{
	bind("cycle_time_", &cycle_time_);

	for (int i=0; i < MaxQueues; i++) {
		rate_[i] = 0;
		tos_[i] = 0;
		dc_[i] = 3000;
		incr_[i] = 0;
		backlog_fwd_[i] = 0;
		backlog_rev_[i] = 0;
		mode_[i] = Disconnected;
		hold_start_[i] = 0x7fffffff;
		hold_end_[i] = 0x7fffffff;
		quanta_[i] = 1000;		
		max_poll_interval_[i] = 40;
	}
	
	poll_event_ = new (PollEvent*)[MaxQueues];
	memset(poll_event_, 0, (sizeof(PollEvent*) * MaxQueues));

	poll_q_ = new PacketQueue();
	lc_ = new (NsObject*)[MaxQueues];
	memset(lc_, 0, (sizeof(NsObject*) * MaxQueues));
}

int BT_DRRScheduler::command(int argc, const char*const* argv)
{
	Tcl& tcl = Tcl::instance();
	if (argc == 4) {
		if (strcmp(argv[1], "install") == 0) {
			int slot = atoi(argv[2]);
			lc_[slot] = (NsObject*)TclObject::lookup(argv[3]);
			return (TCL_OK);
		}
	}
	return (BiConnector::command(argc, argv));
}

uchar
BT_DRRScheduler::mapQoS (uchar ch, flowSpec* qos, con_attr* qoslm_)
{
	bt_packet_type type;
	int mtu = qos->mtu;
	double rate = qos->token_rate*1000;

	// If application is loss sensitive, use FEC
	if (qos->loss_sensitivity) {
		// select appropriate packet type based on MTU
		ASSERT(0);
		// @GT fix the following code which used the old ENUM typedef where BT_DM5 = 0x0e see l2cap.cc and bt-def.h
		if ((mtu > Payload[14]) || ((mtu <= Payload[14]) && (mtu > Payload[10])))
			type = BT_DM5;
		else if (mtu <= Payload[10] && mtu > Payload[3])
			type = BT_DM3;
		else 
			type = BT_DM1;
	}
	else {
		ASSERT(0);
		// @GT fix the following code which used the old ENUM typedef where BT_DM5 = 0x0e see l2cap.cc and bt-def.h
		// select appropriate packet type based on MTU
		if ((mtu > Payload[15]) || ((mtu <= Payload[15]) && (mtu > Payload[11])))
			type = BT_DH5;
		else if (mtu <= Payload[11] && mtu > Payload[4])
			type = BT_DH3;
		else 
			type = BT_DH1;
	}	
	int pi = (int)(Payload[type]*8/(rate*SlotTime));
	uchar result = updateQuanta(ch, qos->token_rate, type);
	if (result) {
		qoslm_->packet_type = type;
		qoslm_->polling_interval = pi;  	// To be used when QoS is reserved
		                                        // in the reverse direcetion as well
	}
	return result;
}

/* Does admission control based on slot 
availability within cycle time. Admission
control can be improved upon
*/
uchar
BT_DRRScheduler::updateQuanta (uchar ch, int token_rate, bt_packet_type type)
{
	double slots;
	int quanta; 
	if (token_rate == -1) {
		slots = 0.5*(cycle_time_/SlotTime - slots_per_cycle_);
		quanta_[ch] = (int)(slots*Payload[type]*8)/(1+(int)SlotSize[type]);
		slots_per_cycle_ += slots;
		num_flows_ ++; 
		mode_[ch] = Active;
		return 1;
	}
	if (token_rate == 0) 
		quanta = (int)(cycle_time_*DefaultRate);
	else {
		quanta = (int)(cycle_time_*token_rate*1000);
	}

	slots = ((int)(1+SlotSize[type]))*(quanta/(Payload[type]*8));
	if ((slots+slots_per_cycle_)*SlotTime < cycle_time_) {
		slots_per_cycle_ += slots;
		num_flows_ ++; 
		mode_[ch] = Active;
		quanta_[ch] = quanta;
		return 1;
	}
	else 
		return 0;
}	

/* Return the next packet to be scheduled */
#ifdef REAL_DRR
Packet* 
BT_DRRScheduler::schedule_next(int clkn) {

	clkn_ = clkn;
	for (int i = curr_queue_; i < curr_queue_ + MaxQueues; i++) {
		int j = i%MaxQueues;
		
		if (hold_start_[j] < clkn) {
			mode_[j] = Hold;
			hold_start_[j] = 0x7fffffff;
		}
		if (hold_end_[j] < clkn) {
			mode_[j] = Active;
			hold_end_[j] = 0x7fffffff;
		}
	}

	uchar queue_no = nextActive();
	if(queue_no == (uchar)-1)
		return NULL;

	LinkController* lc = (LinkController*)lc_[queue_no];
	Packet* p_sched = lc->send(5);
	if(!p_sched) {
		/* create a poll packet for the next queue with am_addr_ = queue_no+1 */
		p_sched = createPOLLpacket(queue_no+1);
	}
	return p_sched;
}


#else // !REAL_DRR
Packet* 
BT_DRRScheduler::schedule_next(int clkn)
{
	Scheduler& s = Scheduler::instance();
	Packet* p_sched = 0;
	int queue_no = -1;
	clkn_ = clkn;
	/* start from the current queue */
	for (int i = curr_queue_; i < curr_queue_ + MaxQueues; i++) {
		int j = i%MaxQueues;

		if (hold_start_[j] < clkn) {
			mode_[j] = Hold;
			hold_start_[j] = 0x7fffffff;
		}
		if (hold_end_[j] < clkn) {
			mode_[j] = Active;
			hold_end_[j] = 0x7fffffff;
		}

		/* if a round is over indicate that DC can be increased now*/
		if ((j == 0)&& nextround_) {
			nextround_ = 0;
			for (int i=0; i< MaxQueues; i++) 
				incr_[i] = 0;
		}
		LinkController* lc = (LinkController*)lc_[j];

		/* see if the the current register at the link controller 
		corresponding to the current queue has any data to send */
		
		int size = lc->pktSize();

		/* mark the queue backlogged in the forward direction if 
		it has a non-zero packet size */

		backlog_fwd_[j] = size ? 1 : 0;
		size <<= 3;

		/* Find if the flow (forward + reverse) is backlogged */
		uchar	backlogged = (backlog_fwd_[j] || backlog_rev_[j]);
		if (backlogged && (mode_[j] != Hold)) {
			/* If the DC hasn't already been incremented this
			round, increment it */
			if (incr_[j] == 0) {
				dc_[j] = MIN(MaxQuanta,dc_[j]+quanta_[j]);
				incr_[j] = 1;
			}
			/* If the packetsize to be transmitted in less than 
			DC get the packet from the current register of the 
			link controller */
			if (size < dc_[j]) {
				curr_queue_ = queue_no = j;
				p_sched = lc->send();
				break;
			}
		} else 
			dc_[j] = 0;
		nextround_ = 1;
	}

	if (p_sched) {
		hdr_bt* bt = HDR_BT(p_sched);
		dc_[queue_no] -= (Payload[bt->type])<<3;			
	}
	else {
		if (queue_no < 0) {
			/* if the round resulted in no packet being scheduled
			find the next active queue */
			if (num_flows_) queue_no = nextActive();
			else return 0;
		}
		// There could still be packet in the queue which does not have enough dc_[que] 
		LinkController* lc = (LinkController*)lc_[queue_no];
		p_sched = lc->send();
		if(!p_sched) {
			/* create a poll packet for the next queue with am_addr_ = queue_no+1 */
			p_sched = createPOLLpacket(queue_no+1);
		}
	}
	return p_sched;
}
#endif //REAL_DRR

// Find the next active queue
uchar
BT_DRRScheduler::nextActive()
{
	int i = 0;
	for (i=0; i<MaxQueues; i++) {
		curr_queue_ = (curr_queue_+1)%MaxQueues;
		if (mode_[curr_queue_] == Active)
			break;
	}
#ifdef REAL_DRR
	if(i >= MaxQueues)
		return (uchar)-1;
	else
		return curr_queue_;
#else	
	return curr_queue_;
#endif
}

void
BT_DRRScheduler::hold(uchar am_addr, int hold_time)
{
	int index = am_addr-1;
	backlog_fwd_[index] = backlog_rev_[index] = 0;
	hold_start_[index] = clkn_ + 20;
	hold_end_[index] = clkn_ + hold_time;
}


// handle a packet going up the stack
void 
BT_DRRScheduler::sendUp (Packet* p, Handler* h)
{
	hdr_cmn* ch = HDR_CMN(p);
	hdr_bt* bt = HDR_BT(p);
	int size = Payload[bt->type];

	int index = bt->am_addr -1;
	if(index < 0 || index >= MaxNumLinks) {
		return;
		//ASSERT(0);
	}
	/* if packetsize is non-zero, mark flow as 
	backlogged in the reverse direction */
	backlog_rev_[index] = (size) ? 1 : 0;
	lc_[index]->recv(p,this);
}		

/* This function not used now, will be required when 
   'traffic' is sent in the reverse direction as well
*/
void
BT_DRRScheduler::schedulePoll(int index)
{
	Scheduler& s = Scheduler::instance(); 
	s.cancel(poll_event_[index]);
	poll_event_[index]->num_ = index;
	s.schedule (&ph_, poll_event_[index], max_poll_interval_[index]);
}

/* create a poll packet */
Packet* 
BT_DRRScheduler::createPOLLpacket (uchar am_addr)
{
	Packet* p = Baseband::allocBBPkt(BT_POLL, am_addr);
	return p;
}

/* not used in this version */
void
PollHandler::handle (Event* e)
{
	PollEvent* pe = (PollEvent*)e;	
	uchar am_addr = pe->num_ + 1;
	Packet* pkt = sched_->createPOLLpacket(am_addr);
	sched_->poll_q_->enque(pkt);
	delete pe;
}	

void
BT_DRRScheduler::disconnect(uchar am_addr) {
	int i = am_addr-1;

	rate_[i] = 0;
	tos_[i] = 0;
	dc_[i] = 3000;
	incr_[i] = 0;
	backlog_fwd_[i] = 0;
	backlog_rev_[i] = 0;
	mode_[i] = Disconnected;
	hold_start_[i] = 0x7fffffff;
	hold_end_[i] = 0x7fffffff;
	quanta_[i] = 1000;		
	max_poll_interval_[i] = 40;
}

void
BT_DRRScheduler::connect(uchar am_addr) {
	int i = am_addr-1;

	hold_start_[i] = 0x7fffffff;
	hold_end_[i] = 0x7fffffff;
	mode_[i] = Active;
	dynamic_cast<LinkController*>(lc_[am_addr-1])->initialize();	// Initialize LC so that SEQN are reset!
}


