/* -*-	Mode:C++; c-basic-offset:8; tab-width:8; indent-tabs-mode:t -*- */
/**************************************************************************************************
*IBM Public License Version 1.0 
*
*THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS IBM PUBLIC LICENSE ("AGREEMENT"). ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS AGREEMENT. 
*
*1. DEFINITIONS 
*
*"Contribution" means: 
*
*       a) in the case of International Business Machines Corporation ("IBM"), the Original Program, and 
*
*       b) in the case of each Contributor, 
*
*       i) changes to the Program, and
*
*       ii) additions to the Program;
*
*       where such changes and/or additions to the Program originate from and are distributed by that particular Contributor. A Contribution 'originates' from a Contributor if it
*       was added to the Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions do not include additions to the Program which: (i) are
*       separate modules of software distributed in conjunction with the Program under their own license agreement, and (ii) are not derivative works of the Program.
*
*  "Contributor" means IBM and any other entity that distributes the Program. 
*
*  "Licensed Patents " mean patent claims licensable by a Contributor which are necessarily infringed by the use or sale of its Contribution alone or when combined with the
*  Program. 
*
*  "Original Program" means the original version of the software accompanying this Agreement as released by IBM, including source code, object code and documentation, if
*  any. 
*
*  "Program" means the Original Program and Contributions. 
*
*  "Recipient" means anyone who receives the Program under this Agreement, including all Contributors. 
*
*  2. GRANT OF RIGHTS 
*
*       a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive, worldwide, royalty-free copyright license to reproduce, prepare
*       derivative works of, publicly display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, and such derivative works, in source code
*       and object code form.
*
*       b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive, worldwide, royalty-free patent license under Licensed Patents to
*       make, use, sell, offer to sell, import and otherwise transfer the Contribution of such Contributor, if any, in source code and object code form. This patent license shall
*       apply to the combination of the Contribution and the Program if, at the time the Contribution is added by the Contributor, such addition of the Contribution causes
*       such combination to be covered by the Licensed Patents. The patent license shall not apply to any other combinations which include the Contribution. No hardware per
*       se is licensed hereunder. 
*
*       c) Recipient understands that although each Contributor grants the licenses to its Contributions set forth herein, no assurances are provided by any Contributor that
*       the Program does not infringe the patent or other intellectual property rights of any other entity. Each Contributor disclaims any liability to Recipient for claims brought
*       by any other entity based on infringement of intellectual property rights or otherwise. As a condition to exercising the rights and licenses granted hereunder, each
*       Recipient hereby assumes sole responsibility to secure any other intellectual property rights needed, if any. For example, if a third party patent license is required to
*       allow Recipient to distribute the Program, it is Recipient's responsibility to acquire that license before distributing the Program.
*
*       d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its Contribution, if any, to grant the copyright license set forth in this
*       Agreement. 
*
*  3. REQUIREMENTS 
*
*  A Contributor may choose to distribute the Program in object code form under its own license agreement, provided that: 
*
*       a) it complies with the terms and conditions of this Agreement; and
*
*       b) its license agreement:
*
*       i) effectively disclaims on behalf of all Contributors all warranties and conditions, express and implied, including warranties or conditions of title and non-infringement,
*       and implied warranties or conditions of merchantability and fitness for a particular purpose; 
*
*       ii) effectively excludes on behalf of all Contributors all liability for damages, including direct, indirect, special, incidental and consequential damages, such as lost
*       profits; 
*
*       iii) states that any provisions which differ from this Agreement are offered by that Contributor alone and not by any other party; and
*
*       iv) states that source code for the Program is available from such Contributor, and informs licensees how to obtain it in a reasonable manner on or through a medium
*       customarily used for software exchange. 
*
*  When the Program is made available in source code form: 
*
*       a) it must be made available under this Agreement; and 
*
*       b) a copy of this Agreement must be included with each copy of the Program. 
*
*  Each Contributor must include the following in a conspicuous location in the Program: 
*
*       Copyright  2002 International Business Machines Corporation, 
*       Massachusetts Institute of Technology, and others. All Rights Reserved. 
*
*  In addition, each Contributor must identify itself as the originator of its Contribution, if any, in a manner that reasonably allows subsequent Recipients to identify the originator
*  of the Contribution. 
*
*  4. COMMERCIAL DISTRIBUTION 
*
*  Commercial distributors of software may accept certain responsibilities with respect to end users, business partners and the like. While this license is intended to facilitate the
*  commercial use of the Program, the Contributor who includes the Program in a commercial product offering should do so in a manner which does not create potential liability
*  for other Contributors. Therefore, if a Contributor includes the Program in a commercial product offering, such Contributor ("Commercial Contributor") hereby agrees to defend
*  and indemnify every other Contributor ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising from claims, lawsuits and other legal
*  actions brought by a third party against the Indemnified Contributor to the extent caused by the acts or omissions of such Commercial Contributor in connection with its
*  distribution of the Program in a commercial product offering. The obligations in this section do not apply to any claims or Losses relating to any actual or alleged intellectual
*  property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the Commercial Contributor in writing of such claim, and b) allow the Commercial
*  Contributor to control, and cooperate with the Commercial Contributor in, the defense and any related settlement negotiations. The Indemnified Contributor may participate in
*  any such claim at its own expense. 
*
*  For example, a Contributor might include the Program in a commercial product offering, Product X. That Contributor is then a Commercial Contributor. If that Commercial
*  Contributor then makes performance claims, or offers warranties related to Product X, those performance claims and warranties are such Commercial Contributor's
*  responsibility alone. Under this section, the Commercial Contributor would have to defend claims against the other Contributors related to those performance claims and
*  warranties, and if a court requires any other Contributor to pay any damages as a result, the Commercial Contributor must pay those damages. 
*
*  5. NO WARRANTY 
*
*  EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
*  KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT,
*  MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness of using and distributing the
*  Program and assumes all risks associated with its exercise of rights under this Agreement, including but not limited to the risks and costs of program errors, compliance with
*  applicable laws, damage to or loss of data, programs or equipment, and unavailability or interruption of operations. 
*
*  6. DISCLAIMER OF LIABILITY 
*
*  EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE ANY LIABILITY FOR ANY DIRECT,
*  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND
*  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
*  OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF ADVISED OF THE POSSIBILITY OF
*  SUCH DAMAGES. 
*
*  7. GENERAL 
*
*  If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not affect the validity or enforceability of the remainder of the terms of this
*  Agreement, and without further action by the parties hereto, such provision shall be reformed to the minimum extent necessary to make such provision valid and enforceable. 
*
*  If Recipient institutes patent litigation against a Contributor with respect to a patent applicable to software (including a cross-claim or counterclaim in a lawsuit), then any
*  patent licenses granted by that Contributor to such Recipient under this Agreement shall terminate as of the date such litigation is filed. In addition, If Recipient institutes
*  patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding combinations of the Program with other
*  software or hardware) infringes such Recipient's patent(s), then such Recipient's rights granted under Section 2(b) shall terminate as of the date such litigation is filed. 
*
*  All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the material terms or conditions of this Agreement and does not cure such failure in a
*  reasonable period of time after becoming aware of such noncompliance. If all Recipient's rights under this Agreement terminate, Recipient agrees to cease use and
*  distribution of the Program as soon as reasonably practicable. However, Recipient's obligations under this Agreement and any licenses granted by Recipient relating to the
*  Program shall continue and survive. 
*
*  IBM may publish new versions (including revisions) of this Agreement from time to time. Each new version of the Agreement will be given a distinguishing version number. The
*  Program (including Contributions) may always be distributed subject to the version of the Agreement under which it was received. In addition, after a new version of the
*  Agreement is published, Contributor may elect to distribute the Program (including its Contributions) under the new version. No one other than IBM has the right to modify this
*  Agreement. Except as expressly stated in Sections 2(a) and 2(b) above, Recipient receives no rights or licenses to the intellectual property of any Contributor under this
*  Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not expressly granted under this Agreement are reserved. 
*
*  This Agreement is governed by the laws of the State of New York and the intellectual property laws of the United States of America. No party to this Agreement will bring a
*  legal action under this Agreement more than one year after the cause of action arose. Each party waives its rights to a jury trial in any resulting litigation. 
**********************************************************************************************************************/

/*==================================================================
  BLUETOOTH HOST MODULE (IMPLEMENTS HCI LAYER)

The bt-host entity is the principle controlling entity in the
simulation. On the master side it does the following:
(1) Request Inquiry from the baseband. 
(2) Requests paging for the received Bluetooth addresses from the Baseband
(3) Looks up the flow specifications for the application which intends
    to use an ACL connection to request QoS from Link Manager.  
(4) On QoS being accepted calls sendL2CA_ConnectRequest to intitiate 
    L2CAP connection establishment
(5) After L2CAP connection is established, it starts the application. 
(6) Calls dataWrite primitive provided by L2CAP with the proper connection
    handle for every packet received from the application. 

 ==================================================================*/

    

#include <bt-core.h>
#include <lcs.h>
#include <tcp.h>
#include <tsf.h>


#define BD2IP_ADDR(a) a
#define IP2BD_ADDR(a) a
#define LID2CID(a) (a+1)
#define CID2LID(a) (a-1)

char BTHost::buf_[BUF_LEN];

//#define DUPACK_ACT 
int SEQ_CNT = 3;

// QoS is not currently implemented but there are some exisiting code. 
//#define BT_QOS

static class BTHostClass : public TclClass 
{
public:
	BTHostClass() : TclClass("BTHost"){}
	TclObject* create(int, const char*const*) {
	 	return ( new BTHost );
	}
} class_bthost;


BTHost::BTHost() : HCIEventsHandler()
{
	curr_paged_ = 0; 
	app_start_ = 0;
	sched_ = NULL;
	topoConstr_ = NULL;
	trafgen_ = new (NsObject*)[MaxNumLinks];

	for (int i=0; i<MaxNumLinks; i++)
		active_addr_[i] = -1;
#ifdef BT_QOS
	app_flow_spec_ = new (struct flowSpec*)[MaxNumLinks];
	for (int i=0; i<MaxNumLinks; i++) {
		trafgen_[i] = NULL;

		active_addr_[i] = -1;
		app_flow_spec_[i] = new (struct flowSpec);
		// Initialize the specs as Traffic/Exponential apps 
		app_flow_spec_[i]->mtu = 339;
		app_flow_spec_[i]->token_rate = 64;
		app_flow_spec_[i]->token_bucket = 30000;
		app_flow_spec_[i]->input_qlen = 30;
		app_flow_spec_[i]->peak_bw = 100000;
		app_flow_spec_[i]->latency = 100;
		app_flow_spec_[i]->loss_sensitivity = 0;
	}
#endif
	
	proto1_.value = 0;
	proto2_.value = 1;
	for(int i = 0; i < MaxNumNodes; i++) {
		proto1_.arp_table_[i] = (uchar)-1;
		proto2_.arp_table_[i] = (uchar)-1;
	}
	linkq_ = new (LMP*)[MaxNumLinks];

	start_clk_ = 0;
	prev_clk_ = -1;
	HCIEventsHandler::init(this);
	topo_ev_ = NULL;
	prev_dur_ = 0;
	stats_ = new DataStats();
	b_drop_ = false;
	seqno_ = -1;
}

int
BTHost::command(int argc, const char*const* argv)
{
	Tcl& tcl = Tcl::instance();
	if (argc == 2) {
		if (strcmp(argv[1], "start") == 0) {
			//if(master_)
			//	findAppNames();
			start_clk_ = Scheduler::instance().clock();
			lm_->start();
			CALLBACK(start()); 
			return (TCL_OK);
		}
		if (strcmp(argv[1], "stop") == 0) {
			if(lm_) lm_->stop();
			if(l2cap_) l2cap_->stop();
			CALLBACK(stop());
			TRACE_BT(LEVEL_ACCT, "%s _%d_ %s\n",
				  TraceAcctStr, hciGetBdAddr(), stats_->toString());
			return (TCL_OK);
		}

	}
	if (argc == 3) {
		if (strcmp(argv[1], "setL2CAP") == 0) {
			if (*argv[2] == '0') {
				l2cap_ = 0;
				return (TCL_OK);
			}
			l2cap_ = (L2CAP*)TclObject::lookup(argv[2]);
			if (l2cap_ == 0) {
				tcl.resultf("no such object %s", argv[2]);
				return (TCL_ERROR);
			}
			return (TCL_OK);
		}
		if (strcmp(argv[1], "setLM") == 0) {
			if (*argv[2] == '0') {
				lm_ = 0;
				return (TCL_OK);
			}
			lm_ = (Baseband*)TclObject::lookup(argv[2]);
			if (lm_ == 0) {
				tcl.resultf("no such object %s", argv[2]);
				return (TCL_ERROR);
			}
			return (TCL_OK);
		}
		if (strcmp(argv[1], "setSched") == 0) {
			if (*argv[2] == '0') {
				sched_ = 0;
				return (TCL_ERROR);
			}
			sched_ = dynamic_cast<TaskScheduler*>(TclObject::lookup(argv[2]));

			if (sched_ == 0) {
				tcl.resultf("no such object %s", argv[2]);
				return (TCL_ERROR);
			}
			return (TCL_OK);
		}
		if (strcmp(argv[1], "setTopo") == 0) {
			if (*argv[2] == '0') {
				topoConstr_ = 0;
				return (TCL_ERROR);
			}
			topoConstr_ = dynamic_cast<TopoConstructor*>(TclObject::lookup(argv[2]));
			if (topoConstr_ == 0) {
				tcl.resultf("no such object %s", argv[2]);
				return (TCL_ERROR);
			}
			return (TCL_OK);
		}
		if (strcmp(argv[1], "add-handler") == 0) {
			if (*argv[2] != '0') {
				HCIEventsHandler* h = (HCIEventsHandler*)TclObject::lookup(argv[2]);
				addHandler(h);
			}
			return (TCL_OK);
		}
#ifdef BT_QOS
		if (strcmp(argv[1], "connect-app") == 0) {
			int slot = atoi(argv[2]); // this may not be working correctly
			//int slot = num_apps_;
			if(slot < MaxNumLinks) { 
				trafgen_[slot] = (NsObject*)TclObject::lookup(argv[2]);
				num_apps_++;
			}
			return (TCL_OK);
		}
#endif
	}	
	if (argc == 4) {
		if (strcmp(argv[1], "linkq") == 0) {
			int slot = atoi(argv[2]);
			linkq_[slot] = (LMP*)TclObject::lookup(argv[3]);
			return (TCL_OK);
		}
	}
	return (Connector::command(argc, argv));
}

void
BTHost::addHandler(HCIEventsHandler* handler) 
{
	handlers_.push_back(handler);
	handler->init(this);
}

/******************************************************************************************
 * Link control events.
 ******************************************************************************************/

// Results of the Inquiry process.
void
BTHost::hciInquiryResult(vector<FHS_payload*>& addr_vec)
{
	taskFinished(INQ_TSK);
	vec_addr_ = addr_vec;
	CALLBACK(hciInquiryResult(vec_addr_));
}

// Results of the hciCreateConnection command. If successful, CH contains the connection handle and -1 otherwise.
void
BTHost::hciConnectionCompleteEvent(char ch, bool bMasRole)
{
	if(bMasRole) {
		taskFinished(PAGE_TSK); 
	}
	else {
		task_type scan_type = timer2task(PAGE_SCAN_TM);
		if (taskScheduler()->currTask() && taskScheduler()->currTask()->type() == scan_type) { // @GT 10/17/02
			taskFinished(scan_type);
		}
	}

	if(ch != -1) {
		linkEstablished(ch, bMasRole);
		if (bMasRole) {
			active_addr_[ch] = curr_paged_;
			/*
			ch = (bMasRole) ? ch : 0;
			//linkq_[ch]->hciChange_connection_packet_type(15);
			if (curr_paged_ > hciGetBdAddr() && (curr_paged_ <= hciGetBdAddr()+num_responses_))
				linkq_[ch]->hciQoSSetup(app_flow_spec_[curr_paged_-hciGetBdAddr()-1]);
			else 
				linkq_[ch]->hciQoSSetup(app_flow_spec_[curr_paged_%num_responses_]);
			*/
		}
	}
	CALLBACK(hciConnectionCompleteEvent(ch, bMasRole));
	if(ch != -1 && lm()->isMasLink(ch))
		createL2CAPConnection(ch);
}

// QoS complete event.
void
BTHost::hciQoSSetupCompleteEvent(char ch, bt_packet_type type)
{
	ASSERT(0);
	if (ch != -1) {
		type_[ch] = type;
	}
	else {
		printf("QoS not satisfied CH %d BD_ADDR %d\n", ch, curr_paged_);
		ASSERT(0); //Do we need to do anything here? GT
	}

	CALLBACK(hciQoSSetupCompleteEvent(ch, type));
}

void
BTHost::hciConnectionRequestEvent(char ch)
{
	CALLBACK(hciConnectionRequestEvent(ch));
}		

void 
BTHost::hciDisconnectionCompleteEvent(char ch)
{
	l2cap_->hciDisconnectionCompleteEvent(ch);
	CALLBACK(hciDisconnectionCompleteEvent(ch));
}

/* If BRESPTO = TRUE, the scan operation in progress has failed after recieving
 * a response from another node. Otherwise, the scan operation has completed. 
 */
void 
BTHost::hciScanCompleteEvent(timer_type tm, bool bRespTO)
{
	if(!bRespTO) { // if this is a response or connection timeout, we would have received this event already
		taskFinished(timer2task(tm));	
	}
	else {
		TRACE_BT(LEVEL_TSF, "_%d_ BTHost::hciScanCompleteEvent TIMEOUT %d\n", hciGetBdAddr(), tm);
		task_type scan_type = timer2task(PAGE_SCAN_TM);
		if (tm == PAGE_SCAN_TM && taskScheduler()->currTask() &&
		    taskScheduler()->currTask()->type() == scan_type) { // @GT 10/17/02
			taskFinished(scan_type);
		}
	}

	CALLBACK(hciScanCompleteEvent(tm, bRespTO));
	int ticks, window;
	if(lm()->getTimer(tm, &ticks, &window) && !bRespTO) {
		TopoEvent* e = scheduleTopoTask(timer2task(tm), window, ticks, 3, tm, ticks, window);	
		if(lm()->getSessionInProg() == NONE_IN_PROG) {
			lm()->cancel(tm);
			e->first_ = true;
		}
		else {
			e->first_ = false; // should not call scan again
		}
	}
}

void
BTHost::hciInqRespSentEvent() 
{
	CALLBACK(hciInqRespSentEvent());
}

void
BTHost::hciCommandStatusEvent(hci_cmd cmd, bool succ)
{
	CALLBACK(hciCommandStatusEvent(cmd, succ));
}

void 
BTHost::hci2HostTimerExpiredEvent() 
{
	CALLBACK(hci2HostTimerExpiredEvent());
}

/******************************************************************************************
 * Link control commands
 ******************************************************************************************/

void
BTHost::acceptConnection(uchar ch) 
{
	linkq_[ch]->hciAcceptConnectionRequest();
}

void
BTHost::hciCreateConnection(FHS_payload* info, int pageto = PageTO) 
{
	ASSERT(!hciIsExistingConn(info));
	curr_paged_ = info->addr;
	scheduleTopoTask(PAGE_TSK, pageto, 0, 3, info->addr, info->clock, pageto); // fix this later to reduce pageto
}

void
BTHost::createL2CAPConnection(uchar ch)
{
	if(!lm_->isMasLink(ch)) // for now only allow master to initiate
		ASSERT(0);
	l2cap_->L2CA_ConnectReq(0, ch, BT_DH5); //@GT may need to setup QoS before hand
}

void 
BTHost::hciInquiry(long inqlen, int num_responses, int iac)
{
	scheduleTopoTask(INQ_TSK, inqlen, 0, 3, inqlen, num_responses, iac);
}
	
// Perform periodic scan every TICKS ticks for WINDOW ticks burst. 
void
BTHost::hciScan(timer_type type, int ticks, int window)
{
	scheduleTopoTask(timer2task(type), window, 0, 3, type, ticks, window);
}

void 
BTHost::hciCancel(timer_type tm)
{
	TRACE_BT(LEVEL_LOW, "BTHost::hciCancel tm=%d, evType=%d\n", tm, (topo_ev_) ? topo_ev_->type_ : -1 );
	lm_->cancel(tm);
	if(timer2task(tm) >= INQ_TSK && timer2task(tm) < NUM_TSK)
		sched_->cancel(timer2task(tm));
}

// Schedule a topo contrution related task TSK for DURATION period. 
TopoEvent*
BTHost::scheduleTopoTask(task_type tsk, int duration, int offset, int nArgs, ...)
{
	TopoEvent* ev = new TopoEvent(tsk);

	va_list ap;
	va_start(ap, nArgs);
	for(int i = 0; i < nArgs; i++)
		*(ev->data+i) = (int)va_arg(ap, int);
	va_end(ap);
	ev->handler_ = this;
	ev->duration_ = duration;
	if((tsk == INQ_TSK || tsk == PAGE_TSK || tsk == PAGE_SCAN_TSK || tsk == INQ_SCAN_TSK) 
	   && dynamic_cast<LCS*>(sched_)) {
		dynamic_cast<LCS*>(sched_)->scheduleTopoTask(duration, this, ev, offset);
	}
	else {
		sched_->schedule(tsk, duration, this, ev, offset);
	}
	return ev;
}

void
BTHost::handle(Event* e)
{
	TopoEvent* ev = NULL;
	ev = static_cast<TopoEvent*>(e);
	ASSERT(ev);
	if(ev->status_ == TASK_CANCEL) {
		if(topo_ev_) {
			delete topo_ev_;
			topo_ev_ = NULL;
		}
	}
	else if(ev->status_ == TASK_BEGIN) {
		if(ev->type_ == INQ_TSK) {
			lm_->inquire(ev->data[0], ev->data[1], ev->data[2]);		
		}
		else if(ev->type_ == PAGE_TSK) {
			lm_->page(ev->data[0], ev->data[1], ev->data[2]);
		}
		else {
			if(!(ev->type_ == INQ_SCAN_TSK || ev->type_ == PAGE_SCAN_TSK))
				ASSERT(0);
			if(ev->first_)// periodic scan begins
				lm_->beginScan((timer_type)ev->data[0], ev->data[1], ev->data[2]); 
		}
		ASSERT(!topo_ev_);
		topo_ev_ = ev;	
	}
	else if(ev->status_ == TASK_END) {
		if(topo_ev_) {
			delete topo_ev_;
			topo_ev_ = NULL;
		}
	}
}

void
BTHost::taskFinished(task_type type)
{
	sched_->currTaskFinished();
	if(topo_ev_) {
		delete topo_ev_;
		topo_ev_ = NULL;
	}
}

task_type
BTHost::timer2task(timer_type tm) 
{
	switch(tm) {
	case INQ_TM:
		return INQ_TSK;
	case INQ_SCAN_TM:
		return INQ_SCAN_TSK;
	case PAGE_TM:
		return PAGE_TSK;
	case PAGE_SCAN_TM:
		return PAGE_SCAN_TSK;
	default:
		return NUM_TSK;
	}
}

timer_type
BTHost::taskToTimer(task_type task)
{
	switch(task) {
	case INQ_TSK:
		return INQ_TM;
	case INQ_SCAN_TSK:
		return INQ_SCAN_TM;
	case PAGE_TSK:
		return PAGE_TM;
	case PAGE_SCAN_TSK:
		return PAGE_SCAN_TM;
	default:
		ASSERT(0);
	}
}

/* P has been transmitted on link LID. If P == NULL, a control pkt such as
 * POLL or NULL pkt has been transmitted. */
void
BTHost::transmitted(Packet* p, uchar lid)
{
	CALLBACK(transmitted(p, lid));
}

/* Packet RECVDPKT was recevied on link LID. P is the data packet this
 * node has transmitted in the previous time slot. Must not modify both P
 * and RECVDPKT. */
void
BTHost::recvd(Packet* p, uchar lid, Packet* recvdPkt)//bt_packet_type type)
{
	CALLBACK(recvd(p, lid, recvdPkt));
}

// There is no data to send on LID link which is currently active.
Packet*
BTHost::send(uchar lid) 
{
	Packet* p = sched_->send(lid);
	return p;
}

// The slave has been active but not been polled by the master. Only applies to slave links.
void
BTHost::pollMissed(uchar lid)
{
	sched_->pollMissed(lid);
}

/******************************************************************************************
 * Link policy events
 ******************************************************************************************/

// If BSUCCESS is true, the device mode has been changed to CUR mode with interval of INTV ticks.
// Otherwise, the attempt to change to CUR mode has failed.  
void
BTHost::hciModeChangeEvent(char ch, bool bSuccess, BT_mode cur, int intv)
{
	b_drop_ = false; // as soon as the mode changes reset b_drop_
	seqno_ = -1;
	CALLBACK(hciModeChangeEvent(ch, bSuccess, cur, intv));
}

/* The link's hold timer has expired. However, because of other Baseband activities
 * this link cannot be changed to the Active status. Otherwise, modeChangeEvent would
 * have been called. */
void
BTHost::hciHoldExpiredEvent(char ch)
{
	CALLBACK(hciHoldExpiredEvent(ch));
}

// BMASTER is true if the current role of this node on the connection CH is master. 
void 
BTHost::hciRoleChangeEvent(bool bMaster, char ch)
{
	TRACE_BT(LEVEL_ACCT, "%s _%d_ ROLE_CHANGE EVENT: MAS %d-%d SLV, LASTLINK %.4f\n", TraceAcctStr,
		 hciGetBdAddr(), lm()->lid2addr(ch, true), lm()->lid2addr(ch, false), prev_dur_);
	CALLBACK(hciRoleChangeEvent(bMaster, ch));
	if(ch != -1 && bMaster)
		createL2CAPConnection(ch);
}


/******************************************************************************************
 * Data related routines
 ******************************************************************************************/

/* A packet is received from an upper layer or lower layer, so call dataWrite primitive of L2CAP.
 * When received from a lower layer, the packet will be queued at appropriate links to be forwarded. 
 * If the packet is destined for this node, L2CAP::sendUp will be called instead of this routine. */
void
BTHost::recv(Packet* p, Handler* h) 
{
	Scheduler& s = Scheduler::instance();
	hdr_cmn* ch = HDR_CMN(p);
	ch->direction() = hdr_cmn::DOWN;

	hdr_ip* iph = HDR_IP(p);
	uchar cid = lookupCid(iph->daddr()); // find an appropriate output link
	if(cid == (uchar)-1) {
		l2cap_->drop(p);
	}
	else {
		TRACE_BT(LEVEL_MED, "_%d_ L2CA_DATA_WRITE: UID %d %s\n",
			  hciGetBdAddr(), ch->uid(), packet_info.name(ch->ptype()));
		stats_->has_sent_data_ = true;

		bool isSrc = (IP2BD_ADDR(iph->saddr()) == hciGetBdAddr());
		uchar outLid = lookupLid(hciGetBdAddr(), IP2BD_ADDR(iph->daddr()), hciGetBdAddr());
		uchar inLid = (isSrc) ? InvalidLid : lookupLid(hciGetBdAddr(), IP2BD_ADDR(iph->daddr()), hciGetBdAddr());

		if(isSrc) {
			// This packet is generated by the applications on this node
			ch->timestamp() = s.clock();
		        HDR_BT(p)->lid_ = InvalidLid; 
		}

		if(l2cap_->numSegments(p, cid) > lmp(outLid)->numAvailL2CAPQueSize() || b_drop_) {
			hdr_tcp* tcp = HDR_TCP(p);
			TRACE_BT(LEVEL_HIGH, "_%d_ DROPPING %s [TCP %d %d]\n",
				  hciGetBdAddr(), toString(p), tcp->seqno(), tcp->ackno());

			// The problem here is that sometimes it may lead to out of order transmission and thus
			// TCP has to deal with it later. Ideally, we should inform TCP that congestion has happened! 
			if(h && isSrc) {
#ifdef DUPACK_ACT
				TcpAgent* agent = dynamic_cast<TcpAgent*>(h);
				if(agent) {
					// HACK: if it's a tcpagent, inform right away to halve ssthresh and window size
					//agent->dupack_action();
					// This works well for two hops case but not that well for 6 hops case
					// In real TCP implementation for FreeBSD, this will result in the same effect as 
					// retransmit timer has expiredx
					//agent->timeout(0); // this will result in infinite loop if overhead_ == 0
					
					//agent->ecn(tcp->seqno());
					//queueFull(outLid, outLid);

					b_drop_ = true; // drop consecutive packets
					if(++seqno_ == SEQ_CNT) {
						//seqno_ = agent->last_ack();//tcp->seqno();
						b_drop_ = false;
						agent->dupack_action();
						seqno_ = -1;
					}

					/*
					// fast recovery and retransmit
					Packet* ack = ALLOCP();
					hdr_tcp *acktcp = hdr_tcp::access(ack);
					acktcp->seqno() = seqno_; //agent->last_ack();
					acktcp->ts() = Scheduler::instance().clock();
					acktcp->ts_echo() = tcp->ts();
					HDR_CMN(ack)->ptype() = PT_ACK;
					agent->recv(ack, NULL);
					*/
				}
#endif // DUPACK_ACT
			}
			else {
				queueFull(outLid, inLid);
			}
			l2cap_->drop(p);
			p = NULL;
		}

		if(p) {
			ch->num_forwards()++;
			l2cap_->dataWrite(p, cid);
		}
	}
}

uchar
BTHost::lookupCid(int dstip)
{
	uchar cid = proto1_.arp_table_[dstip];
	uchar lid = 0;
	CID_attr* cid_attr = NULL;

	if(cid == (uchar)-1) {
		lid = lookupLid(hciGetBdAddr(), IP2BD_ADDR(dstip), hciGetBdAddr());
		if(lid != (uchar)-1) {
			cid_attr = l2cap_->findFirstCID(lid);
			if(cid_attr == NULL) {
				// although we have a connection at Baseband level, we don't have it at the L2CAP level yet
			}
			else {
				ASSERT(cid_attr->ch == lid);
				cid = cid_attr->lcid;
				proto1_.arp_table_[dstip] = cid;
			}
		}
	}
	return cid;
}

char
BTHost::findLid(int dstip)
{
	uchar cid = lookupCid(dstip);
	char lid = InvalidLid;
	if(cid != (uchar)-1) 
		lid = l2cap_->findLid(cid);
	return lid;
}

uchar     
BTHost::lookupLid(int src, int dst, int in) 
{
	// look for the destination node in the connected component 
	// This should be hooked up to the routing agent; override lookupLidTsf with your routing agent's routine
	return lookupLidTsf(src, dst, in);
}

// P has been received on channel CID by the L2CAP layer. Deliver P to the appropriate receiver (agent). 
void
BTHost::dataRead (Packet* p, CID_attr* cid)
{	
	static bool bFirstTime = true;

	Scheduler& s = Scheduler::instance();
	uchar psm = cid->psm;
	hdr_cmn* ch = HDR_CMN(p);
	hdr_ip* iph = HDR_IP(p);

	if (psm == proto1_.value) {
		if(IP2BD_ADDR(iph->daddr()) == hciGetBdAddr() && (ch->ptype() == PT_TCP || ch->ptype() == PT_CBR)) {
			if (bFirstTime) {
				bFirstTime = false;
				Baseband::stopAll(false);
				app_start_ = s.clock();
				TRACE_BT(LEVEL_ACCT, "_%d_ APPLICATION HAS STARTED AT %2.2e\n", hciGetBdAddr(), app_start_); 
			}

			double delay = s.clock() - ch->timestamp();
			TRACE_BT(LEVEL_L2CAP, "_%d_ DELAY %9.2e %s\n", hciGetBdAddr(), delay, toString(p));
			stats_->total_delay_ += delay;
			stats_->total_delay_sq_ += (delay * delay);
			stats_->total_bytes_ += ch->size();
			stats_->n_pkts_++;

			if(stats_->ptype_ == -1) {
				stats_->ptype_ = ch->ptype();
				stats_->pkt_size_ = ch->size();
				stats_->start_ = ch->timestamp();//s.clock();
				stats_->n_hops_ = ch->num_forwards();
			}
			stats_->finish_ = s.clock();
			if(!(stats_->ptype_ == ch->ptype()))
				ASSERT(0); // for now only one flow per path
			ASSERT(stats_->pkt_size_ == ch->size());
			stats_->src_ = iph->saddr();
			stats_->dst_ = iph->daddr();
		}
		target_->recv(p, this);

	}
	else 
		proto2_.uptarget_->recv(p,this);
}



/******************************************************************************************
 * L2CAP events.
 ******************************************************************************************/

// L2CAP connection establishment complete. L2CAP informs host. 
void
BTHost::L2CA_ConnectCfm (int scid, uchar ch, uchar psm)
{
	int bd_addr = lm()->lid2addr(ch);
	uchar ip_addr = BD2IP_ADDR(bd_addr);

	TRACE_BT(LEVEL_L2CAP, "_%d_ L2CAP CONNECTION COMPLETE: ADDR %d SCID %d LID %d\n",
		  hciGetBdAddr(), bd_addr, scid, ch);

	if (psm == proto1_.value) {
		if(!(proto1_.arp_table_[ip_addr] == (uchar)-1)) // for now only allow one SCID per CH. 
			ASSERT(0);
		proto1_.arp_table_[ip_addr] = scid;
	}
	else {
		proto2_.arp_table_[ip_addr] = scid;
	}
}

// L2CAP connection REQ pkt is received. /* slave operation */
void 
BTHost::L2CA_ConnectInd (CID_attr* cid_attr, uchar psm)
{
	if (psm == proto1_.value) {
		proto1_.cid = cid_attr->lcid;
	}
	else {
		proto2_.cid = cid_attr->lcid;
	}
	// add logic for accepting/rejecting here, accept for now
	l2cap_->L2CA_ConnectRsp(cid_attr, 1);
}


/******************************************************************************************
 * Misc routines
 ******************************************************************************************/

// A new link with handle CH has been established. 
void
BTHost::linkEstablished(uchar ch, bool bMaster) 
{
	double clk = Scheduler::instance().clock();
	ASSERT(lm_->last_recv());
	
	const char* str = (bMaster) ? "MAS" : "SLV";
	double dur = clk - prev_clk_;
	if(lm_->numLinks() <= 1) {
		str = (bMaster) ? "FIRST MAS" : "FIRST SLV";
		dur = (clk - start_clk_);
	}
	TRACE_BT(LEVEL_ACCT, "%s _%d_ %s LINK ESTABLISHED %d -> %d DELAY %f\n", 
		  TraceAcctStr, hciGetBdAddr(), str, hciGetBdAddr(), lm_->lid2addr(ch), dur);
	prev_dur_ = dur;
	prev_clk_ = clk;
}

bool
BTHost::hciIsExistingConn(FHS_payload* info) const
{
	ASSERT(info);
	bool res = lm()->isExistingConn(info->addr);
	return res;
}

void    
BTHost::hci2SetHostTimer(int period) 
{ 
	lm()->setTimer(HOST_TM, period, 0);
}

void    
BTHost::hci2BeginSession(state_progress prog, int ticks = 30, Handler* h=NULL)
{ 
	lm()->beginSession(prog, ticks, h); 
}

void    
BTHost::hci2EndSession(state_progress prog) 
{ 
	lm()->endSession(prog); 
}

inline state_type
BTHost::hci2GetState() const 
{
	return lm()->getState();
}

inline state_progress 
BTHost::hci2GetSessionInProg() const 
{ 
	return lm()->getSessionInProg(); 
}

// If MODE = Hold, continue holding the LIDth link for INTV ticks. Otherwise, 
// put the link into hold mode till MCLK + INTV ticks.  If BRECV is TRUE, 
// the link will not be put into hold mode until after the ACK is sent back. 
void
BTHost::hci2HoldLink(int lid, BT_mode mode, int intv, int mclk, bool bRcvd) 
{
	if (mode == Hold) {
		lm()->continueHold(lid, intv);
	}
	else {
		lm()->holdLink(lid, intv, mclk, bRcvd);
	}
}

void
BTHost::recvPkt(Packet* p, uchar ch) 
{
	CALLBACK(recvPkt(p, ch));
	FREEP(p);
}

void
BTHost::flushPkt(uchar lid, packet_t type)
{
	deque<Packet*>::iterator it;
	Packet* p = NULL;
	for(it = linkq_[lid]->hostq_.begin(); it != linkq_[lid]->hostq_.end();) {
		p = *it;
		if(HDR_CMN(p)->ptype() == type) {
			TRACE_BT(LEVEL_MED, "_%d_ BTHost::flushPkt: removing %d type pkts\n", 
				  hciGetBdAddr(), type);
			linkq_[lid]->hostq_.erase(it);
			FREEP(p);
			continue;
		}
		it++;
	}
	linkq_[lid]->lc()->resetARQ();
	linkq_[lid]->lc()->flushPkt(type);
}

void
BTHost::dropped(Packet* p)
{
	TRACE_BT(LEVEL_MED, "_%d_ DROPPED BTHOST %d %s\n", 
		  hciGetBdAddr(), HDR_CMN(p)->ptype(), packet_info.name(HDR_CMN(p)->ptype()));
}

char*
BTHost::toString(Packet* p)
{
	hdr_cmn* ch = HDR_CMN(p);
	hdr_bt* bt = HDR_BT(p);
	hdr_ip* ip = HDR_IP(p);

	snprintf(buf_, BUF_LEN, "SZ %4d %8s UID %4d SRC %3d DST %3d [%3d -> %3d]",
		 ch->size(), packet_info.name(ch->ptype()), ch->uid(), 
		 ip->saddr(), ip->daddr(), bt->send_id_, bt->recv_id_);
	return buf_;
}

// The combined queue size in slots.
int
BTHost::queueSize(char lid)
{
	int sz = lmp(lid)->queueSize();
	sz += l2cap_->queueSize(lid);
	return sz;
}

/* The LMP data queue associated with link OUTLID is full. This is as a result of an incoming
 * packet on link INLID. If the packet is generated by this node, INLID is InvalidLid (see recv()). */
void
BTHost::queueFull(char outLid, char inLid) 
{
	//TRACE_BT(LEVEL_HIGH, "_%d_ LID %d QUEUE FULL\n", hciGetBdAddr(), lid);
	if(inLid != InvalidLid) {
		sched_->queueFull(outLid, inLid);
	}
}


#ifdef BT_QOS
// Start any application if it hasn't been started yet. Currently not used. 
void
BTHost::startApps()
{
	Tcl& tcl = Tcl::instance();
	for(int i = 0; i < MaxNumLinks; i++) {
		//TrafficGenerator* trafgen = static_cast<TrafficGenerator*>(trafgen_[i]);
		//if(trafgen && !trafgen->running()) {
		if(trafgen_[i] != NULL) {
			TRACE_BT(LEVEL_HIGH, "STARTING APPLS: bd_addr %-4d, \n", hciGetBdAddr());
			tcl.evalf("%s start", trafgen_[i]->name()); // start() is a protected method
		}
	}
}

// Find application names and fill flowSpecs for well known applications. Currently not used. 
void
BTHost::findAppNames()
{
	Tcl& tcl = Tcl::instance();
	for (int i=0; i< MaxNumLinks; i++) {
		tcl.evalf("%s info class", trafgen_[i]->name()); 
		app_names_[i] = tcl.result();
		const char* p = app_names_[i].c_str();
		if (strcmp(p,"Application/Traffic/Exponential")==0) {
			tcl.evalf("%s set packet_size_", trafgen_[i]->name()); 
			int mtu = atoi(tcl.result());
			app_flow_spec_[i]->mtu = mtu;
			app_flow_spec_[i]->token_rate = 64;
			app_flow_spec_[i]->token_bucket = 30000;
			app_flow_spec_[i]->input_qlen = 30;
			app_flow_spec_[i]->peak_bw = 100000;
			app_flow_spec_[i]->latency = 100;
			app_flow_spec_[i]->loss_sensitivity = 1;
		}

		if (strcmp(p,"Application/Telnet") == 0) {
			app_flow_spec_[i]->mtu = 100;  		// Don't care
			app_flow_spec_[i]->token_rate = 0; 	// Don't care
			app_flow_spec_[i]->token_bucket = 0; 	// Don't care
			app_flow_spec_[i]->input_qlen = 0; 	// Don't care
			app_flow_spec_[i]->peak_bw = 0; 		// Don't care
			app_flow_spec_[i]->latency = -1; 		// Minimize
			app_flow_spec_[i]->loss_sensitivity = 1;
		}

		if (strcmp(p,"Application/FTP") == 0) {
			app_flow_spec_[i]->mtu = 1000; 		// large
			app_flow_spec_[i]->token_rate = -1; 	// MAX
			app_flow_spec_[i]->token_bucket = -1; 	// MAX
			app_flow_spec_[i]->input_qlen = -1; 	// MAX
			app_flow_spec_[i]->peak_bw = -1; 		// MAX
			app_flow_spec_[i]->latency = 0; 		// Don't care 
			app_flow_spec_[i]->loss_sensitivity = 0;
		}
		printf("_%d_ appname[%d] = %s\n", hciGetBdAddr(), i, p);
	}
}
#endif

/******************************************************************************************
 * HCIEventsHandler routines
 ******************************************************************************************/

HCIEventsHandler::HCIEventsHandler() : host_(NULL)
{
}

inline Baseband*
HCIEventsHandler::lm() const
{ 
	return host()->lm(); 
}

inline LMP*
HCIEventsHandler::lmp(uchar ch) const 
{
	return host()->lmp(ch); 
}

