/* -*-	Mode:C++; c-basic-offset:8; tab-width:8; indent-tabs-mode:t -*- */
/*==================================================================
			LEAKY BUCKET FILTER
 ==================================================================*/

#ifndef ns_lbf_h
#define ns_lbf_h


#include <bi-connector.h>


class SendHandler : public Handler {
public:
	SendHandler(LBF* lbf) : lbf_(lbf) {}
	void handle(Event* e);
	LBF* lbf_;
};


class TokenHandler : public Handler {
public:
	TokenHandler(LBF* lbf) : lbf_(lbf) {}
	void handle(Event* e);
	LBF* lbf_;
};


class LBF : public BiConnector {
	friend class SendHandler;
	friend class TokenHandler;
	int firsttime_;
	void updatetokens();
	double tokens_; 
	double token_rate_; 
	int bucket_; 
	int qlength_;
	int conn_handle_;
	double peak_bw_;
	double lastupdate_;
	PacketQueue *input_q_;
	PacketQueue *blocked_q_;
	Event send_ev_;
	SendHandler sh_;
	TokenHandler th_;
public:
	LBF();
	void release();
	void setParameters(flowSpec*);
	void recv(Packet *, Handler *);
};



#endif // ns_lbf_h
