/* -*-	Mode:C++; c-basic-offset:8; tab-width:8; indent-tabs-mode:t -*- */
/**************************************************************************************************
*IBM Public License Version 1.0 
*
*THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS IBM PUBLIC LICENSE ("AGREEMENT"). ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS AGREEMENT. 
*
*1. DEFINITIONS 
*
*"Contribution" means: 
*
*       a) in the case of International Business Machines Corporation ("IBM"), the Original Program, and 
*
*       b) in the case of each Contributor, 
*
*       i) changes to the Program, and
*
*       ii) additions to the Program;
*
*       where such changes and/or additions to the Program originate from and are distributed by that particular Contributor. A Contribution 'originates' from a Contributor if it
*       was added to the Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions do not include additions to the Program which: (i) are
*       separate modules of software distributed in conjunction with the Program under their own license agreement, and (ii) are not derivative works of the Program.
*
*  "Contributor" means IBM and any other entity that distributes the Program. 
*
*  "Licensed Patents " mean patent claims licensable by a Contributor which are necessarily infringed by the use or sale of its Contribution alone or when combined with the
*  Program. 
*
*  "Original Program" means the original version of the software accompanying this Agreement as released by IBM, including source code, object code and documentation, if
*  any. 
*
*  "Program" means the Original Program and Contributions. 
*
*  "Recipient" means anyone who receives the Program under this Agreement, including all Contributors. 
*
*  2. GRANT OF RIGHTS 
*
*       a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive, worldwide, royalty-free copyright license to reproduce, prepare
*       derivative works of, publicly display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, and such derivative works, in source code
*       and object code form.
*
*       b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive, worldwide, royalty-free patent license under Licensed Patents to
*       make, use, sell, offer to sell, import and otherwise transfer the Contribution of such Contributor, if any, in source code and object code form. This patent license shall
*       apply to the combination of the Contribution and the Program if, at the time the Contribution is added by the Contributor, such addition of the Contribution causes
*       such combination to be covered by the Licensed Patents. The patent license shall not apply to any other combinations which include the Contribution. No hardware per
*       se is licensed hereunder. 
*
*       c) Recipient understands that although each Contributor grants the licenses to its Contributions set forth herein, no assurances are provided by any Contributor that
*       the Program does not infringe the patent or other intellectual property rights of any other entity. Each Contributor disclaims any liability to Recipient for claims brought
*       by any other entity based on infringement of intellectual property rights or otherwise. As a condition to exercising the rights and licenses granted hereunder, each
*       Recipient hereby assumes sole responsibility to secure any other intellectual property rights needed, if any. For example, if a third party patent license is required to
*       allow Recipient to distribute the Program, it is Recipient's responsibility to acquire that license before distributing the Program.
*
*       d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its Contribution, if any, to grant the copyright license set forth in this
*       Agreement. 
*
*  3. REQUIREMENTS 
*
*  A Contributor may choose to distribute the Program in object code form under its own license agreement, provided that: 
*
*       a) it complies with the terms and conditions of this Agreement; and
*
*       b) its license agreement:
*
*       i) effectively disclaims on behalf of all Contributors all warranties and conditions, express and implied, including warranties or conditions of title and non-infringement,
*       and implied warranties or conditions of merchantability and fitness for a particular purpose; 
*
*       ii) effectively excludes on behalf of all Contributors all liability for damages, including direct, indirect, special, incidental and consequential damages, such as lost
*       profits; 
*
*       iii) states that any provisions which differ from this Agreement are offered by that Contributor alone and not by any other party; and
*
*       iv) states that source code for the Program is available from such Contributor, and informs licensees how to obtain it in a reasonable manner on or through a medium
*       customarily used for software exchange. 
*
*  When the Program is made available in source code form: 
*
*       a) it must be made available under this Agreement; and 
*
*       b) a copy of this Agreement must be included with each copy of the Program. 
*
*  Each Contributor must include the following in a conspicuous location in the Program: 
*
*       Copyright  2002 International Business Machines Corporation, 
*       Massachusetts Institute of Technology, and others. All Rights Reserved. 
*
*  In addition, each Contributor must identify itself as the originator of its Contribution, if any, in a manner that reasonably allows subsequent Recipients to identify the originator
*  of the Contribution. 
*
*  4. COMMERCIAL DISTRIBUTION 
*
*  Commercial distributors of software may accept certain responsibilities with respect to end users, business partners and the like. While this license is intended to facilitate the
*  commercial use of the Program, the Contributor who includes the Program in a commercial product offering should do so in a manner which does not create potential liability
*  for other Contributors. Therefore, if a Contributor includes the Program in a commercial product offering, such Contributor ("Commercial Contributor") hereby agrees to defend
*  and indemnify every other Contributor ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising from claims, lawsuits and other legal
*  actions brought by a third party against the Indemnified Contributor to the extent caused by the acts or omissions of such Commercial Contributor in connection with its
*  distribution of the Program in a commercial product offering. The obligations in this section do not apply to any claims or Losses relating to any actual or alleged intellectual
*  property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the Commercial Contributor in writing of such claim, and b) allow the Commercial
*  Contributor to control, and cooperate with the Commercial Contributor in, the defense and any related settlement negotiations. The Indemnified Contributor may participate in
*  any such claim at its own expense. 
*
*  For example, a Contributor might include the Program in a commercial product offering, Product X. That Contributor is then a Commercial Contributor. If that Commercial
*  Contributor then makes performance claims, or offers warranties related to Product X, those performance claims and warranties are such Commercial Contributor's
*  responsibility alone. Under this section, the Commercial Contributor would have to defend claims against the other Contributors related to those performance claims and
*  warranties, and if a court requires any other Contributor to pay any damages as a result, the Commercial Contributor must pay those damages. 
*
*  5. NO WARRANTY 
*
*  EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
*  KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT,
*  MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness of using and distributing the
*  Program and assumes all risks associated with its exercise of rights under this Agreement, including but not limited to the risks and costs of program errors, compliance with
*  applicable laws, damage to or loss of data, programs or equipment, and unavailability or interruption of operations. 
*
*  6. DISCLAIMER OF LIABILITY 
*
*  EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE ANY LIABILITY FOR ANY DIRECT,
*  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND
*  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
*  OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF ADVISED OF THE POSSIBILITY OF
*  SUCH DAMAGES. 
*
*  7. GENERAL 
*
*  If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not affect the validity or enforceability of the remainder of the terms of this
*  Agreement, and without further action by the parties hereto, such provision shall be reformed to the minimum extent necessary to make such provision valid and enforceable. 
*
*  If Recipient institutes patent litigation against a Contributor with respect to a patent applicable to software (including a cross-claim or counterclaim in a lawsuit), then any
*  patent licenses granted by that Contributor to such Recipient under this Agreement shall terminate as of the date such litigation is filed. In addition, If Recipient institutes
*  patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding combinations of the Program with other
*  software or hardware) infringes such Recipient's patent(s), then such Recipient's rights granted under Section 2(b) shall terminate as of the date such litigation is filed. 
*
*  All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the material terms or conditions of this Agreement and does not cure such failure in a
*  reasonable period of time after becoming aware of such noncompliance. If all Recipient's rights under this Agreement terminate, Recipient agrees to cease use and
*  distribution of the Program as soon as reasonably practicable. However, Recipient's obligations under this Agreement and any licenses granted by Recipient relating to the
*  Program shall continue and survive. 
*
*  IBM may publish new versions (including revisions) of this Agreement from time to time. Each new version of the Agreement will be given a distinguishing version number. The
*  Program (including Contributions) may always be distributed subject to the version of the Agreement under which it was received. In addition, after a new version of the
*  Agreement is published, Contributor may elect to distribute the Program (including its Contributions) under the new version. No one other than IBM has the right to modify this
*  Agreement. Except as expressly stated in Sections 2(a) and 2(b) above, Recipient receives no rights or licenses to the intellectual property of any Contributor under this
*  Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not expressly granted under this Agreement are reserved. 
*
*  This Agreement is governed by the laws of the State of New York and the intellectual property laws of the United States of America. No party to this Agreement will bring a
*  legal action under this Agreement more than one year after the cause of action arose. Each party waives its rights to a jury trial in any resulting litigation. 
**********************************************************************************************************************/
/***
 * Class LinkController: implements the stop and wait ARQ based on 
 * current and next register as is the Bluetooth baseband specifications. 
 * There are 7 instances of the link controller at the master  but only 
 * the first N<7 are used, where N is the number of slaves in the 
 * piconet. A slave has a single instance. 
 * Actually, a slave node has many instances as the number of piconets it belongs to. 
 * The slave links are directly managed by Baseband
*/


#include <bt-core.h>

// For now, a pkt is retransmitted until successful
#define RETRASMIT_FOREVER


static class LinkContClass : public TclClass {
public:
	LinkContClass() : TclClass("LinkController") {}
	TclObject* create(int, const char*const*) {
		return (new LinkController);
	}
} class_linkcont;


LinkController::LinkController() : tx_cnt_(0), seq_(0), seq_old_(1), ack_(0), am_addr_(0)
{
	// stop trying retransmitting a packet after tx_thresh attempts
	bind("tx_thresh_", &tx_thresh_);
	// initialized at the master side (1 to 7) when a master is created
	bind("am_addr_", &am_addr_);

	curr_reg_ = next_reg_ = 0;
	max_pkt_size_ = MaxBtPktSize;
}

// Called when a packet is received from the upper layer. 
void 
LinkController::sendDown (Packet* p, Handler* h) 
{
	next_reg_ = p;        
	if (!curr_reg_) // check if ack of last tx packet is received 
		switchReg();  			
}

/* This function is used to convey to the scheduler whether the forward queue 
 * for an AM address has data to send. Here data could even be LMP or L2CAP signaling */ 
int
LinkController::pktSize() const
{
	Packet* pkt = curr_reg_;
	if (pkt) {
		hdr_bt* bt = HDR_BT(pkt);
		return (Payload[bt->type]);
	}
	else
		return 0;
}

/* Set the maximum packet size (in slots) to be transmitted in the future. */
void
LinkController::setMaxPktSize(int sz)
{
	ASSERT(sz > 0);
	max_pkt_size_ = sz;
}

/* If PKTSIZE != -1, send a packet of size <= pktSize. Otherwise, max_pkt_size_ is used. */
Packet*  
LinkController::send(int pktSize)
{
	LMP* linkq = (LMP*)uptarget_;
	if(pktSize <= 0)
		pktSize = max_pkt_size_;

	if(curr_reg_) {
		//!GT if not we have to make sure the following code to use pktSize
		if(!(SlotSize[HDR_BT(curr_reg_)->type] <= pktSize)) {
			TRACE_BT(LEVEL_HIGH, "_%d_ pktSize %d type %d currSize %f\n", 
				  lmp()->lm()->bd_addr(), pktSize, HDR_BT(curr_reg_)->type, SlotSize[HDR_BT(curr_reg_)->type]);
			ASSERT(next_reg_ == NULL);
			switchReg(); // curr_reg will become null
			//ASSERT(0);
		}
	}
	else {
		switchReg(); // curr_reg will become next_reg_
	}

	if(!curr_reg_)
		curr_reg_ = linkq->send(pktSize);

	//Copy the packet and send the copy
	if (curr_reg_) {
		//if the current register has a packet, copy it
		// and send it off if transmission count is less than a threshold.
		Packet* p = COPYP(curr_reg_);
		hdr_cmn* ch = HDR_CMN(p);
		tx_cnt_++;
		if ((tx_cnt_ > 1) && (ch->ptype() == PT_EXP)) {
			tx_cnt_ = tx_thresh_+1;
		}
#ifdef RETRASMIT_FOREVER
		if(true) { // RETRY FOREVER!!
#else
		if (tx_cnt_ <= tx_thresh_) {
#endif	
			if(tx_cnt_ > 1)
				TRACE_BT(LEVEL_PACKET, "_%d_ Retransmitting %s\n", 
					 lmp()->lm()->bd_addr(), HDR_BT(p)->toString());
			compose_pkt(p);
			return p;
		}
		else {
			// if transmission count is exceeded, discard the 
			// packet. needs to take care of discarding following 
			// segments of the same L2CAP packet
			TRACE_BT(LEVEL_MED, "Discarding the packet after multiple attempts\n", HDR_BT(p)->toString());
			ASSERT(0); 
			LMP* linkq = dynamic_cast<LMP*>(uptarget_);
			linkq->dropped(p);
			FREEP(p);
			tx_cnt_ = 0;
			if (curr_reg_) {
				FREEP(curr_reg_);
				curr_reg_ = 0;
				switchReg();
			}
			return NULL;
		}
	}
	else if (ack_) {
		// If there is no packet to send but a packet to acknowledge, send a NULL packet		
		Packet* p = Baseband::allocBBPkt(BT_NULL, am_addr_);
		compose_pkt(p);
		return p;
	}
	return NULL;
}
	
	
// set ARQ related fields of the packet and am_addr_.
void 
LinkController::compose_pkt(Packet* p)
{
	hdr_bt*  bt = HDR_BT(p);
  	bt->seqn= seq_;
	bt->arqn= ack_;
	bt->am_addr = am_addr_;
	ack_ = 0;
}

void 
LinkController::sendUp(Packet* p, Handler* h)
{
	hdr_cmn* ch = HDR_CMN(p);
	hdr_bt*  bt = HDR_BT(p);

	lmp()->recvd(curr_reg_, p);

	if (bt->type == BT_NULL) {
		//receive ack from a NULL packet
		if (bt->arqn) 
			recvACK();
		FREEP(p);
		return; 
	}
	else if(bt->type == BT_POLL) {
		FREEP(p);
		return; 
	}
	else {
		//Discard duplicate packet ...
		if (bt->seqn == seq_old_) {
			ack_=1;
			// ... but see if it carries a new ACK
			if (bt->arqn) 
				recvACK();

			if(bt->ph.l_ch ==  LMP_CHAN || bt->ph.l_ch == HOST_CHAN) {
				TRACE_BT(LEVEL_MED, "DUPLICATE PKT RECV %s \n", bt->toString());
				uchar* d = p->accessdata();
				if(bt->ph.l_ch == LMP_CHAN) {
					TRACE_BT(LEVEL_MED, "DUP LMP PACKET %s\n", LMPCommandStr[d[0]]);
				}
				else {
					ASSERT(0); //@GT
				}
			}
			FREEP(p);
		}
		
		else 
		{	
			//Handle corrupt packet
			if (ch->error()) {
				ASSERT(0); //@GT
				FREEP(p);    
				ack_=0;
			}

			//Handle valid data packet
			else {
				// set ack bit to acknowledge the packet
				ack_=1;
				// update sequence number
				seq_old_ = bt->seqn;
				// receive ACK
				if (bt->arqn) 
					recvACK();
				/* following block to make the slave 
				side aware of its AM_ADDR through the
				connection request LMP PDU */
				if (bt->ph.l_ch == LMP_CHAN) {
					uchar* data = p->accessdata();
					if (data[0] == LMP_HOST_CONN_REQ)
						am_addr_ = bt->am_addr;
				}
				// send to upper layer
				uptarget_->recv(p,h);
			}
		}
	}
}

// Switch between current and next register, see Bluetooth baseband Specifications.
void 
LinkController::switchReg()
{
	Packet* temp; 
	temp = curr_reg_;
	curr_reg_ = next_reg_;
	next_reg_ = temp;
}

void 
LinkController::flushPkt(packet_t type)
{
	if(curr_reg_ && HDR_CMN(curr_reg_)->ptype() == type) {
		TRACE_BT(LEVEL_HIGH, "_%d_ LinkController::flushPkt DROPPING %s\n", 
			  lmp()->lm()->bd_addr(), BTHost::toString(curr_reg_));
		lmp()->dropped(curr_reg_);
		FREEP(curr_reg_);
		curr_reg_ = NULL;
	}
	if(next_reg_ && HDR_CMN(next_reg_)->ptype() == type) {
		TRACE_BT(LEVEL_HIGH, "_%d_ LinkController::flushPkt DROPPING %s\n", 
			  lmp()->lm()->bd_addr(), BTHost::toString(next_reg_));
		lmp()->dropped(next_reg_);
		FREEP(next_reg_);
		next_reg_ = NULL;
	}

}

// initialize ARQ related variables for the new connection.
void 
LinkController::initialize()
{
	resetARQ();
	if(curr_reg_) {
		TRACE_BT(LEVEL_HIGH, "_%d_ LinkController::initialize DROPPING %s\n", 
			  lmp()->lm()->bd_addr(), BTHost::toString(curr_reg_));
		lmp()->dropped(curr_reg_);
		FREEP(curr_reg_);
	}

	if(next_reg_) {
		lmp()->dropped(next_reg_);
		FREEP(next_reg_);
	}
	curr_reg_ = 0;
	next_reg_ = 0;
}

void
LinkController::resetARQ()
{
	seq_ = ack_ = tx_cnt_ = 0;
	seq_old_ = 1;
}

/* Receive acknowledgement for the packet (c_u_r_r__r_e_g_) sent. 
 * TYPE is the type of the replied packet. */
void
LinkController::recvACK() 
{	
	//update next sequence number to be sent
	seq_ = 1-seq_;
	tx_cnt_ = 0;
	if (curr_reg_) {
		FREEP(curr_reg_);
	}
	curr_reg_ = 0;
	switchReg();
}

void
LinkController::setAmAddr(int am_addr) 
{
	// This is NEEDED since HOST_CONNECTION_REQ may not receive during the topo formation process!
	am_addr_ = am_addr;
}

LMP*
LinkController::lmp() const
{
	return dynamic_cast<LMP*>(uptarget_);
}

void
LinkController::transmitted()
{
	lmp()->transmitted(curr_reg_);
}

