/* -*-	Mode:C++; c-basic-offset:8; tab-width:8; indent-tabs-mode:t -*- */
/**************************************************************************************************
*IBM Public License Version 1.0 
*
*THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS IBM PUBLIC LICENSE ("AGREEMENT"). ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS AGREEMENT. 
*
*1. DEFINITIONS 
*
*"Contribution" means: 
*
*       a) in the case of International Business Machines Corporation ("IBM"), the Original Program, and 
*
*       b) in the case of each Contributor, 
*
*       i) changes to the Program, and
*
*       ii) additions to the Program;
*
*       where such changes and/or additions to the Program originate from and are distributed by that particular Contributor. A Contribution 'originates' from a Contributor if it
*       was added to the Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions do not include additions to the Program which: (i) are
*       separate modules of software distributed in conjunction with the Program under their own license agreement, and (ii) are not derivative works of the Program.
*
*  "Contributor" means IBM and any other entity that distributes the Program. 
*
*  "Licensed Patents " mean patent claims licensable by a Contributor which are necessarily infringed by the use or sale of its Contribution alone or when combined with the
*  Program. 
*
*  "Original Program" means the original version of the software accompanying this Agreement as released by IBM, including source code, object code and documentation, if
*  any. 
*
*  "Program" means the Original Program and Contributions. 
*
*  "Recipient" means anyone who receives the Program under this Agreement, including all Contributors. 
*
*  2. GRANT OF RIGHTS 
*
*       a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive, worldwide, royalty-free copyright license to reproduce, prepare
*       derivative works of, publicly display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, and such derivative works, in source code
*       and object code form.
*
*       b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive, worldwide, royalty-free patent license under Licensed Patents to
*       make, use, sell, offer to sell, import and otherwise transfer the Contribution of such Contributor, if any, in source code and object code form. This patent license shall
*       apply to the combination of the Contribution and the Program if, at the time the Contribution is added by the Contributor, such addition of the Contribution causes
*       such combination to be covered by the Licensed Patents. The patent license shall not apply to any other combinations which include the Contribution. No hardware per
*       se is licensed hereunder. 
*
*       c) Recipient understands that although each Contributor grants the licenses to its Contributions set forth herein, no assurances are provided by any Contributor that
*       the Program does not infringe the patent or other intellectual property rights of any other entity. Each Contributor disclaims any liability to Recipient for claims brought
*       by any other entity based on infringement of intellectual property rights or otherwise. As a condition to exercising the rights and licenses granted hereunder, each
*       Recipient hereby assumes sole responsibility to secure any other intellectual property rights needed, if any. For example, if a third party patent license is required to
*       allow Recipient to distribute the Program, it is Recipient's responsibility to acquire that license before distributing the Program.
*
*       d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its Contribution, if any, to grant the copyright license set forth in this
*       Agreement. 
*
*  3. REQUIREMENTS 
*
*  A Contributor may choose to distribute the Program in object code form under its own license agreement, provided that: 
*
*       a) it complies with the terms and conditions of this Agreement; and
*
*       b) its license agreement:
*
*       i) effectively disclaims on behalf of all Contributors all warranties and conditions, express and implied, including warranties or conditions of title and non-infringement,
*       and implied warranties or conditions of merchantability and fitness for a particular purpose; 
*
*       ii) effectively excludes on behalf of all Contributors all liability for damages, including direct, indirect, special, incidental and consequential damages, such as lost
*       profits; 
*
*       iii) states that any provisions which differ from this Agreement are offered by that Contributor alone and not by any other party; and
*
*       iv) states that source code for the Program is available from such Contributor, and informs licensees how to obtain it in a reasonable manner on or through a medium
*       customarily used for software exchange. 
*
*  When the Program is made available in source code form: 
*
*       a) it must be made available under this Agreement; and 
*
*       b) a copy of this Agreement must be included with each copy of the Program. 
*
*  Each Contributor must include the following in a conspicuous location in the Program: 
*
*       Copyright  2002 International Business Machines Corporation, 
*       Massachusetts Institute of Technology, and others. All Rights Reserved. 
*
*  In addition, each Contributor must identify itself as the originator of its Contribution, if any, in a manner that reasonably allows subsequent Recipients to identify the originator
*  of the Contribution. 
*
*  4. COMMERCIAL DISTRIBUTION 
*
*  Commercial distributors of software may accept certain responsibilities with respect to end users, business partners and the like. While this license is intended to facilitate the
*  commercial use of the Program, the Contributor who includes the Program in a commercial product offering should do so in a manner which does not create potential liability
*  for other Contributors. Therefore, if a Contributor includes the Program in a commercial product offering, such Contributor ("Commercial Contributor") hereby agrees to defend
*  and indemnify every other Contributor ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising from claims, lawsuits and other legal
*  actions brought by a third party against the Indemnified Contributor to the extent caused by the acts or omissions of such Commercial Contributor in connection with its
*  distribution of the Program in a commercial product offering. The obligations in this section do not apply to any claims or Losses relating to any actual or alleged intellectual
*  property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the Commercial Contributor in writing of such claim, and b) allow the Commercial
*  Contributor to control, and cooperate with the Commercial Contributor in, the defense and any related settlement negotiations. The Indemnified Contributor may participate in
*  any such claim at its own expense. 
*
*  For example, a Contributor might include the Program in a commercial product offering, Product X. That Contributor is then a Commercial Contributor. If that Commercial
*  Contributor then makes performance claims, or offers warranties related to Product X, those performance claims and warranties are such Commercial Contributor's
*  responsibility alone. Under this section, the Commercial Contributor would have to defend claims against the other Contributors related to those performance claims and
*  warranties, and if a court requires any other Contributor to pay any damages as a result, the Commercial Contributor must pay those damages. 
*
*  5. NO WARRANTY 
*
*  EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
*  KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT,
*  MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness of using and distributing the
*  Program and assumes all risks associated with its exercise of rights under this Agreement, including but not limited to the risks and costs of program errors, compliance with
*  applicable laws, damage to or loss of data, programs or equipment, and unavailability or interruption of operations. 
*
*  6. DISCLAIMER OF LIABILITY 
*
*  EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE ANY LIABILITY FOR ANY DIRECT,
*  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND
*  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
*  OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF ADVISED OF THE POSSIBILITY OF
*  SUCH DAMAGES. 
*
*  7. GENERAL 
*
*  If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not affect the validity or enforceability of the remainder of the terms of this
*  Agreement, and without further action by the parties hereto, such provision shall be reformed to the minimum extent necessary to make such provision valid and enforceable. 
*
*  If Recipient institutes patent litigation against a Contributor with respect to a patent applicable to software (including a cross-claim or counterclaim in a lawsuit), then any
*  patent licenses granted by that Contributor to such Recipient under this Agreement shall terminate as of the date such litigation is filed. In addition, If Recipient institutes
*  patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding combinations of the Program with other
*  software or hardware) infringes such Recipient's patent(s), then such Recipient's rights granted under Section 2(b) shall terminate as of the date such litigation is filed. 
*
*  All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the material terms or conditions of this Agreement and does not cure such failure in a
*  reasonable period of time after becoming aware of such noncompliance. If all Recipient's rights under this Agreement terminate, Recipient agrees to cease use and
*  distribution of the Program as soon as reasonably practicable. However, Recipient's obligations under this Agreement and any licenses granted by Recipient relating to the
*  Program shall continue and survive. 
*
*  IBM may publish new versions (including revisions) of this Agreement from time to time. Each new version of the Agreement will be given a distinguishing version number. The
*  Program (including Contributions) may always be distributed subject to the version of the Agreement under which it was received. In addition, after a new version of the
*  Agreement is published, Contributor may elect to distribute the Program (including its Contributions) under the new version. No one other than IBM has the right to modify this
*  Agreement. Except as expressly stated in Sections 2(a) and 2(b) above, Recipient receives no rights or licenses to the intellectual property of any Contributor under this
*  Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not expressly granted under this Agreement are reserved. 
*
*  This Agreement is governed by the laws of the State of New York and the intellectual property laws of the United States of America. No party to this Agreement will bring a
*  legal action under this Agreement more than one year after the cause of action arose. Each party waives its rights to a jury trial in any resulting litigation. 
**********************************************************************************************************************/


/**************************************************************************************************
 LMP module: This class simulates LMP signaling 
 related to connection establishment and QoS negotiation.
 It should be very easy to add more LMP exchanges. 
 Since this sits on top of the stop and wait ARQ 
 (Link Controller) it provides reliable delivery 
 (at least for a large value of tx_thresh). 
 
 Also since this object sits just above the ARQ object 
 in BTNode, it seems logical to house the queues 
 containing LMP and L2CAP traffic in this layer. Since
 there is one LMP and one L2CAP queue per slave, master
 will require upto 7 instance of this class if the same
 class is to be used for the slave.
 
 It also implements those HCI commands which require 
 LMP exchanges because the LMP PDUs have to be 
 sent over a reliable channel while our Baseband class
 sits below the link controller.
 **************************************************************************************************/


#include <bt-core.h>


#define BEGIN_LMP_SESS(x) if(lm_->getSessionInProg() == NONE_IN_PROG) { \
                                lm_->beginSession(LMP_IN_PROG, x, this); \
                                ASSERT(ev_.uid_ <= 0); \
                       } else if (lm_->getSessionInProg() != LMP_IN_PROG) { \
				Scheduler::instance().schedule(this, &ev_, 20*SlotTime); \
				return; \
		       } 


#define END_LMP_SESS() { if(lm_->getSessionInProg() ==LMP_IN_PROG) \
                                 lm_->endSession(LMP_IN_PROG); \
                         ev_.task_ = DIS_ALL; }


LMPTestHandler* LMPTestHandler::testHandler = NULL;
LMPEvent* LMPTestHandler::testEvent = NULL;


static class LMPClass : public TclClass {
public:
	LMPClass() : TclClass ("LMP") {}
	TclObject* create(int,const char*const*) {
		return (new LMP());
	}
} class_lmp;


LMP::LMP() 
{
	bind("am_addr_", (int*)(&am_addr_));		
	am_addr_ = 0;
	lm_ = NULL;
	sched_ = NULL;
	policy_ = (link_policy) (EN_SWITCH | EN_HOLD | EN_SNIFF | EN_PARK | EN_CONN);
	pkts_queued_ = 0;
}

int 
LMP::command(int argc, const char*const* argv)
{
	Queue* que = NULL;

	if (argc == 3) {
		if (strcmp(argv[1], "bthost") == 0) {
			host_ = (BTHost*)TclObject::lookup(argv[2]);
		 	return (TCL_OK);
		}
		else if (strcmp(argv[1], "sched") == 0) {
			sched_ = (BTScheduler*)TclObject::lookup(argv[2]);
		 	return (TCL_OK);
		}
		else if (strcmp(argv[1], "tbf") == 0) {
			tbf_ = (LBF*)TclObject::lookup(argv[2]);
		 	return (TCL_OK);
		}
		else if (strcmp(argv[1], "bb") == 0) {
			lm_ = (Baseband*)TclObject::lookup(argv[2]);
		 	return (TCL_OK);
		}
		else if (strcmp(argv[1], "queue") == 0) {
			que = (Queue*)TclObject::lookup(argv[2]);
			ASSERT(que);
			l2capq_.init(this, que, MaxDataQueSize, 2);
		 	return (TCL_OK);
		}
	}

	return (BiConnector::command(argc, argv));
}

Packet*
LMP::send(int pktSize)
{
	hdr_bt* bt = NULL;
	Packet* p = dequePkt(lmpq_, pktSize);

	if (!p) 
		p = dequePkt(hostq_, pktSize);

	if (!p) {
		p = l2capq_.deque(pktSize);
	}

	if(!p) {
		p = host()->send(lid_); 
	}
	else {
		bt = HDR_BT(p);
		pkts_queued_ -= SlotSize[bt->type];
		if(!(pkts_queued_ >= 0))
			ASSERT(0);
	}
	return p;
}

void
LMP::clear()
{
	Packet* p = NULL;

	while((p = dequePkt(lmpq_, MaxBtPktSize)))
		delete p;
	while((p =  dequePkt(hostq_, MaxBtPktSize))) 
		delete p;
	while((p =  l2capq_.deque(MaxBtPktSize)))
		delete p;
	pkts_queued_ = 0;
}

// L2CAP or LMP packet going down the stack.
void
LMP::sendDown(Packet* p, Handler* h)
{	
	hdr_bt* bt = HDR_BT(p);
	bt->am_addr = am_addr_;
	uchar l_ch = bt->ph.l_ch;

	pkts_queued_ += SlotSize[bt->type]; // do this before enque
	// enque it in the proper queue based on logical channel number
	if (l_ch == LMP_CHAN)
		lmpq_.push_back(p);
	else if (l_ch == HOST_CHAN) 
		hostq_.push_back(p);
	else {
		l2capq_.enque(p);
	}
}

void 
LMP::sendLMPCommand(uchar opcode, int nArgs, ...)
{
	Packet* p = ALLOCP1(1+(4*nArgs)); // 1byte opcode + N params
	hdr_bt* bt = HDR_BT(p);
	hdr_cmn* ch = HDR_CMN(p);
	bt->type = BT_DM1;
	ch->size() = Payload[bt->type];
	bt->ph.l_ch = LMP_CHAN;

	uchar* data = p->accessdata();
	data[0] = opcode;
	data++; // incr one byte to start copying params

	va_list ap;
	va_start(ap, nArgs);

	unsigned int arg = 0, first = 0;

	for(int i = 0; i < nArgs; i++) {
		arg = va_arg(ap, unsigned int);
		if(i == 0)
			first = arg;
		memcpy((void*)(data+(i*4)), (void*)&arg, 4);
	}
	va_end(ap);


	TRACE_BT(LEVEL_FUNCTION, "_%d_ sendLMPCommand: %s, nArgs %d, first %d\n", 
		  lm_->bd_addr(), LMPCommandStr[opcode], nArgs,first);
	sendDown(p, 0);
}

// BTHost accepts the connection
void
LMP::hciAcceptConnectionRequest ()
{
	ev_.task_ = EN_CONN; 
	ev_.step_ = RECV_CMD;
	handle(&ev_);
}	

// BTHost requires a change in the packet size used
void
LMP::hciChangeConnectionPacketType (uchar packet_type)
{
	packet_type_ = packet_type;
}	

// BTHost requires QoS setup
void
LMP::hciQoSSetup (flowSpec* qos)
{
	// find if the QoS can be supported by the scheduler
	uchar result = 0; //sched_->mapQoS(lid_, qos, &qoslm_);
	if (result) {
		//tbf_->setParameters(qos);
		sendLMPCommand(LMP_QOS_REQ, 1, qoslm_.polling_interval);
	}
	else 
		host()->hciQoSSetupCompleteEvent(-1, BT_NULL);
}

// Negotiate with the other end node to enter the HOLD mode for TICKS ticks. 
void
LMP::hciHoldMode(int ticks)
{
	ev_.task_ = EN_HOLD;
	ev_.intv_ = ticks;
	ev_.step_ = SEND_CMD;
	handle(&ev_);
}

// Perform a role-switch with the other end node. 
void
LMP::hciSwitch()
{
	ev_.task_ = EN_SWITCH;
	ev_.step_ = SEND_CMD;
	handle(&ev_);
}

void
LMP::sendUp (Packet* p, Handler* h) 
{
	hdr_bt* bt = HDR_BT(p);
	uchar am_addr = bt->am_addr;

	if (bt->ph.l_ch == LMP_CHAN) {
		uchar* data = p->accessdata();
		int* params = (int*)(data+1);
		TRACE_BT(LEVEL_HIGH, "_%d_ %s\t AM_ADDR: %-10d %s\n", 
			  lm_->bd_addr(), LMPCommandStr[data[0]], am_addr_, bt->toString());

		switch (data[0]) {
		case LMP_HOST_CONN_REQ:
			// inform bthost about connection request from remote host
			// This is a little bit different than other ops since we are allowing the host to decide.
			ASSERT(am_addr);
			am_addr_ = am_addr;
			host()->hciConnectionRequestEvent(bt->lid_);
#if defined(GT_TEST_ROLE_SLV)
			if(lm_->bd_addr() == 1 && bt->send_id_ == 0) { //rolesw.tcl (0 is the master)
				LMPTestHandler::schedule(this, EN_SWITCH);
			}
#endif
#ifdef GT_TEST_ROLE_SLV1
			if(lm_->bd_addr() == 1 && bt->send_id_ == 2) {   //rolesw1.tcl (1 bridges 0 and 2 as slave
				LMPTestHandler::schedule(this, EN_SWITCH, 2);
			}
#endif
#ifdef GT_TEST_HOLD_SLV
			if(lm_->bd_addr() == 1 && bt->send_id_ == 0) { // slv -> mas (hold.tcl)
				LMPTestHandler::schedule(this, EN_HOLD);
			}
#endif
			break;

		case LMP_QOS_REQ: 
			// accept QoS required, could change this later to negotiation
			sendLMPCommand(LMP_ACCEPTED, 1, (int)LMP_QOS_REQ); 
			break;

		case LMP_HOLD_REQ: 
			if(policy_ & EN_HOLD) {
				ev_.task_ = EN_HOLD;
				ev_.step_ = RECV_CMD;
				ev_.intv_ = params[0];
				ev_.mclkn_ = params[1]; 
				handle(&ev_);
			}
			else
				sendLMPCommand(LMP_NOT_ACCEPTED, 1, (int)LMP_HOLD_REQ);
			break;

		case LMP_HOLD: 
		        // LMP hold received. not implemented!
			ASSERT(0); 
			break;

	        case LMP_SLOT_OFFSET:
			TRACE_BT(LEVEL_HIGH, "offset %d, bd_addr %d\n", params[0], params[1]);
			lm_->recvSlotOffset(params[0], params[1]);
			break;

		case LMP_SWITCH_REQ:
			if(policy_ & EN_SWITCH) {
				ev_.task_ = EN_SWITCH;
				ev_.step_ = RECV_CMD;
				handle(&ev_);
			}
			else
				sendLMPCommand(LMP_NOT_ACCEPTED, 1, (int)LMP_SWITCH_REQ);
			break;

		case LMP_DETACH:
			lm_->detach(this);
			break;

		case LMP_NOT_ACCEPTED:
			ASSERT(0);
			break;

		case LMP_ACCEPTED:
			TRACE_BT(LEVEL_HIGH, " ACCEPTED PDU: %s\n", LMPCommandStr[params[0]]);

			switch (params[0]) {
			case LMP_HOST_CONN_REQ:
				ev_.step_ = RECV_ACCP;
				handle(&ev_);
#ifdef GT_TEST_ROLE_MAS
				if(lm_->bd_addr() == 0 && bt->send_id_ == 1) {//rolesw.tcl (0 is the master)
					LMPTestHandler::schedule(this, EN_SWITCH);
				}
#endif
#ifdef GT_TEST_ROLE_MAS1
				if(lm_->bd_addr() == 2 && bt->send_id_ == 1) {//rolesw1.tcl (1 bridges 0 and 2 as slave
					LMPTestHandler::schedule(this, EN_SWITCH, 2);
				}
#endif
#ifdef GT_TEST_HOLD_MAS
				if(lm_->bd_addr() == 0 && bt->send_id_ == 1) { // mas -> slv (hold.tcl)
					LMPTestHandler::schedule(this, EN_HOLD);
				}
#endif
				break;
				
			case LMP_QOS_REQ:
				// inform bthost that proposed QoS was accepted.
				host()->hciQoSSetupCompleteEvent(lid_, qoslm_.packet_type);
				break;

			case LMP_SWITCH_REQ:
				ev_.am_addr_ = am_addr;
				ev_.step_ = RECV_ACCP;
				handle(&ev_);
				break;

			case LMP_HOLD_REQ:
				ev_.step_ = RECV_ACCP;
				handle(&ev_);
				break;

			default:
				ASSERT(0);
			}
			break;
		default:
			ASSERT(0);
		}
		FREEP(p);
	}	
	else if(bt->ph.l_ch == HOST_CHAN) {
		host()->recvPkt(p, bt->lid_);
	}
        else
		uptarget_->recv(p,this);
}

void
LMP::hciDetach() 
{
	sendLMPCommand(LMP_DETACH , 0);
}

void
LMP::transmitted(Packet* p)
{
	host()->transmitted(p, lid_);
}

void
LMP::recvd(Packet* p, Packet* recvdPkt) 
{
	if(p != NULL) {
		hdr_bt* bt = HDR_BT(p);
		
		if (bt->ph.l_ch == LMP_CHAN) {
			uchar* data = p->accessdata();
			int* params = (int*)(data+1);
			
			switch (data[0]) {
			case LMP_ACCEPTED:
				switch (params[0]) {
				case LMP_HOLD_REQ:
				case LMP_SWITCH_REQ:
				case LMP_HOST_CONN_REQ:
					ASSERT(ev_.task_ != DIS_ALL);
					ev_.step_ = SEND_ACCP;
					handle(&ev_);
					break;
				}
				break;
			}
		}

		if(bt->ph.l_ch != HOST_CHAN && bt->ph.l_ch != LMP_CHAN) {
			//pass it to L2CAP only if the packet sent was its!
			dynamic_cast<L2CAP*>(uptarget_)->recvd(p, lid_, recvdPkt);
		}
	}
	// Let host know about all the packets being received. 
	host()->recvd(p, lid_, recvdPkt);
}

void
LMP::roleChanged(bool bMaster)
{
	lm_->roleChangeInProg(0);
	clear(); // clear all the queues. 
	host()->hciRoleChangeEvent(bMaster, lid_);
}

// A new link has been established.
void
LMP::linkEstablished(bool bMaster)
{
	// After a link has established, remain connected for a while by starting a LMP session.
	BEGIN_LMP_SESS(MinConnSetup);
	if(bMaster) {
		// request to create a lmp connection 
		ev_.task_ = EN_CONN;
		ev_.step_ = SEND_CMD;
		handle(&ev_);
	}
}

void
LMP::linkDestroyed(bool bMaster) 
{
	clear(); // clear all the queues. 
	host()->hciDisconnectionCompleteEvent(lid_);
}

void
LMP::dropped(Packet* p, bool bFrmQue = false)
{
	hdr_bt* bt = HDR_BT(p);
	hdr_cmn* ch = HDR_CMN(p);

	if(bFrmQue) {
		pkts_queued_ -= SlotSize[bt->type];
	}
	if (bt->ph.l_ch == LMP_CHAN) {
		uchar* data = p->accessdata();
		uchar opcode = data[0];
		TRACE_BT(LEVEL_HIGH, "_%d_ DROPPED LMP pkt %d opcode %d\n", lm()->bd_addr(), ch->uid(), opcode);
		return;
	}
	else if(bt->ph.l_ch == HOST_CHAN) {
		host()->dropped(p);
	}
	else {
		dynamic_cast<L2CAP*>(uptarget_)->dropped(p);
		if(bFrmQue && l2capq_.isFull())
			host()->queueFull(lid_, bt->lid_);
	}
}

/* l2capq_ is now full after receiving P. The next packet will be dropped. */
void
LMP::queueFull(Packet* p) 
{
	ASSERT(l2capq_.isFull());
	hdr_bt* bt = HDR_BT(p);
	if(lid_ == bt->lid_) {
		// P is generated by THIS node. 
		//So, ignore this advance notification packet and wait until really drop happens
	}
	else {
		host()->queueFull(lid_, bt->lid_);
	}
}

// When E == NULL, it either means the sesssion has ended due to the timeout or that 
// a new session has interrupted this session. 
void
LMP::handle(Event* e) 
{
	if(e == NULL) {
		END_LMP_SESS();
		return;
	}
	ASSERT(e == &ev_);

	switch(ev_.task_) {
	case EN_CONN:
		switch(ev_.step_) {
		case SEND_CMD:
			ASSERT(lm_->getSessionInProg() == LMP_IN_PROG);
			sendLMPCommand(LMP_HOST_CONN_REQ, 1, 0);
			break;
		case RECV_CMD:
			ASSERT(lm_->getSessionInProg() == LMP_IN_PROG);
			sendLMPCommand(LMP_ACCEPTED , 1, (int)LMP_HOST_CONN_REQ);
			break;
		case SEND_ACCP:
		case RECV_ACCP:
			END_LMP_SESS();
			host()->hciConnectionCompleteEvent(lid_, lm_->isMasLink(lid_));
			break;
		}
		break;

	case EN_HOLD:
		switch(ev_.step_) {
		case SEND_CMD:
		case RECV_CMD:
			if(!lm_->isSessionAvail()) {
				Scheduler::instance().schedule(this, &ev_, 20*SlotTime);
				return;
			}
			if(ev_.step_ == SEND_CMD) {
				ev_.mclkn_ = lm_->mclkn(lid_) + 2; // Hold starts from the next even (mas) slot 
				sendLMPCommand(LMP_HOLD_REQ, 2, ev_.intv_, ev_.mclkn_);
			}
			else {
				// need to cater for the case when it is not available
				sendLMPCommand(LMP_ACCEPTED, 1, (int)LMP_HOLD_REQ);
			}
			break;

		case SEND_ACCP:
		case RECV_ACCP:
			lm_->holdLink(lid_, ev_.intv_, ev_.mclkn_, ev_.step_ == RECV_ACCP);
			break;
		}
		break;

	case EN_SWITCH:
		switch(ev_.step_) {
		case SEND_CMD:
		case RECV_CMD:
			lm_->roleChangeInProg(1);
			if(ev_.step_ == SEND_CMD) {
				if(!lm()->isMasLink(lid())) {
					lm_->sendSlotOffset(lid_);
				}
				sendLMPCommand(LMP_SWITCH_REQ, 0);
			}
			else {
				if(!lm()->isMasLink(lid())) {
					lm_->sendSlotOffset(lid_); 
				}
				sendLMPCommand(LMP_ACCEPTED , 1, (int)LMP_SWITCH_REQ);
			}
			break;

		case SEND_ACCP:
		case RECV_ACCP:
			if(!lm()->isMasLink(lid())) {
				//if (am_addr_ == 0)
				//	assert(0);
				if (am_addr_ == 0)
					am_addr_ = ev_.am_addr_;
				lm_->switchSlaveRole(am_addr_);
			}
			break;

		}
		break;

	default:
		ASSERT(0);
	}
}

LinkController* 
LMP::lc() const 
{ 
	return dynamic_cast<LinkController*>(downtarget_); 
}

Packet*
LMP::dequePkt(deque<Packet*>& q, int pktSize) 
{
	Packet* p = NULL;
	hdr_bt* bt = NULL;
	if(!q.empty()) {
		p = q.front();
	        bt = HDR_BT(p);
		if(SlotSize[bt->type] <= pktSize)
			q.pop_front();
		else
			p = NULL;
	}
	return p;
}

/******************************************************************************************
 * LMPEvent routines
 ******************************************************************************************/
LMPEvent::LMPEvent() 
{
	step_ = SEND_CMD;
	mclkn_ = 0;
	task_ = DIS_ALL;
	intv_ = 0;
}


/******************************************************************************************
 * Test routines
 ******************************************************************************************/

void
LMPTestHandler::schedule(LMP* l, link_policy pol, int nSlots = 100) 
{
	if(testHandler == NULL) {
		testHandler = new LMPTestHandler(l);
		testEvent = new LMPEvent();
	}
	testEvent->task_ = pol;
	Scheduler::instance().schedule(testHandler, testEvent, nSlots*SlotTime);
}

void
LMPTestHandler::handle(Event* e)
{
	LMPEvent* ev = static_cast<LMPEvent*>(e);
	
	switch(ev->task_) {
	case EN_HOLD:
		linkq_->hciHoldMode(10);
		break;
	case EN_SWITCH:
		linkq_->hciSwitch();
		break;
	}
}

