/* -*-	Mode:C++; c-basic-offset:8; tab-width:8; indent-tabs-mode:t -*- */
/**************************************************************************************************
*IBM Public License Version 1.0 
*
*THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS IBM PUBLIC LICENSE ("AGREEMENT"). ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS AGREEMENT. 
*
*1. DEFINITIONS 
*
*"Contribution" means: 
*
*       a) in the case of International Business Machines Corporation ("IBM"), the Original Program, and 
*
*       b) in the case of each Contributor, 
*
*       i) changes to the Program, and
*
*       ii) additions to the Program;
*
*       where such changes and/or additions to the Program originate from and are distributed by that particular Contributor. A Contribution 'originates' from a Contributor if it
*       was added to the Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions do not include additions to the Program which: (i) are
*       separate modules of software distributed in conjunction with the Program under their own license agreement, and (ii) are not derivative works of the Program.
*
*  "Contributor" means IBM and any other entity that distributes the Program. 
*
*  "Licensed Patents " mean patent claims licensable by a Contributor which are necessarily infringed by the use or sale of its Contribution alone or when combined with the
*  Program. 
*
*  "Original Program" means the original version of the software accompanying this Agreement as released by IBM, including source code, object code and documentation, if
*  any. 
*
*  "Program" means the Original Program and Contributions. 
*
*  "Recipient" means anyone who receives the Program under this Agreement, including all Contributors. 
*
*  2. GRANT OF RIGHTS 
*
*       a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive, worldwide, royalty-free copyright license to reproduce, prepare
*       derivative works of, publicly display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, and such derivative works, in source code
*       and object code form.
*
*       b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive, worldwide, royalty-free patent license under Licensed Patents to
*       make, use, sell, offer to sell, import and otherwise transfer the Contribution of such Contributor, if any, in source code and object code form. This patent license shall
*       apply to the combination of the Contribution and the Program if, at the time the Contribution is added by the Contributor, such addition of the Contribution causes
*       such combination to be covered by the Licensed Patents. The patent license shall not apply to any other combinations which include the Contribution. No hardware per
*       se is licensed hereunder. 
*
*       c) Recipient understands that although each Contributor grants the licenses to its Contributions set forth herein, no assurances are provided by any Contributor that
*       the Program does not infringe the patent or other intellectual property rights of any other entity. Each Contributor disclaims any liability to Recipient for claims brought
*       by any other entity based on infringement of intellectual property rights or otherwise. As a condition to exercising the rights and licenses granted hereunder, each
*       Recipient hereby assumes sole responsibility to secure any other intellectual property rights needed, if any. For example, if a third party patent license is required to
*       allow Recipient to distribute the Program, it is Recipient's responsibility to acquire that license before distributing the Program.
*
*       d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its Contribution, if any, to grant the copyright license set forth in this
*       Agreement. 
*
*  3. REQUIREMENTS 
*
*  A Contributor may choose to distribute the Program in object code form under its own license agreement, provided that: 
*
*       a) it complies with the terms and conditions of this Agreement; and
*
*       b) its license agreement:
*
*       i) effectively disclaims on behalf of all Contributors all warranties and conditions, express and implied, including warranties or conditions of title and non-infringement,
*       and implied warranties or conditions of merchantability and fitness for a particular purpose; 
*
*       ii) effectively excludes on behalf of all Contributors all liability for damages, including direct, indirect, special, incidental and consequential damages, such as lost
*       profits; 
*
*       iii) states that any provisions which differ from this Agreement are offered by that Contributor alone and not by any other party; and
*
*       iv) states that source code for the Program is available from such Contributor, and informs licensees how to obtain it in a reasonable manner on or through a medium
*       customarily used for software exchange. 
*
*  When the Program is made available in source code form: 
*
*       a) it must be made available under this Agreement; and 
*
*       b) a copy of this Agreement must be included with each copy of the Program. 
*
*  Each Contributor must include the following in a conspicuous location in the Program: 
*
*       Copyright  2002 International Business Machines Corporation, 
*       Massachusetts Institute of Technology, and others. All Rights Reserved. 
*
*  In addition, each Contributor must identify itself as the originator of its Contribution, if any, in a manner that reasonably allows subsequent Recipients to identify the originator
*  of the Contribution. 
*
*  4. COMMERCIAL DISTRIBUTION 
*
*  Commercial distributors of software may accept certain responsibilities with respect to end users, business partners and the like. While this license is intended to facilitate the
*  commercial use of the Program, the Contributor who includes the Program in a commercial product offering should do so in a manner which does not create potential liability
*  for other Contributors. Therefore, if a Contributor includes the Program in a commercial product offering, such Contributor ("Commercial Contributor") hereby agrees to defend
*  and indemnify every other Contributor ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising from claims, lawsuits and other legal
*  actions brought by a third party against the Indemnified Contributor to the extent caused by the acts or omissions of such Commercial Contributor in connection with its
*  distribution of the Program in a commercial product offering. The obligations in this section do not apply to any claims or Losses relating to any actual or alleged intellectual
*  property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the Commercial Contributor in writing of such claim, and b) allow the Commercial
*  Contributor to control, and cooperate with the Commercial Contributor in, the defense and any related settlement negotiations. The Indemnified Contributor may participate in
*  any such claim at its own expense. 
*
*  For example, a Contributor might include the Program in a commercial product offering, Product X. That Contributor is then a Commercial Contributor. If that Commercial
*  Contributor then makes performance claims, or offers warranties related to Product X, those performance claims and warranties are such Commercial Contributor's
*  responsibility alone. Under this section, the Commercial Contributor would have to defend claims against the other Contributors related to those performance claims and
*  warranties, and if a court requires any other Contributor to pay any damages as a result, the Commercial Contributor must pay those damages. 
*
*  5. NO WARRANTY 
*
*  EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
*  KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT,
*  MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness of using and distributing the
*  Program and assumes all risks associated with its exercise of rights under this Agreement, including but not limited to the risks and costs of program errors, compliance with
*  applicable laws, damage to or loss of data, programs or equipment, and unavailability or interruption of operations. 
*
*  6. DISCLAIMER OF LIABILITY 
*
*  EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE ANY LIABILITY FOR ANY DIRECT,
*  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND
*  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
*  OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF ADVISED OF THE POSSIBILITY OF
*  SUCH DAMAGES. 
*
*  7. GENERAL 
*
*  If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not affect the validity or enforceability of the remainder of the terms of this
*  Agreement, and without further action by the parties hereto, such provision shall be reformed to the minimum extent necessary to make such provision valid and enforceable. 
*
*  If Recipient institutes patent litigation against a Contributor with respect to a patent applicable to software (including a cross-claim or counterclaim in a lawsuit), then any
*  patent licenses granted by that Contributor to such Recipient under this Agreement shall terminate as of the date such litigation is filed. In addition, If Recipient institutes
*  patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding combinations of the Program with other
*  software or hardware) infringes such Recipient's patent(s), then such Recipient's rights granted under Section 2(b) shall terminate as of the date such litigation is filed. 
*
*  All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the material terms or conditions of this Agreement and does not cure such failure in a
*  reasonable period of time after becoming aware of such noncompliance. If all Recipient's rights under this Agreement terminate, Recipient agrees to cease use and
*  distribution of the Program as soon as reasonably practicable. However, Recipient's obligations under this Agreement and any licenses granted by Recipient relating to the
*  Program shall continue and survive. 
*
*  IBM may publish new versions (including revisions) of this Agreement from time to time. Each new version of the Agreement will be given a distinguishing version number. The
*  Program (including Contributions) may always be distributed subject to the version of the Agreement under which it was received. In addition, after a new version of the
*  Agreement is published, Contributor may elect to distribute the Program (including its Contributions) under the new version. No one other than IBM has the right to modify this
*  Agreement. Except as expressly stated in Sections 2(a) and 2(b) above, Recipient receives no rights or licenses to the intellectual property of any Contributor under this
*  Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not expressly granted under this Agreement are reserved. 
*
*  This Agreement is governed by the laws of the State of New York and the intellectual property laws of the United States of America. No party to this Agreement will bring a
*  legal action under this Agreement more than one year after the cause of action arose. Each party waives its rights to a jury trial in any resulting litigation. 
**********************************************************************************************************************/

/*==============================================================================
  Generic Task Scheduling
 ============================================================================*/

#include <bt-core.h>


char TaskScheduler::buf[BUF_LEN];
char HostTask::buf[BUF_LEN];
char TaskEvent::buf[BUF_LEN];


static class TaskSchedulerClass : public TclClass 
{
public:
	TaskSchedulerClass() : TclClass("TaskScheduler"){}
	TclObject* create( int, const char*const*) {
	 	return ( new TaskScheduler );
	}
} class_taskscheduler;


TaskScheduler::TaskScheduler() : curr_task_(NULL)
{
}

int
TaskScheduler::lastFinishTime() const
{
	if(tasks_.rbegin() == tasks_.rend())
		return host_->lm()->clkn();
	return tasks_.rbegin()->second->finish_;
}

/* Schedule a new task of TYPE type for DURATION ticks. The task is scheduled at 
 * the earliest possible time after OFFSET ticks have passed. If MINDUR != -1, the duration of the 
 * task is between DURATION and MINDUR.*/
HostTask*  
TaskScheduler::schedule(task_type type, int duration, Handler* h, TaskEvent* e, int offset = 0, 
			int minDur = -1, int slack = 0)
{
	int prevFinish = host_->lm()->clkn();
	int start = prevFinish + offset;
	map<int, HostTask*>::iterator it, begin;
	HostTask* tsk = new HostTask();
	tsk->handler_ = h;
	tsk->ev_ = e; 
	tsk->type_ = type;
	tsk->sched_ = this;

	if(minDur == -1)
		minDur = duration;

	TRACE_BT(LEVEL_SCHED, "_%d_ SCHEDULE: NUM TASKS %-6d CLKN %-6d\n", 
		  host_->hciGetBdAddr(), tasks_.size(), host_->lm()->clkn());

      	for(begin = it = tasks_.begin(); it != tasks_.end(); it++) {
		TRACE_BT(LEVEL_SCHED, "_%d_ %s\n", host_->hciGetBdAddr(), it->second->toString());
		if(it->second->start_ - start >= minDur) {
			break;
		}

		if(start < it->second->finish_) // to cater for offset
			start = it->second->finish_;
		prevFinish = it->second->finish_;;
	}

	
	//if(prev != tasks_.end() && prev->second->finish_ != start) {
	if(prevFinish != start && start - prevFinish <= slack) {
		// move it forward if the gap between the previous task and this one is <= slack
		TRACE_BT(LEVEL_HIGH, "_%d_ MOVING FORWARD TASK TO CLOSE THE GAP: OLD %d NEW %d\n", 
			 host_->hciGetBdAddr(), start, prevFinish);
		start = prevFinish;
	}
	tsk->start_ = start;
	//tsk->finish_ = prevFinish + duration;
	tsk->finish_ = start + min(duration, (it == tasks_.end()) ? duration : it->second->start_ - start);

	if(tsk->finish_ < tsk->start_)
		ASSERT(0);
	

	tasks_.insert(make_pair(start, tsk));
	if(tasks_.begin() != begin)
		adjustTimer();
	TRACE_BT(LEVEL_SCHED, "_%d_ SCHED TASK: CLKN %-6d %s\n",
		  host_->hciGetBdAddr(), host_->lm()->clkn(), tsk->toString());
	return tsk;
}

/* Find the earliest availabe longest slot between START and FINISH. The task must have at least
 * DUR in length. */
HostTask*
TaskScheduler::scheduleHard(task_type type, Handler* h, TaskEvent* e, int start, int finish, int minDur)
{
	//int prevFinish = start = max(host_->lm()->clkn(), start);;
	if(!(start >= host_->lm()->clkn())) {
		TRACE_BT(LEVEL_LCS, "_%d_ TYPE %d START %d FIN %d CLKN %d %s\n", 
			  host()->hciGetBdAddr(), type, start, finish, host_->lm()->clkn(), e->toString());
		ASSERT(0);
	}
	int prevFinish = start;
	map<int, HostTask*>::iterator it, begin;
	HostTask* tsk = NULL;

	TRACE_BT(LEVEL_SCHED, "_%d_ SCHEDULEHARD: NUM TASKS %-6d CLKN %-6d\n", 
		  host_->hciGetBdAddr(), tasks_.size(), host_->lm()->clkn());
      	for(begin = it = tasks_.begin(); it != tasks_.end(); it++) {
		TRACE_BT(LEVEL_SCHED, "_%d_ %s\n", host_->hciGetBdAddr(), it->second->toString());
		// if the task can start no earlier than START and last for at least MINDUR
		if(start >= prevFinish && it->second->start_ >= start + minDur) {
			finish = min(it->second->start_, finish);
			break;
		}
		if(prevFinish < it->second->finish_) {// to cater for offset
			prevFinish = it->second->finish_;
			start = max(prevFinish, start);
		}
	}

	if(prevFinish + minDur <= finish) {
		ASSERT(!tsk);
		tsk = new HostTask();
		tsk->handler_ = h;
		tsk->ev_ = e; 
		tsk->type_ = type;
		tsk->start_ = max(start, prevFinish);
		tsk->finish_ = finish;
		tsk->sched_ = this;

		if(tsk->finish_ < tsk->start_)
			ASSERT(0);
		tasks_.insert(make_pair(tsk->start_, tsk));
		TRACE_BT(LEVEL_SCHED, "_%d_ SCHED TASK: CLKN %-6d %s\n",
			  host_->hciGetBdAddr(), host_->lm()->clkn(), tsk->toString());
	}

	if(tasks_.begin() != begin)
		adjustTimer();
	return tsk;
}

bool
TaskScheduler::cancel(HostTask* tsk)
{
	bool bRemoved = false;
	map<int, HostTask*>::iterator it = tasks_.find(tsk->start_);
	if(it != tasks_.end()) {
		ASSERT(tsk->equal(it->second));
		removeTask(it, TASK_CANCEL);
		bRemoved = true;
	}
	return bRemoved;
}

bool
TaskScheduler::cancel(TaskEvent* e, bool bAll = false)
{
	return cancelT(this, e, bAll);
}

/* Remove the first task of TYPE type found in TASKS. 
 * Should later adapt to use CANCEL(TaskEvent*) instead. */
bool
TaskScheduler::cancel(task_type type, bool bAll = false)
{
	ASSERT(type >= INQ_TSK && type < NUM_TSK);
	TopoEvent* e = new TopoEvent(type);
	bool res = cancel(dynamic_cast<TaskEvent*>(e), bAll);
	delete e;
	return res;
}

HostTask*
TaskScheduler::find(TaskEvent* e)
{
	return findT(this, e);
}

void
TaskScheduler::removeTask(map<int, HostTask*>::iterator it, task_status status)
{
	TRACE_BT(LEVEL_SCHED, "_%d_ REMOV TASK: CLKN %-6d %s STATUS %d\n",
		  host_->hciGetBdAddr(), host_->lm()->clkn(), it->second->toString(), status);
	if(it->second->handler_) {
		it->second->ev_->status_ = status;
		it->second->handler_->handle(it->second->ev_);
		//Scheduler::instance().cancel(&intr_);
	}
	bool bAdjust = false;
	if(it == tasks_.begin())
		bAdjust = true;
	delete it->second;
	tasks_.erase(it);

	if(bAdjust) {
		curr_task_ = NULL;
		adjustTimer();
	}
}

void
TaskScheduler::currTaskFinished() 
{
	if(tasks_.begin() == tasks_.end())
		ASSERT(0);
	removeTask(tasks_.begin(), TASK_END); // GT may not be right
	//adjustTimer();
}

/* It is time to invoke the appropriate handler for the first event in the queue. */
void
TaskScheduler::handle(Event* e)
{
	ASSERT(e == &intr_);
	HostTask* tsk = tasks_.begin()->second;
	if(curr_task_ != NULL)
		ASSERT(0);
	curr_task_ = tsk;
	tsk->ev_->status_ = TASK_BEGIN;
	//TRACE_BT(LEVEL_SCHED, "_%d_ BEGIN TASK: CLKN %-6d %s\n",
	//	  host_->hciGetBdAddr(), host_->lm()->clkn(), tsk->toString());
	tsk->handler_->handle(tsk->ev_);
}

void
TaskScheduler::adjustTimer()
{
	Scheduler& s = Scheduler::instance();
	s.cancel(&intr_);
	if(tasks_.begin() != tasks_.end()) {
		HostTask* tsk = tasks_.begin()->second;
		double delay = (tsk->start_ - host_->lm()->clkn()) * ClockTick;
		TRACE_BT(LEVEL_SCHED, "_%d_ adjustTimer CLKN %d %s %4.4f\n",
			  host_->hciGetBdAddr(),  host_->lm()->clkn(), tsk->toString(), delay);
		s.schedule(this, &intr_, max(0.0, delay));
	}
} 

Packet*
TaskScheduler::send(uchar ch)
{
  return NULL;
}

/* Begin firstTask() if it hasn't begun yet. currTask() must be NULL. 
 * This routine is used to sync THIS and other timers. */
void
TaskScheduler::beginFirstTask() 
{
	ASSERT(firstTask());
	ASSERT(currTask() == NULL);
	Scheduler::instance().cancel(&intr_);
	handle(&intr_); // begin task right away
}

HostTask*
TaskScheduler::firstTask() const
{
	if(tasks_.begin() == tasks_.end())
		return NULL;
	return tasks_.begin()->second;
}

HostTask*
TaskScheduler::getTask(int i) 
{
	map<int, HostTask*>::iterator it;
	unsigned int cnt = 0;
	for(it = tasks_.begin(); it != tasks_.end(); it++) {
		if((int)cnt == i)
			break;
		cnt++;
	}
	if(cnt >= tasks_.size())
		return NULL;
	return it->second;
}

/* Get the index of TSK in the list. -1 if TSK does not exist. */
int
TaskScheduler::getIndexOf(HostTask* tsk) 
{
	map<int, HostTask*>::iterator it;
	int ind = 0;
	for(it = tasks_.begin(); it != tasks_.end(); it++) {
		if(it->second == tsk)
			return ind;
		ind++;
	}
	return -1;
}

void
TaskScheduler::pollMissed(uchar ch)
{
}

const char*
TaskScheduler::toString() const 
{
	map<int, HostTask*>::const_iterator it; 
	int written = 0;
      	for(it = tasks_.begin(); it != tasks_.end(); it++) {
		written += snprintf(buf + written, BUF_LEN - written, "%s\n", it->second->toString());
	}
	return buf;
}

/* Return the gap between TSK and its preceding task, if bBegin == TRUE, or its
 * succeeding task, otherwise. -1 indicates that there is no task behind this task. */
int
TaskScheduler::gapBetweenTasks(HostTask* tsk, bool bBegin) 
{
	map<int, HostTask*>::iterator it = tasks_.find(tsk->start_);
	ASSERT(it != tasks_.end());
	if(bBegin) 
		it--;
	else
		it++;
	int gap = -1;
	if(it != tasks_.end()) {
		if(bBegin)
			gap = tsk->start_ - it->second->finish_;
		else
			gap = it->second->start_ - tsk->finish_;
	}
	return gap;
}

const char*
HostTask::toString(bool bNative = true) const
{
	if(bNative) {
		snprintf(buf, BUF_LEN, "[%13s %-6d (%-6d, %-6d) %-6s]", 
			 typeString(type_), mclkn_, start_, finish_, ev_->toString());
	}
	else {
	        Baseband* lm = sched_->host()->lm();
		snprintf(buf, BUF_LEN, "[%13s (%-6d, %-6d, %-3d) %-6s]", 
			 typeString(type_), (int)((start_ - lm->startClkn()) / 2.0), (int)((finish_ - lm->startClkn()) / 2.0), 
			 (int)((finish_-start_)/2.0), ev_->toString());
	}
	return buf;
}
