/* -*-	Mode:C++; c-basic-offset:8; tab-width:8; indent-tabs-mode:t -*- */
/**************************************************************************************************
*IBM Public License Version 1.0 
*
*THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS IBM PUBLIC LICENSE ("AGREEMENT"). ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS AGREEMENT. 
*
*1. DEFINITIONS 
*
*"Contribution" means: 
*
*       a) in the case of International Business Machines Corporation ("IBM"), the Original Program, and 
*
*       b) in the case of each Contributor, 
*
*       i) changes to the Program, and
*
*       ii) additions to the Program;
*
*       where such changes and/or additions to the Program originate from and are distributed by that particular Contributor. A Contribution 'originates' from a Contributor if it
*       was added to the Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions do not include additions to the Program which: (i) are
*       separate modules of software distributed in conjunction with the Program under their own license agreement, and (ii) are not derivative works of the Program.
*
*  "Contributor" means IBM and any other entity that distributes the Program. 
*
*  "Licensed Patents " mean patent claims licensable by a Contributor which are necessarily infringed by the use or sale of its Contribution alone or when combined with the
*  Program. 
*
*  "Original Program" means the original version of the software accompanying this Agreement as released by IBM, including source code, object code and documentation, if
*  any. 
*
*  "Program" means the Original Program and Contributions. 
*
*  "Recipient" means anyone who receives the Program under this Agreement, including all Contributors. 
*
*  2. GRANT OF RIGHTS 
*
*       a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive, worldwide, royalty-free copyright license to reproduce, prepare
*       derivative works of, publicly display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, and such derivative works, in source code
*       and object code form.
*
*       b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive, worldwide, royalty-free patent license under Licensed Patents to
*       make, use, sell, offer to sell, import and otherwise transfer the Contribution of such Contributor, if any, in source code and object code form. This patent license shall
*       apply to the combination of the Contribution and the Program if, at the time the Contribution is added by the Contributor, such addition of the Contribution causes
*       such combination to be covered by the Licensed Patents. The patent license shall not apply to any other combinations which include the Contribution. No hardware per
*       se is licensed hereunder. 
*
*       c) Recipient understands that although each Contributor grants the licenses to its Contributions set forth herein, no assurances are provided by any Contributor that
*       the Program does not infringe the patent or other intellectual property rights of any other entity. Each Contributor disclaims any liability to Recipient for claims brought
*       by any other entity based on infringement of intellectual property rights or otherwise. As a condition to exercising the rights and licenses granted hereunder, each
*       Recipient hereby assumes sole responsibility to secure any other intellectual property rights needed, if any. For example, if a third party patent license is required to
*       allow Recipient to distribute the Program, it is Recipient's responsibility to acquire that license before distributing the Program.
*
*       d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its Contribution, if any, to grant the copyright license set forth in this
*       Agreement. 
*
*  3. REQUIREMENTS 
*
*  A Contributor may choose to distribute the Program in object code form under its own license agreement, provided that: 
*
*       a) it complies with the terms and conditions of this Agreement; and
*
*       b) its license agreement:
*
*       i) effectively disclaims on behalf of all Contributors all warranties and conditions, express and implied, including warranties or conditions of title and non-infringement,
*       and implied warranties or conditions of merchantability and fitness for a particular purpose; 
*
*       ii) effectively excludes on behalf of all Contributors all liability for damages, including direct, indirect, special, incidental and consequential damages, such as lost
*       profits; 
*
*       iii) states that any provisions which differ from this Agreement are offered by that Contributor alone and not by any other party; and
*
*       iv) states that source code for the Program is available from such Contributor, and informs licensees how to obtain it in a reasonable manner on or through a medium
*       customarily used for software exchange. 
*
*  When the Program is made available in source code form: 
*
*       a) it must be made available under this Agreement; and 
*
*       b) a copy of this Agreement must be included with each copy of the Program. 
*
*  Each Contributor must include the following in a conspicuous location in the Program: 
*
*       Copyright  2002 International Business Machines Corporation, 
*       Massachusetts Institute of Technology, and others. All Rights Reserved. 
*
*  In addition, each Contributor must identify itself as the originator of its Contribution, if any, in a manner that reasonably allows subsequent Recipients to identify the originator
*  of the Contribution. 
*
*  4. COMMERCIAL DISTRIBUTION 
*
*  Commercial distributors of software may accept certain responsibilities with respect to end users, business partners and the like. While this license is intended to facilitate the
*  commercial use of the Program, the Contributor who includes the Program in a commercial product offering should do so in a manner which does not create potential liability
*  for other Contributors. Therefore, if a Contributor includes the Program in a commercial product offering, such Contributor ("Commercial Contributor") hereby agrees to defend
*  and indemnify every other Contributor ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising from claims, lawsuits and other legal
*  actions brought by a third party against the Indemnified Contributor to the extent caused by the acts or omissions of such Commercial Contributor in connection with its
*  distribution of the Program in a commercial product offering. The obligations in this section do not apply to any claims or Losses relating to any actual or alleged intellectual
*  property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the Commercial Contributor in writing of such claim, and b) allow the Commercial
*  Contributor to control, and cooperate with the Commercial Contributor in, the defense and any related settlement negotiations. The Indemnified Contributor may participate in
*  any such claim at its own expense. 
*
*  For example, a Contributor might include the Program in a commercial product offering, Product X. That Contributor is then a Commercial Contributor. If that Commercial
*  Contributor then makes performance claims, or offers warranties related to Product X, those performance claims and warranties are such Commercial Contributor's
*  responsibility alone. Under this section, the Commercial Contributor would have to defend claims against the other Contributors related to those performance claims and
*  warranties, and if a court requires any other Contributor to pay any damages as a result, the Commercial Contributor must pay those damages. 
*
*  5. NO WARRANTY 
*
*  EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
*  KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT,
*  MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness of using and distributing the
*  Program and assumes all risks associated with its exercise of rights under this Agreement, including but not limited to the risks and costs of program errors, compliance with
*  applicable laws, damage to or loss of data, programs or equipment, and unavailability or interruption of operations. 
*
*  6. DISCLAIMER OF LIABILITY 
*
*  EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE ANY LIABILITY FOR ANY DIRECT,
*  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND
*  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
*  OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF ADVISED OF THE POSSIBILITY OF
*  SUCH DAMAGES. 
*
*  7. GENERAL 
*
*  If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not affect the validity or enforceability of the remainder of the terms of this
*  Agreement, and without further action by the parties hereto, such provision shall be reformed to the minimum extent necessary to make such provision valid and enforceable. 
*
*  If Recipient institutes patent litigation against a Contributor with respect to a patent applicable to software (including a cross-claim or counterclaim in a lawsuit), then any
*  patent licenses granted by that Contributor to such Recipient under this Agreement shall terminate as of the date such litigation is filed. In addition, If Recipient institutes
*  patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding combinations of the Program with other
*  software or hardware) infringes such Recipient's patent(s), then such Recipient's rights granted under Section 2(b) shall terminate as of the date such litigation is filed. 
*
*  All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the material terms or conditions of this Agreement and does not cure such failure in a
*  reasonable period of time after becoming aware of such noncompliance. If all Recipient's rights under this Agreement terminate, Recipient agrees to cease use and
*  distribution of the Program as soon as reasonably practicable. However, Recipient's obligations under this Agreement and any licenses granted by Recipient relating to the
*  Program shall continue and survive. 
*
*  IBM may publish new versions (including revisions) of this Agreement from time to time. Each new version of the Agreement will be given a distinguishing version number. The
*  Program (including Contributions) may always be distributed subject to the version of the Agreement under which it was received. In addition, after a new version of the
*  Agreement is published, Contributor may elect to distribute the Program (including its Contributions) under the new version. No one other than IBM has the right to modify this
*  Agreement. Except as expressly stated in Sections 2(a) and 2(b) above, Recipient receives no rights or licenses to the intellectual property of any Contributor under this
*  Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not expressly granted under this Agreement are reserved. 
*
*  This Agreement is governed by the laws of the State of New York and the intellectual property laws of the United States of America. No party to this Agreement will bring a
*  legal action under this Agreement more than one year after the cause of action arose. Each party waives its rights to a jury trial in any resulting litigation. 
**********************************************************************************************************************/

/*==================================================================
  Generic Task Scheduler Module
 ==================================================================*/

#ifndef ns_task_sched_h
#define ns_task_sched_h

#include <map>
#include <scheduler.h>
#include <bt-def.h>
#include <bt-host.h>

class TaskScheduler;


class TaskEvent : public Event {
public:
	TaskEvent() { status_ = TASK_CANCEL; type_ = NUM_TSK; }
	task_status status_; // status of this event 
	task_type   type_;
	virtual bool equal(TaskEvent* e) { return this == e; }
	virtual const char*   toString() const {
		snprintf(buf, BUF_LEN, "%-6d", (int)status_);
		return buf;
	}
 
	static char buf[BUF_LEN];
};


class HostTask {

public:
	task_type type_;
	int       start_;
	int       finish_;
	int       mclkn_;  // aux field which helps implementation; only applies to COMM task
	int       data_in_;
	int       data_out_;
	Handler*  handler_;
	TaskEvent*    ev_;
	TaskScheduler* sched_;

	HostTask() : type_(NUM_TSK), start_(0), finish_(0), mclkn_(0), 
		data_in_(0), data_out_(0), handler_(NULL), ev_(NULL), sched_(NULL) {}

	virtual const char* toString(bool bNative = true) const;
	task_type type() const { return type_; }
	
	static char*  typeString(task_type type) {
		if(type == INQ_TSK)
			return "INQ_TSK";
		else if(type == INQ_SCAN_TSK)
			return "INQ_SCAN_TSK";
		else if(type == PAGE_TSK)
			return "PAGE_TSK";
		else if(type == PAGE_SCAN_TSK)
			return "PAGE_SCAN_TSK";
		else if(type == COMM_TSK)
			return "COMM_TSK";
		else {
			ASSERT(0);
		}
	}

	virtual bool equal(HostTask* t) { 
		return (this == t);
			//(type_ == e->type_ && start_ == e->start_ && finish_ == e->finish_);
	}

	int       duration() { return finish_ - start_; }

protected:
	static char buf[BUF_LEN];
};


// run time: O(n^2) if bAll is set! @TODO
template<class T> inline bool 
cancelT(TaskScheduler* tss, T* e, bool bAll) 
{
	map<int, HostTask*>::iterator it;
	bool bRemoved = false, bEq = false;

      	for(it = tss->tasks_.begin(); it != tss->tasks_.end();) {
		bEq = false;
		if(dynamic_cast<TaskEvent*>(e))
			bEq = dynamic_cast<TaskEvent*>(e)->equal(it->second->ev_);
		if(bEq) {
			bRemoved = true;
			tss->removeTask(it, TASK_CANCEL); 
			if(!bAll)
				break;
			else {
				it = tss->tasks_.begin(); // The STL implementation distributed with linux
				// does not return an iter upon erase! Some commerical impl. does. 
				continue; // do not incr it
			}
		}
		it++;
	}
	return bRemoved;
}


template<class T> inline HostTask*
findT(TaskScheduler* tss, T* e) 
{
	map<int, HostTask*>::iterator it;
	bool bEq = false;
      	for(it = tss->tasks_.begin(); it != tss->tasks_.end(); it++) {
		if(dynamic_cast<TaskEvent*>(e))
			bEq = dynamic_cast<TaskEvent*>(e)->equal(it->second->ev_);
		else if(dynamic_cast<HostTask*>(e))
			bEq = dynamic_cast<HostTask*>(e)->equal(it->second);
		if(bEq) {
			return it->second;
		}
	}
	return NULL;
}


class TaskScheduler : virtual public HCIEventsHandler {

	friend bool cancelT<TaskEvent>(TaskScheduler* tss, TaskEvent* e, bool bAll);
	friend HostTask* findT<HostTask>(TaskScheduler* tss, HostTask* e);
	friend HostTask* findT<TaskEvent>(TaskScheduler* tss, TaskEvent* e);
	
public:
	const static int MinTaskLen = 4;

	TaskScheduler();
	virtual HostTask*  scheduleHard(task_type type, Handler* h, TaskEvent* e, int start, int finish, int minDur);
	virtual HostTask*  schedule(task_type type, int duration, Handler* h, TaskEvent* e, int offset = 0, 
				    int minDur = -1, int slack = 0);
	virtual bool       cancel(HostTask* tsk);
	virtual bool       cancel(TaskEvent* ev, bool bAll = false);
	virtual bool       cancel(task_type ty, bool bAll = false);

	virtual HostTask*  find(TaskEvent* ev);

	virtual Packet*    send(uchar ch);
	virtual void       pollMissed(uchar ch);

	virtual void       handle(Event* e);
	void               beginFirstTask();
	int                lastFinishTime() const;
	int                gapBetweenTasks(HostTask* tsk, bool bBegin);
        virtual void       currTaskFinished();

	HostTask*          currTask() const { return curr_task_; }
	HostTask*          firstTask() const;
	HostTask*          getTask(int i);
	int                getIndexOf(HostTask* tsk);

	virtual const char* toString() const;
	virtual void       stop(bool bStop = true) {}
	virtual void       queueFull(char outLid, char inLid) {}

protected:
	void               adjustTimer();
	void               removeTask(map<int, HostTask*>::iterator it, task_status status);

protected:

	map<int, HostTask*> tasks_;
	HostTask*         curr_task_;
	Event intr_;

	static char buf[BUF_LEN];
};




#endif // ns_task_sched_h

