/* -*-	Mode:C++; c-basic-offset:8; tab-width:8; indent-tabs-mode:t -*- */
/*==================================================================
  DATA STATS: to store network statistics
 ==================================================================*/

#include <math.h>
#include <packet.h>
#include <data-stats.h>

char DataStats::buf[BUF_LEN];


DataStats::DataStats()  : src_(-1), dst_(-1), pkt_size_(-1), total_bytes_(0), 
	n_pkts_(0), ptype_(-1), n_hops_(0), start_(0), finish_(0), total_delay_(0), 
	total_delay_sq_(0), has_sent_data_(false)
{
}

const char*
DataStats::toString(char*) const
{
	int cnt = snprintf(buf, BUF_LEN, "SRC %-4d DST %-4d PROTO %-8s AVGDELAY %-10.2e THRUPUT %-10.2e PKTS %-4d"
			   "DUR %-10.2e HOPS %-3d DEVDELAY %-10.2e SENT %-5s\n",
			   src_, dst_, packet_info.name((packet_t)ptype_), total_delay_ / n_pkts_, 
			   ((duration() > 0) ? (total_bytes_ * 8 / duration()) : 0), n_pkts_, duration(), n_hops_, 
			   stdDev(n_pkts_, total_delay_, total_delay_sq_), (has_sent_data_) ? "TRUE" : "FALSE");
	buf[cnt] = 0;
	return buf;
}

double 
DataStats::stdDev(int n, double total, double sqTotal)
{
	if(n > 1) {
		return sqrt(((n * sqTotal) - (total * total)) / (n * (n - 1)));
	}
	return 0;
} 






