/* -*-	Mode:C++; c-basic-offset:8; tab-width:8; indent-tabs-mode:t -*- */

#ifndef data_stats_h
#define data_stats_h


#include <util.h>


class DataStats {
public:
	int    src_;
	int    dst_;
	int    pkt_size_;
	int    total_bytes_; // bytes received
	int    n_pkts_;
	int    ptype_;
	int    n_hops_;

	double start_;
	double finish_;
	double total_delay_;
	double total_delay_sq_; // total of the square of the delay
	bool   has_sent_data_;  // whethere any L2CAP data has been sent through this entity

public:
	DataStats();

	double  duration() const { return finish_ - start_; }
	const char*   toString(char* str = NULL) const;

	static double stdDev(int n, double total, double sqTotal);

protected:

        static char buf[BUF_LEN];
};


#endif // data_stats_h


