#!/usr/bin/perl

if(@ARGV != 1) {
    die "./analys.pl <trace file name>";
}

$trFileName = $ARGV[0] . ".out";
$dotFileName = $ARGV[0] . ".dot";
$psFileName = $ARGV[0] . ".ps";

# stats for dis v.s. non-discovery time until scat is formed
@aLastState =();
@aLastStateClk =();
@aTotalTimeTillFormed = ();
$bTillFormed = 0;
$timeTillFormed = 0; # this should be very close to last link time

$aTotalConnTimeTillAppStarted = 0;
@aConnTimeTillAppStarted = ();
$bAppStarted = 0;
$timeTillAppStarted = 0;
@aBusyNodes = ();


@aDelays = ();#(0, 0, 0, 0);
@aRecvBytes = ();#(0, 0, 0, 0);
@aPackets = ();
%hDuration= ();
%hNodeConnDelay = ();
%hLinkConnDelay = ();
%hLinkConnClock = ();
$maxPnet = -1;
$maxNode = -1;
$pktCnt  = -1;
$pktSize = 0;
$GTCount = 0;
$nmerge = 0;

$trafficStats = "src->dst Thruput  Delay   NPkts  Dur  Proto NHops StdDevDelay\n";
$totalPkts = 0;
$totalDelays = 0;
$totalThru = 0;
$totalHops = 0;
$nFlows = 0;

#system("~/Blueware/ns $script 2> $fileName");
open(TRACE, $trFileName) || die "can't open $trFileName";

#BD_ADDR 4 DELAY 1.911480e-03 SIZE 210 clock 8.636578e+00
$linecnt = 0;
$dotPrinted = 0;
$lastLinkTime = 0;
$prevLinkTime = 0;
$lastStart = 0;

$tsfStats = "";
$defStats = "";
$phase = 0;

$dotLinkCnt = 0;
@aDotStr = ();

beginDot();

while($line = <TRACE>) {
    if($line =~ /^\((.*)\): /) {
	$lastClk = $1;
    }

    if($line =~ /BD_ADDR (.*) DELAY (.*) SIZE (.*) clock/) {
	#BD_ADDR 1 DELAY 2.533733e-03 SIZE 210 clock 5.565467e+00
	$pktCnt++;
	$aDelays[$1] += $2;
	$aPackets[$1]++;
	$aRecvBytes[$1] += $3;
	#print "$1 $2 $3 $aDelays[$1] $aRecvBytes[$1]\n";
    }
    elsif($line =~ /BB START (.*)clock:(.*)/) {
        #(0.00):  # START: 0      CLKN: 0          clock: 0.000000e+00
	$tmp = $2;
	if($tmp > $lastStart) {
	    $lastStart = $tmp;
	}
    }
    elsif($line =~ /\+.*_(.*)_(.*)_NODE.*NLINKS/) {
	#(127840.00):  + _5_ ROOT_NODE      NLINKS 2 NCHILD 2 SID 0x30000            MASK 14 RID 5    LEVEL 2 
	$mas = $1;
	$type = $2;
	if ($type =~ /COORD/) {
	    writeToDot("$mas [style=dotted];\n");
	}

	if ($type =~ /ROOT/) {
	    #print DOT "$mas [peripheries=3];\n";
	    #writeToDot("$mas [peripheries=3];\n");
	    writeToDot("$mas [shape=box];\n");
	    # increase the merit of root nodes so that they appear on top of the graph
	    for($i = 1000; $i < 1003; $i++) {
		print DOT "$mas -- $i [style=invis];\n";
		#print DOT "$mas [peripheries=3];\n";
		#print DOT "$mas [shape=ellipse];\n";
		print DOT "$i [style=invis];\n";
	    }
	}

    }
    elsif($line =~ /\+ _(.*)_ LIFE(.*), FIRST LINK(.*)/) {
	#(95840.00):  + _0_ LIFE 53.0030, FIRST LINK  2.5277 
	$node = $1; $life = $2; $delay = $3; 
	trimSpaces($node); trimSpaces($life);trimSpaces($delay); 
	$hNodeConnDelay{"$node"} = $delay;
    }
    elsif($line =~ /_(.*)_.*LINK ESTABLISHED(.*)->(.*)DELAY(.*)/) {
	#(5585.28):  + _0_ FIRST LINK ESTABLISHED 0 -> 2 DELAY 3.490798
	#(17425.05):  + _3_ LINK ESTABLISHED 3 -> 7 DELAY 0.437500
	$node = $1; $mas = $2; $slv = $3; $delay = $4; 
	trimSpaces($node); trimSpaces($mas);trimSpaces($slv); trimSpaces($delay);

	if($hLinkConnDelay{$mas . "_" . $slv} > 0) {
	    #printf "GT COLLISSION $mas - $slv %f MUST BE A LOOP\n", $hLinkConnDelay{$mas . "_" . $slv};
	}
	else {
	    $hLinkConnDelay{$mas . "_" . $slv} = $delay;
	    $prevLinkTime = $lastLinkTime;
	    $lastLinkTime = $lastClk * 0.000625;
	}

	if($line =~ /FIRST/) {
	    $hNodeConnDelay{"$node"} = $delay;
	    #printf "FIRST $node %f\n",  $hNodeConnDelay{"$node"};
	}

	if($line =~ /MAS/) {
	    writeToDot(" $mas -- $slv\n");
	    $hLinkConnClock{$mas . "_" . $slv} = $lastClk * 0.000625;
	    #@GT writeToDot(" $mas [peripheries=2];\n");
	    $GTCount++;
	    #printf "ESTAB %d %9.2e\n",  $GTCount, $hLinkConnClock{$mas . "_" . $slv};
	}
	
	if($hLinkConnDelay{$mas . "_" . $slv} <= 0) {
	    print "GT $mas -> $slv\n";
	}

	if($maxNode < $node) {
	    $maxNode = $node;
	}
    }
    elsif($line =~ /_(.*)_ ROLE_CHANGE EVENT: MAS(.*)-(.*)SLV, LASTLINK(.*)/) {
        #(12474.27): _5_ ROLE_CHANGE EVENT: MAS 9-5 SLV, LASTLINK 5.9470
	$node = $1; $mas = $2; $slv = $3; $dur = $4;
	trimSpaces($node); trimSpaces($mas); trimSpaces($slv);
	#assume that DISCONN event came first 
	#print "ROLE_CHANGE $mas $node \n";
	if($mas eq $node) {
	    writeToDot(" $mas -- $slv\n");
	    #@GT writeToDot(" $mas [peripheries=2];\n");
	    $GTCount++;
	    $hLinkConnDelay{$mas . "_" . $slv} = $dur;
	    $hLinkConnClock{$mas . "_" . $slv} = $lastClk * 0.000625;
	    $prevLinkTime = $lastLinkTime;
	    $lastLinkTime = $lastClk * 0.000625;
	    #printf "ROLE_CHANGE %d %9.2e\n",  $GTCount, $hLinkConnClock{$mas . "_" . $slv};
	}
    }
    elsif($line =~ /_(.*)_ DISCONNECTED: MAS(.*)-(.*)SLV/) {
	$node = $1; $mas = $2; $slv = $3;
	trimSpaces($node); trimSpaces($mas); trimSpaces($slv);
	#print "DISCONN $mas $node \n";
	if($mas eq $node) {
	    #@GT replaceDotStr(" $mas [peripheries=2];\n", "");
	    replaceDotStr(" $mas -- $slv\n", "");
	    if($hLinkConnDelay{$mas . "_" . $slv} <= 0) {
		print "GT1 $mas -> $slv \n";
		printf "DELAY %s\n", $hLinkConnDelay{$mas . "_" . $slv};
	    }
	    if($hLinkConnDelay{$slv . "_" . $mas} <= 0) {
		print "GT1 $slv <- $mas\n";
	    }
	    $hLinkConnDelay{$mas . "_" . $slv} = 0;
	    $hLinkConnDelay{$slv . "_" . $mas} = 0;

	    $hLinkConnClock{$mas . "_" . $slv} = 0;
	    $hLinkConnClock{$mas . "_" . $slv} = 0;

	    $GTCount = $GTCount - 1;
	    $lastLinkTime = $prevLinkTime;	    
	    #printf "DISCONN %d %9.2e\n",  $GTCount, $hLinkConnClock{$mas . "_" . $slv};
	}
    }
    elsif($line =~ /\+ SCAT COUNT v.s. Nodes:(.*)\/(.*)/) {
	#(28720.00):  + SCAT COUNT v.s. Nodes: 1 / 32.
	$scatcnt = $1; $nodecnt = $2;
	trimSpaces($scatcnt); trimSpaces($nodecnt);

	if($scatcnt == 1 && $bTillFormed != 1) {
	    if($maxNode != ($nodecnt - 1)) {
		die "Maxnode is not right at this point.\n";
	    }
	    for($i = 0; $i < $maxNode + 1; $i++) {
		$aTotalTimeTillFormed[0] += $hDuration{$i . "_INQUIRY"};
		$aTotalTimeTillFormed[1] += $hDuration{$i . "_INQ_SCAN"};
		$aTotalTimeTillFormed[2] += $hDuration{$i . "_INQ_RESP"};
		$aTotalTimeTillFormed[3] += $hDuration{$i . "_PAGE"};
		$aTotalTimeTillFormed[4] += $hDuration{$i . "_PAGE_SCAN"};
		$aTotalTimeTillFormed[5] += $hDuration{$i . "_MASTER_RESP"};
		$aTotalTimeTillFormed[6] += $hDuration{$i . "_SLAVE_RESP"};
		$aTotalTimeTillFormed[7] += $hDuration{$i . "_STANDBY"};
		
		$j = 0;
		while($j < $maxNode + 1) {
		    if($hDuration{$i . "_CONNECTION_" . $j} > 0) {
			$aTotalTimeTillFormed[8] += $hDuration{$i . "_CONNECTION_" . $j};
		    }
		    $j++;
		}

		if($aLastState[$i] =~/CONNECTION/) {
		    $ind = 8;
		}
		elsif($aLastState[$i] =~ /STANDBY/) {
		    $ind = 7;
		}
		else {
		    # just set it to inq_scan since the stats only show dicovery and non-discovery time
		    $ind = 1;
		}
		$dur = ($lastClk - $aLastStateClk[$i]) * 0.000625;
		#print "NODE $i DUR $dur NEXT $aLastState[$i] LASTCLK $lastClk \n";
		$aTotalTimeTillFormed[$ind] += $dur;
	    }
	    $timeTillFormed = $lastClk;
	    $bTillFormed = 1;
	}
    }
    elsif($line =~ /_(.*)_ \((.*)\) STATE (.*) LASTED (.*)/) {
	#(95840.00): STOP  + _0_ (0) STATE INQUIRY LASTED     3.4125 
	#+  _17_ (17) STATE INQ_SCAN LASTED     0.0112 NEXT CONNECTION
	$node = $1; $pnet = $2; $state = $3; $dur = $4;
	trimSpaces($node); trimSpaces($pnet); trimSpaces($state); 
	$key = $node . "_" . $state;
	if($state =~ /CONNECTION/) {
	    $key = $key . "_" . $pnet;
	}
	$hDuration{$key} = $hDuration{$key} + $dur;
	#printf "%s -> %s\n", $key, $hDuration{$key};

	if($bTillFormed != 1 && $line =~ /NEXT(.*)/) {
	    #print "$node $next $lastClk \n";
	    $next = $1;
	    trimSpaces($next);
	    $aLastState[$node] = $next;
	    $aLastStateClk[$node] = $lastClk;
	}

	if($maxNode < $node) {
	    $maxNode = $node;
	    #printf "MAXNODE $maxNode\n";
	}
    }
    elsif($line =~ /RECV TSF.*\(ROOT_NODE\).*\(ROOT_NODE\)/) {
	#: _16_ RECV TSF ON CH 7 from 28. ROOT_NODE(ROOT_NODE), TSF_BOOT_PHASE [TSF: TSF_CONN, ROOT_NODE(ROOT_NODE)]
	$nmerge++;
    }
    elsif($line =~ /STATS TSF/) {
	$tsfStats =  $tsfStats . $line 
    }
    elsif($line =~ /STATS DEF/) {
	$defStats =  $defStats . $line 
    }
    elsif($line =~ /\+.*SRC(.*)DST(.*)PROTO(.*)AVGDELAY(.*)THRUPUT(.*)PKTS(.*)DUR(.*)HOPS(.*)DEVDELAY(.*)/) {
	#(95999.84):  + _0_ SRC 1    DST 0    PROTO ack      AVGDELAY 7.33e-04   THRUPUT 5.58e+04   PKTS 5223
	$src = $1; $dst = $2; $proto = $3; $delay = $4; $thru = $5; $pkts = $6; $duration = $7; $hops = $8; $devdelay = $9; $bSent = "FALSE";

	if($devdelay =~ /(.*)SENT(.*)/) {
	    # backward compatibility
	    $bSent = $2;
	    $devdelay = $1;
	}

	trimSpaces($src); trimSpaces($dst); trimSpaces($proto); trimSpaces($hops);
	trimSpaces($delay); trimSpaces($thru); trimSpaces($pkts); trimSpaces($duration); 
	trimSpaces($devdelay); trimSpaces($bSent);

	if($proto =~ /tcp/ || $proto =~ /cbr/) {
	    $trafficStats =  $trafficStats . "$src" . "->" . "$dst" . "  $thru  $delay  $pkts  $duration $proto $hops $devdelay\n";
	    $totalPkts += $pkts;
	    $totalDelays += ($delay * $pkts);
	    $totalThru += $thru;
	    $totalHops += $hops;
	    $nFlows++;
	    $bSent = "TRUE";
	}
	
	if($bSent =~ /TRUE/) {
	    $line =~ /\+ _(.*)_/;
	    $node = $1; trimSpaces($node);
	    $aBusyNode[$node] = 1;
	}
    }
    elsif($line =~ /APPLICATION HAS STARTED/) {
	#print "+++++++ $line \n";
	$timeTillAppStarted = $lastClk;
	# We assume that the residence time of each state was printed out right before "APPLICATION HAS STARTED"
	for($i = 0; $i < $maxNode + 1; $i++) {
	    # for each node, add up all the time spent on channel
	    $aConnTimeTillAppStarted[$i] = getTotalConnTime($i);
	    $aTotalConnTimeTillAppStarted += $aConnTimeTillAppStarted[$i];
	}
	$bAppStarted = 1;
    }
    elsif($line =~ /BEGIN COMM/) {
	$phase = 1;
	print "$line";
	goto OutOfLoop;
    }
}

OutOfLoop:


if($dotPrinted == 0) {
    printDot();
    $dotPrinted = 1;
}

endDot();

$totalGoodput = 0;
$n = @aDelays;
if($maxNode > 0) {
    $n = $maxNode + 1;
}
$totalConnDelay = 0;
$numSuccess = 0;

for($i = 0; $i < $n; $i++) {
    if($i == 0) {
	printf "%-8s %-8s %-8s %-8s %-8s\n", "Node", "PktDelay", "ByteRecv", "Goodput", "ConDelay";
    }
    if($aDelays[$i] > 0) {
	$goodput = $aRecvBytes[$i]*8/$aDelays[$i];
    }
    else {
	$goodput = 0;
    }
    $totalGoodput += $goodput;
    if($aPackets[$i] > 0) {
	$avgDelay =  $aDelays[$i]/$aPackets[$i];
    }
    else {
	$avgDelay = 0;
    }
    printf "%-8d %2.2e %-8d %2.2e %2.2e\n", $i, $avgDelay, $aRecvBytes[$i], $goodput, $hNodeConnDelay{"$i"};
    $totalConnDelay += $hNodeConnDelay{"$i"};
    if($hNodeConnDelay{"$i"} > 0) {
	$numSuccess += 1
    }
}

$avg = 0;
if($numSuccess > 0) {
    $avg = ($totalConnDelay / $numSuccess);
}

printf "%-8s %-8s %-8s %-8s %2.2e %-8s %2.2e\n", "Avg", "", "", "", $avg, "StdDev", stdDev(values (%hNodeConnDelay));
if ($n <= 0) {
    printf "WARNING: no successful connections\n";
}
else {
    printf "%-8s %2.2f %-8s %2.2f %-12s %2.2f\n", 
    "SuccRate", ((100 * $numSuccess) / $n), "LastLink", $lastLinkTime, "FromLastNode", $lastLinkTime - $lastStart;
    if($tsfStats) {
	printf "%s\n", $tsfStats;
    }
    else {
	printf "%s\n", $defStats;
    }
}

#exit(0);
@aTotalTime = ();

#print "MAXNODE $maxNode\n";
for($i = 0; $i < $maxNode + 1; $i++) {
    my($nodelife) = 0.0;
    if($i == 0) {
	printf "%-8s %-9s %-9s %-9s %-9s %-9s %-9s %-9s %-9s %-9s %-9s", "Node", "Life", "INQ", "INQ_SC", "INQ_RE", "PGE", "PGE_SC", "PG_MAR", "PG_SLR", "STB", "CONN";
	$j = 0;
	print "\n";
    }

    $nodelife =   $hDuration{$i . "_INQUIRY"} + $hDuration{"$i" . "_INQ_SCAN"} + $hDuration{$i . "_INQ_RESP"} + $hDuration{$i . "_PAGE"} + 
    $hDuration{$i . "_PAGE_SCAN"} + $hDuration{$i . "_MASTER_RESP"} + $hDuration{$i . "_SLAVE_RESP"} + $hDuration{$i . "_STANDBY"};

    $aTotalTime[0] += $hDuration{$i . "_INQUIRY"};
    $aTotalTime[1] += $hDuration{$i . "_INQ_SCAN"};
    $aTotalTime[2] += $hDuration{$i . "_INQ_RESP"};
    $aTotalTime[3] += $hDuration{$i . "_PAGE"};
    $aTotalTime[4] += $hDuration{$i . "_PAGE_SCAN"};
    $aTotalTime[5] += $hDuration{$i . "_MASTER_RESP"};
    $aTotalTime[6] += $hDuration{$i . "_SLAVE_RESP"};
    $aTotalTime[7] += $hDuration{$i . "_STANDBY"};

    $j = 0;
    while($j < $maxNode + 1) {
	if($hDuration{$i . "_CONNECTION_" . $j} > 0) {
	    $nodelife += $hDuration{$i . "_CONNECTION_" . $j};
	    $aTotalTime[8] += $hDuration{$i . "_CONNECTION_" . $j};
	}
	$j++;
    }

    printf "%-4d %9.2e %9.2e %9.2e %9.2e %9.2e %9.2e %9.2e %9.2e %9.2e ", 
    $i, $nodelife, $hDuration{"$i" . "_INQUIRY"}, 
    $hDuration{"$i" . "_INQ_SCAN"},  $hDuration{$i . "_INQ_RESP"}, $hDuration{$i . "_PAGE"}, 
    $hDuration{$i . "_PAGE_SCAN"}, $hDuration{$i . "_MASTER_RESP"},
    $hDuration{$i . "_SLAVE_RESP"}, $hDuration{$i . "_STANDBY"};

    $j = 0;
    while($j < $maxNode + 1) {
	if($hDuration{$i . "_CONNECTION_" . $j} > 0) {
	    printf "(%-2d)%9.2e ", $j, $hDuration{$i . "_CONNECTION_" . $j};
	}
	$j++;
    }

    print "\n";
}

$n = $maxNode + 1;
printf "%-8s %-5s %9.2e %9.2e %9.2e %9.2e %9.2e %9.2e %9.2e %9.2e %9.2e\n", 
    "AVG", "", ($aTotalTime[0] / $n), ($aTotalTime[1] / $n), ($aTotalTime[2] / $n), ($aTotalTime[3] / $n), 
    ($aTotalTime[4] / $n), ($aTotalTime[5] / $n), ($aTotalTime[6] / $n), ($aTotalTime[7] / $n), ($aTotalTime[8] / $n); 

$allDisc = 0;
$allDiscTillFormed = 0;
for($i = 0; $i < 7; $i++) {
    $allDisc += ($aTotalTime[$i] / $n);
    $allDiscTillFormed += ($aTotalTimeTillFormed[$i] / $n);
}

$tillFormedDur = $timeTillFormed * 0.000625;  
$totalDur = $lastClk * 0.000625;

if($tillFormedDur > 0) {
    printf "%-25s %-7.2f %-20s %-7.2f %-20s %-7.2f\n", 
    "Avg disc time(%):", (100*$allDisc/ $totalDur),
    "BefScatFormed ", (100*$allDiscTillFormed/ $tillFormedDur),
    "AftScatFormed ", (100*($allDisc-$allDiscTillFormed)/($totalDur- $tillFormedDur));
}

my $totBusyNodeConnTime = 0;
my $totBusyNodeConnTimeTill = 0;
my $nBusyNodes = 0; 

for($i = 0; $i < $maxNode + 1; $i++) {
    #$aLastState[$i] = $next;
    #$aLastStateClk[$i] = $lastClk;

    if($aBusyNode[$i] == 1) {
	$totBusyNodeConnTime += getTotalConnTime($i); 
	$totBusyNodeConnTimeTill += $aConnTimeTillAppStarted[$i];
	$nBusyNodes++;
    }
}

# get average
if($nBusyNodes > 0) { 
    printf "AvgConnTime total(before, after): All[%d] %.2f(%.2f, %.2f), Busy[%d] %.2f(%.2f, %.2f)\n", 
    $n, $aTotalTime[8] / $n, $aTotalConnTimeTillAppStarted / $n, ($aTotalTime[8]-$aTotalConnTimeTillAppStarted)/$n,
    $nBusyNodes, $totBusyNodeConnTime/$nBusyNodes, $totBusyNodeConnTimeTill/$nBusyNodes, 
    ($totBusyNodeConnTime - $totBusyNodeConnTimeTill) / $nBusyNodes;
}


@aConnDelay = %hLinkConnDelay;
$total = 0;
$nLinks = 0;
$i = 0;
foreach $key (keys (%hLinkConnDelay)) {
    $val = $hLinkConnDelay{$key};
    if($val > 0) {
	$total += $val;
	$nLinks++;
    }
    else {
	#printf "GT %s %f\n", $key, $val;
    }
    $i++;
}

# total is not accurate due to loop which leads to collission in the table
# t3scen100.out
printf "BiNumLinks %d\n", $GTCount;
printf "TotalNumRoots %d\n", $nmerge;
printf "Traffic Stats\n%s", $trafficStats;
printf "Total %-9.2e %-9.2e AvgHops %-9.2e NFlows %-2d\n", 
    $totalThru, ($totalPkts == 0) ? 0 : $totalDelays / $totalPkts, ($nFlows) ? $totalHops / $nFlows : $nFlows, $nFlows; 

$i = 0;
printf "Link Evolution: %d\n", $GTCount;
foreach $key (keys (%hLinkConnClock)) {
    $val = $hLinkConnClock{$key};
    if($val > 0) {
	printf "%-3.2f %-4d\n", $val, $GTCount;
	$i++;
    }
}
if($i != $GTCount) {
    die "Bad link Evolution\n";
}

if($phase != 1) {
    close(TRACE);
    exit();
}


#######################################################################################
# STATS ABOUT COMM and HEAL phase
# reinit 
%hNodeConnDelay = ();

$dotFileName = "h" . $dotFileName;
$dotPrinted = 0;
$psFileName = "h" . $psFileName;

beginDot();
preserveLinksInDotStr();

$numSuccess = 0;
$healtime = 0;
$healstart = 0;
$ncomps = 0;

while($line = <TRACE>) {
    #print "$line";
    if($line =~ /^\((.*)\)/) {
	$lastClk = $1;
	trimSpaces($lastClk);
    }
    
    if($line =~ /_(.*)_.*DETECTED CONNECTIVITY LOST.*:(.*)->(.*)/) {
	$node = $1; $mas = $2; $slv = $3;
	trimSpaces($node); trimSpaces($mas); trimSpaces($slv);
	$hNodeConnDelay{"$node"} = -1 * $lastClk;
	#printf "%2.2e\n", $hNodeConnDelay{"$node"};
	replaceDotStr(" $mas -- $slv\n", "");
    }
    elsif($line =~ /BB START(.*)clock/) {
	# incremental arrival: new node arrived
	$node = $1; 
	trimSpaces($node); 
	$hNodeConnDelay{"$node"} = -1 * $lastClk;
    }
    elsif($line =~ /_(.*)_.*LINK ESTABLISHED(.*)->(.*)DELAY(.*)/) {
	#(5585.28):  + _0_ FIRST LINK ESTABLISHED 0 -> 2 DELAY 3.490798
	#(17425.05):  + _3_ LINK ESTABLISHED 3 -> 7 DELAY 0.437500
	$node = $1; $mas = $2; $slv = $3; $delay = $4; 
	trimSpaces($node); trimSpaces($mas);trimSpaces($slv); trimSpaces($delay);

	#$hLinkConnDelay{$mas . "_" . $slv} = $delay;
	#if($line =~ /FIRST/) {
	if($hNodeConnDelay{"$node"} < 0) {
	    # record the delay for disconnected nodes
	    #printf "%2.2e\n", $lastClk;
	    $hNodeConnDelay{"$node"} = ($lastClk + $hNodeConnDelay{"$node"}) * 0.000625;
	    #printf "$node %f\n",  $hNodeConnDelay{"$node"};
	}

	if($line =~ /MAS/) {
	    writeToDot(" $mas -- $slv\n");
	    #@GT writeToDot(" $mas [peripheries=2];\n");
	}
    }
    elsif($line =~ /\+.*_(.*)_.*ROOT_NODE/) {
	#_%d_ ROOT_NODE
	$mas = $1;

	print DOT "$mas [peripheries=3];\n";
	writeToDot("$mas [peripheries=3];\n");

	# increase the merit of root nodes so that they appear on top of the graph
	for($i = 1000; $i < 1003; $i++) {
	    print DOT "$mas -- $i [style=invis];\n";
	    print DOT "$mas [peripheries=3];\n";
	    print DOT "$i [style=invis];\n";
	}
	$numSuccess++;
    }
    elsif($line =~ /\+.*_(.*)_.*INTERNAL_NODE/) {
	$mas = $1;
	#@GT writeToDot("$mas [peripheries=2];\n");
	$numSuccess++;
    }
    elsif($line =~ /\+.*_(.*)_.*LEAF_NODE/) {
	$numSuccess++;
    }
    elsif($line =~ /BEGIN HEALING.*SUBTREES(.*)/) {
    #(75200.00): _0_ BEGIN HEALING: SUBTREES 2
	$ncomps = $1;
	$healstart = $lastClk;
    }
    elsif($line =~ /END HEALING/) {
    #(81864.28): _4_ END HEALING
	$healtime = ($lastClk - $healstart) * 0.000625;
    }
}

if($healstart != 0 && $healtime == 0) {
    print "HEALING FAILED\n";
}
elsif($healstart != 0) {
    printf "Healing: subtrees %d, time %2.2e\n", $ncomps, $healtime;
}

if($dotPrinted == 0) {
    printDot();
    $dotPrinted = 1;
}

endDot();

#exit(0);


@aConnDelay = %hNodeConnDelay;
$total = 0;

$numSuccess = 0;
print "\n==============\n";

for($i = 0; $i < @aConnDelay - 1; $i = $i + 2) {
    if($i == 0) {
	printf "%-8s %-8s\n", "Node", "ConDelay";
    }

    if($aConnDelay[$i+1] > 0) {
	printf "%-8s %2.2e\n", $aConnDelay[$i], $aConnDelay[$i + 1];
	$total += $aConnDelay[$i + 1];
	$numSuccess++;
    }

    if($i == @aConnDelay - 2 && $numSuccess > 0) {
	printf "%-8s %2.2e %-8s %2.2e\n", "Avg", ($total / $numSuccess), "StdDev", stdDev(values (%hNodeConnDelay));
    }

}

close(TRACE);


sub beginDot() {
    open(DOT, ">$dotFileName") || die "can't open $dotFileName";
    print DOT "graph genome {\n size =\"8,10\"\n";
    #@aDotStr = ();
    #$dotLinkCnt = 0;
}


sub endDot() {
    print DOT "}\n";
    system("dot -Tps $dotFileName -o $psFileName");
    close(DOT);
}


sub writeToDot() {
    my $str =  @_[0];
    $aDotStr[$dotLinkCnt++] = $str;
}


sub preserveLinksInDotStr() {

    my @aNewDotStr; 
    my $newCount = 0;
    for($i = 0; $i < @aDotStr; $i++) {
	if($aDotStr[$i] =~ /--/) {
	    #print "GT  $aDotStr[$i]";
	    $aNewDotStr[$newCount++] = $aDotStr[$i];
	}
    }
    @aDotStr = ();
    for($i = 0; $i < @aNewDotStr; $i++) { 
	$aDotStr[$i] = $aNewDotStr[$i];
	 #print "$i $aDotStr[$i]";
    }
    $dotLinkCnt = $newCount;
}

sub replaceDotStr() {
    my $old = @_[0];
    my $new = @_[1];
    for($i = 0; $i < @aDotStr; $i++) {
	if($aDotStr[$i] =~ /$old/) {
	     #print "replace $old with $new,  $i  $aDotStr[$i]\n";
	    $aDotStr[$i] = $new;
	}
    }
}

sub printDot() {

    if($numSuccess <= $maxNode) {
	for($i = 0; $i <= $maxNode; $i++) {
	    print DOT " $i [peripheries=1];\n";
	}
    }
    for($i = 0; $i < @aDotStr; $i++) {
	print DOT $aDotStr[$i];
    }
}


sub trimSpaces() {
    my $num = @_;
    while($num > 0) {
	$num--;
	$_[$num] =~ s/^\s*([^\s]*)\s*/$1/;
    }

}

sub stdDev() {
    my @list = @_;

    my $sqTotal = 0.0;
    my $total = 0.0;
    my $dev = 0.0;
    my $i = 0;

    for($i = 0; $i < @list; $i++) {
	$sqTotal += $list[$i] * $list[$i];
	$total +=  $list[$i];
    }
    $total = $total * $total;
    if($i <= 0) {
	$dev = 0;
    }
    else {
	$dev = sqrt((($i*$sqTotal) - $total)/($i * ($i - 1)));
    }
    return $dev;
}

sub getTotalConnTime() {
    my $node = @_[0];
    my $total = 0;
    my $j = 0;

    while($j < $maxNode + 1) {
	if($hDuration{$node . "_CONNECTION_" . $j} > 0) {
	    $total += $hDuration{$node . "_CONNECTION_" . $j};
	}
	$j++;
    }
    return $total;
}
