/* -*-	Mode:C++; c-basic-offset:8; tab-width:8; indent-tabs-mode:t -*- */
/*
 * Copyright (c) 2002 Massachusetts Institute of Technology.
 *
 * This software is being provided by the copyright holders under the GNU
 * General Public License, either version 2 or, at your discretion, any later
 * version. (See the file `gpl.txt' in the source distribution.)
 *
 * This software is provided "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
 * EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. The entire risk as
 * to the quality and performance of the program is with you. See the GNU
 * General Public License for more details.
 *
 * The name and trademarks of copyright holders may NOT be used in 
 * advertising or publicity pertaining to the software without specific, 
 * written prior permission. Title to copyright in this software and any 
 * associated documentation will at all times remain with copyright 
 * holders. See the file README-BLUEWARE for more details. 
 * 
 */

#include <debug.h>
#include <util.h>
#include <stdlib.h>
#include <math.h>
#include <packet.h>


extern Packet*
gAllocPkt(int lineno, const char* strfile)
{
	Packet* p = Packet::alloc();
	TRACE(LEVEL_LOW, "(%s) %4d: ALLOCPKT 0x%-8x\n", strfile, lineno, p);
	return p;
}

extern Packet*
gAllocPkt(int size, int lineno, const char* strfile) 
{
	Packet* p = Packet::alloc(size);
	TRACE(LEVEL_LOW, "(%s) %4d: ALLOCPKT 0x%-8x\n", strfile, lineno, p);
	return p;
}

extern Packet*
gCopyPkt(Packet* orig, int lineno, const char* strfile) 
{
	Packet* p = orig->copy();
	TRACE(LEVEL_LOW, "(%s) %4d: ALLOCDUP 0x%-8x\n", strfile, lineno, p);
	return p;
}

extern void
gFreePkt(Packet* p, int lineno, const char* strfile) 
{
	TRACE(LEVEL_LOW, "(%s) %4d: FREEPKT  0x%-8x\n", strfile, lineno, p);
	Packet::free(p);
}
